SystemOrganization addCategory: #'Artefact-Core'!
SystemOrganization addCategory: 'Artefact-Core-Base'!
SystemOrganization addCategory: 'Artefact-Core-CodeSegment'!
SystemOrganization addCategory: 'Artefact-Core-DataTypes'!
SystemOrganization addCategory: 'Artefact-Core-Elements'!
SystemOrganization addCategory: 'Artefact-Core-Elements-Basic'!
SystemOrganization addCategory: 'Artefact-Core-Elements-Composites'!
SystemOrganization addCategory: 'Artefact-Core-Exceptions'!
SystemOrganization addCategory: 'Artefact-Core-Fonts'!
SystemOrganization addCategory: 'Artefact-Core-Formats'!
SystemOrganization addCategory: 'Artefact-Core-Generator'!
SystemOrganization addCategory: 'Artefact-Core-Layouts'!
SystemOrganization addCategory: 'Artefact-Core-Opacity'!

Trait named: #PDFAngleDirected
	uses: {}
	category: 'Artefact-Core-Elements'!

!PDFAngleDirected commentStamp: '<historical>' prior: 0!
A PDFAngleDirected is a trait to allow creation of the element from an angle and a distance.
!

!PDFAngleDirected classSide methodsFor: 'instance creation' stamp: 'OlivierAuverlot 9/27/2013 08:22'!
from: from angle: angle length: aLength
	^ self from: from to: from + ((angle cos * aLength) @ (angle sin * aLength))! !

!JPEGReadWriter methodsFor: '*Artefact-Core-Generator' stamp: 'GuillaumeLarcheveque 3/21/2013 13:36'!
dataPrecision
	^ dataPrecision ! !

!JPEGReadWriter methodsFor: '*Artefact-Core-Generator' stamp: 'GuillaumeLarcheveque 3/21/2013 13:35'!
height
	^ height! !

!JPEGReadWriter methodsFor: '*Artefact-Core-Generator' stamp: 'GuillaumeLarcheveque 3/21/2013 13:35'!
width
	^ width! !

Error subclass: #ArtefactException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Exceptions'!

!ArtefactException commentStamp: '<historical>' prior: 0!
An ArtefactException is the abstract class for any Exception caused by Artefact.

Instance Variables
!

ArtefactException subclass: #ArtefactOverSizedContent
	instanceVariableNames: 'content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Exceptions'!

!ArtefactOverSizedContent commentStamp: '<historical>' prior: 0!
An ArtefactOverSizedContent indicate a content too large for its container.

Instance Variables
	content:		<Object>

content
	- xxxxx
!

!ArtefactOverSizedContent methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/8/2013 17:25'!
content
	^ content! !

!ArtefactOverSizedContent methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/8/2013 17:25'!
content: anObject
	content := anObject! !

!ArtefactOverSizedContent methodsFor: 'printing' stamp: 'GuillaumeLarcheveque 3/8/2013 17:46'!
printOn: aStream
	super printOn: aStream.
	aStream space.
	self content printOn: aStream! !

ArtefactException subclass: #ArtefactUndefinedAttribute
	instanceVariableNames: 'element attribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Exceptions'!

!ArtefactUndefinedAttribute commentStamp: '<historical>' prior: 0!
An ArtefactUndefinedAttribute is the exception send when a non optional field is not filled.

Instance Variables
	attribute:		<Object>
	element:		<Object>

attribute
	- xxxxx

element
	- xxxxx
!

!ArtefactUndefinedAttribute class methodsFor: 'signaling' stamp: 'GuillaumeLarcheveque 5/24/2013 18:36'!
signalMissingAttribute: anAttribute for: aPDFElement
	self new
		attribute: anAttribute;
		element: aPDFElement;
		signal! !

!ArtefactUndefinedAttribute methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/24/2013 18:34'!
attribute
	^ attribute! !

!ArtefactUndefinedAttribute methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/24/2013 18:34'!
attribute: anObject
	attribute := anObject! !

!ArtefactUndefinedAttribute methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/24/2013 18:34'!
element
	^ element! !

!ArtefactUndefinedAttribute methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/24/2013 18:34'!
element: anObject
	element := anObject! !

!ArtefactUndefinedAttribute methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/24/2013 19:17'!
messageText
	^ String
		streamContents: [ :aStream | 
			self element printOn: aStream.
			aStream nextPutAll: ' -> '.
			self attribute printOn: aStream ]! !

!ArtefactUndefinedAttribute methodsFor: 'printing' stamp: 'GuillaumeLarcheveque 5/24/2013 18:56'!
printOn: aStream
	super printOn: aStream.
	aStream space.
	self element printOn: aStream.
	aStream nextPutAll: ' -> '.
	self attribute printOn: aStream.! !

!StyleSheet class methodsFor: '*Artefact-Core' stamp: 'OlivierAuverlot 1/17/2014 12:45'!
default
	| default |
	default:= self new 
		at: #textColor put: (PDFColor r: 0 g: 0 b: 0); 
		at: #fillColor put: (PDFColor r: 255 g: 255 b: 255); 
		at: #filled put: true;
		at: #drawColor put: (PDFColor r: 0 g: 0 b: 0);
		at: #thickness put: 1 pt;
		at: #dotted put: nil;
		at: #margin put: 0 pt;
		at: #roundCap put: false;
		at: #font put: PDFHelveticaFont new;
		at: #rotation put: 0;
		at: #alignment put: PDFAlignment left middle;
		at: #opacity put: (PDFOpacityNormal alpha: 1);
		yourself.
	default > #caption at: #fillColor put: (PDFColor new setGreyLevel: 192).
	default > #datatable at: #alignment put: PDFAlignment center middle.
	default > #cell at: #margin put: 1 pt.
	default > #cell at: #alignment put: PDFAlignment center middle.
	^ default! !

!StyleSheet methodsFor: '*Artefact-Core' stamp: 'GuillaumeLarcheveque 5/17/2013 14:19'!
alignment
	^ self get: #alignment! !

!StyleSheet methodsFor: '*Artefact-Core' stamp: 'GuillaumeLarcheveque 5/17/2013 14:20'!
alignment: aPDFAlignment
	self at: #alignment put: aPDFAlignment ! !

!StyleSheet methodsFor: '*Artefact-Core' stamp: 'GuillaumeLarcheveque 4/26/2013 15:37'!
dotted: aPDFDotted
	self at: #dotted put: aPDFDotted ! !

!StyleSheet methodsFor: '*Artefact-Core' stamp: 'GuillaumeLarcheveque 4/26/2013 15:37'!
drawColor: aPDFColor
	self at: #drawColor put: aPDFColor ! !

!StyleSheet methodsFor: '*Artefact-Core' stamp: 'GuillaumeLarcheveque 4/26/2013 15:37'!
fillColor: aPDFColor
	self at: #fillColor put: aPDFColor ! !

!StyleSheet methodsFor: '*Artefact-Core' stamp: 'GuillaumeLarcheveque 5/17/2013 10:46'!
filled
	^ self get: #filled! !

!StyleSheet methodsFor: '*Artefact-Core' stamp: 'GuillaumeLarcheveque 5/17/2013 10:47'!
filled: aBoolean
	self at: #filled put: aBoolean ! !

!StyleSheet methodsFor: '*Artefact-Core' stamp: 'GuillaumeLarcheveque 3/1/2013 13:34'!
font
	^ self get: #font! !

!StyleSheet methodsFor: '*Artefact-Core' stamp: 'GuillaumeLarcheveque 4/26/2013 15:37'!
font: aFont
	self at: #font put: aFont ! !

!StyleSheet methodsFor: '*Artefact-Core' stamp: 'GuillaumeLarcheveque 5/17/2013 14:08'!
margin
	^ self get: #margin! !

!StyleSheet methodsFor: '*Artefact-Core' stamp: 'GuillaumeLarcheveque 5/17/2013 14:08'!
margin: aMargin
	self at: #margin put: aMargin ! !

!StyleSheet methodsFor: '*Artefact-Core' stamp: 'OlivierAuverlot 1/17/2014 15:08'!
opacity
	^ self get: #opacity! !

!StyleSheet methodsFor: '*Artefact-Core' stamp: 'OlivierAuverlot 1/18/2014 18:55'!
opacity: aOpacity
	self at: #opacity put: aOpacity! !

!StyleSheet methodsFor: '*Artefact-Core' stamp: 'GuillaumeLarcheveque 4/26/2013 15:37'!
rotation: anAngle
	self at: #rotation put: anAngle! !

!StyleSheet methodsFor: '*Artefact-Core' stamp: 'GuillaumeLarcheveque 4/26/2013 15:37'!
roundCap: aBoolean
	self at: #roundCap put: aBoolean ! !

!StyleSheet methodsFor: '*Artefact-Core' stamp: 'GuillaumeLarcheveque 4/26/2013 15:37'!
textColor: aColor
	self at: #textColor put: aColor ! !

!StyleSheet methodsFor: '*Artefact-Core' stamp: 'GuillaumeLarcheveque 4/26/2013 15:37'!
thickness: aThickness
	self at: #thickness put: aThickness ! !

!UnitValue methodsFor: '*Artefact-Core' stamp: 'GuillaumeLarcheveque 5/24/2013 14:04'!
abs
	^ self value < 0
		ifTrue: [ self negated ]
		ifFalse: [ self ]! !

Object subclass: #PDFAlignment
	instanceVariableNames: 'horizontal vertical'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Base'!

!PDFAlignment commentStamp: '<historical>' prior: 0!
A PDFAlignment represents an alignment (horizontal and vertical).

Instance Variables
	horizontal:		<Object>
	vertical:		<Object>

horizontal
	- xxxxx

vertical
	- xxxxx
!

!PDFAlignment class methodsFor: 'position' stamp: 'GuillaumeLarcheveque 5/17/2013 13:21'!
bottom
	^ self new bottom! !

!PDFAlignment class methodsFor: 'position' stamp: 'GuillaumeLarcheveque 5/17/2013 13:21'!
center
	^ self new center! !

!PDFAlignment class methodsFor: 'position' stamp: 'GuillaumeLarcheveque 5/17/2013 13:21'!
left
	^ self new left! !

!PDFAlignment class methodsFor: 'position' stamp: 'GuillaumeLarcheveque 5/17/2013 13:21'!
middle
	^ self new middle! !

!PDFAlignment class methodsFor: 'position' stamp: 'GuillaumeLarcheveque 5/17/2013 13:21'!
right
	^ self new right! !

!PDFAlignment class methodsFor: 'position' stamp: 'GuillaumeLarcheveque 5/17/2013 13:21'!
top
	^ self new top! !

!PDFAlignment methodsFor: 'position' stamp: 'GuillaumeLarcheveque 5/17/2013 13:15'!
bottom
	self vertical: #BOTTOM! !

!PDFAlignment methodsFor: 'position' stamp: 'GuillaumeLarcheveque 5/17/2013 13:15'!
center
	self horizontal: #CENTER! !

!PDFAlignment methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/17/2013 13:14'!
horizontal
	^ horizontal! !

!PDFAlignment methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/17/2013 13:14'!
horizontal: anObject
	horizontal := anObject! !

!PDFAlignment methodsFor: 'initialize-release' stamp: 'GuillaumeLarcheveque 5/17/2013 13:17'!
initialize
	self left;
	 middle.! !

!PDFAlignment methodsFor: 'checking' stamp: 'GuillaumeLarcheveque 5/17/2013 13:46'!
isBottom
	^ self vertical = #BOTTOM! !

!PDFAlignment methodsFor: 'checking' stamp: 'GuillaumeLarcheveque 5/17/2013 13:33'!
isCenter
	^ self horizontal = #CENTER! !

!PDFAlignment methodsFor: 'checking' stamp: 'GuillaumeLarcheveque 5/17/2013 13:33'!
isLeft
	^ self horizontal = #LEFT! !

!PDFAlignment methodsFor: 'checking' stamp: 'GuillaumeLarcheveque 5/17/2013 13:45'!
isMiddle
	^ self vertical = #MIDDLE! !

!PDFAlignment methodsFor: 'checking' stamp: 'GuillaumeLarcheveque 5/17/2013 13:33'!
isRight
	^ self horizontal = #RIGHT! !

!PDFAlignment methodsFor: 'checking' stamp: 'GuillaumeLarcheveque 5/17/2013 13:33'!
isTop
	^ self vertical = #TOP! !

!PDFAlignment methodsFor: 'position' stamp: 'GuillaumeLarcheveque 5/17/2013 13:15'!
left
	self horizontal:  #LEFT! !

!PDFAlignment methodsFor: 'position' stamp: 'GuillaumeLarcheveque 5/17/2013 13:16'!
middle
	self vertical: #MIDDLE! !

!PDFAlignment methodsFor: 'position' stamp: 'GuillaumeLarcheveque 5/17/2013 13:16'!
right
	self horizontal: #RIGHT! !

!PDFAlignment methodsFor: 'position' stamp: 'GuillaumeLarcheveque 5/17/2013 13:16'!
top
	self vertical: #TOP! !

!PDFAlignment methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/17/2013 13:14'!
vertical
	^ vertical! !

!PDFAlignment methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/17/2013 13:14'!
vertical: anObject
	vertical := anObject! !

Object subclass: #PDFByteCode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-CodeSegment'!

!PDFByteCode commentStamp: '<historical>' prior: 0!
A PDFByteCode is the list of codes used in PDF.

Instance Variables
!

!PDFByteCode class methodsFor: 'text' stamp: 'OlivierAuverlot 11/16/2012 10:08'!
beginText
	^'BT'! !

!PDFByteCode class methodsFor: 'text' stamp: 'guillaumelarcheveque 11/30/2012 14:22'!
continuousPagesDisplayMode
	^ '/OneColumn '! !

!PDFByteCode class methodsFor: 'draw' stamp: 'OlivierAuverlot 11/16/2012 09:34'!
curve
	^'c'! !

!PDFByteCode class methodsFor: 'style' stamp: 'OlivierAuverlot 11/16/2012 14:59'!
dotted
	^'d'! !

!PDFByteCode class methodsFor: 'style' stamp: 'OlivierAuverlot 11/16/2012 15:04'!
drawWithColor
	^'RG'! !

!PDFByteCode class methodsFor: 'style' stamp: 'OlivierAuverlot 11/16/2012 15:11'!
drawWithGreyLevel
	^'G'! !

!PDFByteCode class methodsFor: 'text' stamp: 'OlivierAuverlot 11/16/2012 10:08'!
endOfText
	^'ET'! !

!PDFByteCode class methodsFor: 'style' stamp: 'OlivierAuverlot 11/16/2012 15:12'!
fillWithColor
	^'rg'! !

!PDFByteCode class methodsFor: 'style' stamp: 'OlivierAuverlot 11/16/2012 15:04'!
fillWithGreyLevel
	^'g'! !

!PDFByteCode class methodsFor: 'draw' stamp: 'OlivierAuverlot 11/9/2012 15:38'!
filling
	^'B'! !

!PDFByteCode class methodsFor: 'draw' stamp: 'OlivierAuverlot 11/16/2012 09:33'!
line
	^'l'! !

!PDFByteCode class methodsFor: 'style' stamp: 'OlivierAuverlot 4/10/2013 21:46'!
lineRoundCapStyle
	^'1 J'! !

!PDFByteCode class methodsFor: 'style' stamp: 'OlivierAuverlot 4/10/2013 21:47'!
lineSquareCapStyle
	^'2 J'! !

!PDFByteCode class methodsFor: 'draw' stamp: 'OlivierAuverlot 11/16/2012 09:09'!
moveTo
	^'m'! !

!PDFByteCode class methodsFor: 'draw' stamp: 'OlivierAuverlot 11/9/2012 15:39'!
noFilling
	^'S'! !

!PDFByteCode class methodsFor: 'style' stamp: 'guillaumelarcheveque 11/30/2012 13:16'!
openAction
	^'/OpenAction'! !

!PDFByteCode class methodsFor: 'text' stamp: 'guillaumelarcheveque 11/30/2012 14:15'!
pageLayout
	^ '/PageLayout'! !

!PDFByteCode class methodsFor: 'draw' stamp: 'OlivierAuverlot 11/16/2012 10:22'!
rectangle
	^'re'! !

!PDFByteCode class methodsFor: 'text' stamp: 'OlivierAuverlot 5/19/2014 11:13'!
restoreGraphicsState
	^ 'Q'! !

!PDFByteCode class methodsFor: 'style' stamp: 'OlivierAuverlot 1/17/2014 15:45'!
setOpacity
	^'gs'! !

!PDFByteCode class methodsFor: 'text' stamp: 'OlivierAuverlot 11/16/2012 10:13'!
setTextPosition
	^'Td'! !

!PDFByteCode class methodsFor: 'text' stamp: 'OlivierAuverlot 11/16/2012 10:14'!
showTextString
	^'Tj'! !

!PDFByteCode class methodsFor: 'text' stamp: 'guillaumelarcheveque 11/30/2012 14:21'!
singlePageDisplayMode
	^ '/SinglePage '! !

!PDFByteCode class methodsFor: 'style' stamp: 'OlivierAuverlot 11/16/2012 14:47'!
thickness
	^'w'! !

!PDFByteCode class methodsFor: 'text' stamp: 'guillaumelarcheveque 11/30/2012 14:22'!
twoPagesDisplayMode
	^ '/TwoColumnLeft '! !

Object subclass: #PDFCodeSegment
	instanceVariableNames: 'styleSheet isDrawElement fromElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-CodeSegment'!

!PDFCodeSegment commentStamp: '<historical>' prior: 0!
A PDFCodeSegment is the intermediate representation of a PDFElement resulting from the generation with PDFGenerator. It contains a styleSheet that the PDFStreamPrinter must convert in pdf.

Instance Variables
	isDrawElement:		<Object>
	styleSheet:		<Object>

isDrawElement
	- xxxxx

styleSheet
	- xxxxx
!

!PDFCodeSegment methodsFor: 'accessing' stamp: 'OlivierAuverlot 4/2/2013 15:14'!
fromElement
	^ fromElement! !

!PDFCodeSegment methodsFor: 'accessing' stamp: 'OlivierAuverlot 4/2/2013 15:14'!
fromElement: anPDFElement
	fromElement := anPDFElement! !

!PDFCodeSegment methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 2/22/2013 12:59'!
isDrawElement
	^ isDrawElement! !

!PDFCodeSegment methodsFor: 'accessing' stamp: 'guillaumelarcheveque 2/1/2013 14:57'!
isDrawElement: anObject
	isDrawElement := anObject! !

!PDFCodeSegment methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 2/22/2013 12:56'!
isSecure
	^ true! !

!PDFCodeSegment methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/1/2013 14:47'!
printWith: aPDFWriter 
	^ self subclassResponsibility ! !

!PDFCodeSegment methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 2/22/2013 12:56'!
styleSheet
	^ styleSheet! !

!PDFCodeSegment methodsFor: 'accessing' stamp: 'guillaumelarcheveque 2/1/2013 14:57'!
styleSheet: anObject
	styleSheet := anObject! !

PDFCodeSegment subclass: #PDFCompositeCodeSegment
	instanceVariableNames: 'segments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-CodeSegment'!

!PDFCompositeCodeSegment commentStamp: '<historical>' prior: 0!
A PDFCompositeCodeSegment is a composition of PDFCodeSegment, result of the generation of a PDFCompositeElement.

Instance Variables
	segments:		<Object>

segments
	- xxxxx
!

!PDFCompositeCodeSegment class methodsFor: 'as yet unclassified' stamp: 'GuillaumeLarcheveque 2/22/2013 13:19'!
from: aCollectionOfSegments styleSheet: aStylesheet
	^ self new segments: aCollectionOfSegments; styleSheet: aStylesheet; yourself! !

!PDFCompositeCodeSegment methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/1/2013 14:47'!
printWith: aPDFWriter 
	aPDFWriter printCompositeCodeSegment: self! !

!PDFCompositeCodeSegment methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 2/22/2013 12:59'!
segments
	^ segments! !

!PDFCompositeCodeSegment methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 2/22/2013 12:59'!
segments: anObject
	segments := anObject! !

PDFCodeSegment subclass: #PDFElementCodeSegment
	instanceVariableNames: 'format code fontId opacityId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-CodeSegment'!

!PDFElementCodeSegment commentStamp: '<historical>' prior: 0!
A PDFElementCodeSegment is the result of the generation of a PDFBasicElement. It contains a code that can be directly printed in the stream by the PDFStreamPrinter.

Instance Variables
	code:		<Object>
	fontId:		<Object>

code
	- xxxxx

fontId
	- xxxxx
!

!PDFElementCodeSegment class methodsFor: 'initialize-release' stamp: 'OlivierAuverlot 5/19/2014 10:02'!
code: aCode styleSheet: aStyleSheet format: aFormat isDrawElement: aBoolean fontId: aFontId opacityId: aOpacityId fromElement: aElement
	^ self new
		format: aFormat;
		code: aCode;
		styleSheet: aStyleSheet;
		isDrawElement: aBoolean;
		fontId: aFontId;
		opacityId: aOpacityId;
		fromElement: aElement;
		yourself! !

!PDFElementCodeSegment methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 2/22/2013 12:58'!
code
	^ code! !

!PDFElementCodeSegment methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 2/22/2013 12:57'!
code: anObject
	code := anObject! !

!PDFElementCodeSegment methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/1/2013 14:21'!
fontId
	^ fontId! !

!PDFElementCodeSegment methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/1/2013 14:21'!
fontId: anObject
	fontId := anObject! !

!PDFElementCodeSegment methodsFor: 'accessing' stamp: 'OlivierAuverlot 5/19/2014 10:04'!
format
	^ format! !

!PDFElementCodeSegment methodsFor: 'accessing' stamp: 'OlivierAuverlot 5/19/2014 10:04'!
format: anObject
	format := anObject! !

!PDFElementCodeSegment methodsFor: 'accessing' stamp: 'OlivierAuverlot 1/17/2014 15:03'!
opacityId
	^ opacityId! !

!PDFElementCodeSegment methodsFor: 'accessing' stamp: 'OlivierAuverlot 1/17/2014 15:03'!
opacityId: anObject
	opacityId := anObject! !

!PDFElementCodeSegment methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/1/2013 14:47'!
printWith: aPDFWriter 
	aPDFWriter printElementCodeSegment: self! !

PDFElementCodeSegment subclass: #PDFUnsecureElementCodeSegment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-CodeSegment'!

!PDFUnsecureElementCodeSegment commentStamp: '<historical>' prior: 0!
A PDFUnsecureElementCodeSegment is a code segment produced from a PDFUnsecureBasicElement. It will be considered as dangerous for the final result and have a special treatment to not alter other code segments.

Instance Variables
!

!PDFUnsecureElementCodeSegment methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 11/23/2012 13:35'!
isSecure
	^ false! !

Object subclass: #PDFColor
	instanceVariableNames: 'red green blue greyLevel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Base'!

!PDFColor commentStamp: '<historical>' prior: 0!
A PDFColor represent a color or a grey level in PDF.

Instance Variables
	blue:		<Object>
	green:		<Object>
	greyLevel:		<Object>
	red:		<Object>

blue
	- xxxxx

green
	- xxxxx

greyLevel
	- xxxxx

red
	- xxxxx
!

!PDFColor class methodsFor: 'as yet unclassified' stamp: 'OlivierAuverlot 3/9/2012 15:16'!
formatRGB: aColor
	"Answer a formated RBG color. The values are rounded"
	
	^(PDFColor round: aColor red) ,  ' ' , (PDFColor round: aColor green) , ' ' , (PDFColor round: aColor blue)! !

!PDFColor class methodsFor: 'as yet unclassified' stamp: 'GuillaumeLarcheveque 9/20/2013 14:49'!
greyLevel: aGreyLevel
	^ self new setGreyLevel: aGreyLevel ! !

!PDFColor class methodsFor: 'as yet unclassified' stamp: 'GuillaumeLarcheveque 5/17/2013 11:22'!
r:  r g: g b: b
	^ self new r:  r g: g b: b! !

!PDFColor class methodsFor: 'as yet unclassified' stamp: 'OlivierAuverlot 3/14/2012 12:23'!
round: aValue
	"answer a rounded value for an color value"
	
	^((aValue / 255) roundDownTo: 0.001) asString ! !

!PDFColor methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/8/2013 10:23'!
= anotherPDFColor
	^ #(#blue #red #green #greyLevel)
		allSatisfy: [ :selector | (self perform: selector) = (anotherPDFColor perform: selector) ]! !

!PDFColor methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/25/2012 11:58'!
blue
	^ blue! !

!PDFColor methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/25/2012 11:58'!
blue: anObject
	blue := anObject! !

!PDFColor methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/25/2012 11:58'!
green
	^ green! !

!PDFColor methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/25/2012 11:58'!
green: anObject
	green := anObject! !

!PDFColor methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/25/2012 13:35'!
greyLevel
	^ greyLevel! !

!PDFColor methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/25/2012 13:35'!
greyLevel: anObject
	greyLevel := anObject! !

!PDFColor methodsFor: 'action' stamp: 'OlivierAuverlot 2/25/2012 16:12'!
isEmpty
	"Answer true if the color is undefined"
	^(self red isNil and: [ self greyLevel isNil ])! !

!PDFColor methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/8/2013 10:26'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: self value! !

!PDFColor methodsFor: 'action' stamp: 'GuillaumeLarcheveque 5/17/2013 11:20'!
r:  r g: g b: b
	self red: r.
	self green: g.
	self blue: b.
	
	self greyLevel: nil.
! !

!PDFColor methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/25/2012 11:58'!
red
	^ red! !

!PDFColor methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/25/2012 11:58'!
red: anObject
	red := anObject! !

!PDFColor methodsFor: 'action' stamp: 'OlivierAuverlot 3/2/2012 15:00'!
setGreyLevel: aGreyLevel
	self greyLevel: aGreyLevel.
	
	self red: nil.
	self green: nil.
	self blue: nil.! !

!PDFColor methodsFor: 'tools' stamp: 'GuillaumeLarcheveque 3/15/2013 13:28'!
value
	"answer the value of the color (a RGB tuple or a grey level)"
	
	(self isEmpty)
		ifTrue: [ ^nil ] 
		ifFalse: [
			(self red isNil) 
				ifTrue: [ ^ self greyLevel asString ]
				ifFalse: [ ^ (self red asString) , '.' , (self green asString) , '.' , (self blue asString) ]
		]
! !

Object subclass: #PDFDataType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-DataTypes'!

!PDFDataType commentStamp: '<historical>' prior: 0!
A PDFDataType is the superclass for all pdf types.

All these types are generated by PDFGenerator and then printed by PDFStreamPrinter.

NOT USEFULL FOR USERS

Instance Variables
!

PDFDataType subclass: #PDFDataArray
	instanceVariableNames: 'elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-DataTypes'!

!PDFDataArray commentStamp: '<historical>' prior: 0!
A PDFDataArray is the representation for arrays in PDF.

Instance Variables
	elements:		<Object>

elements
	- xxxxx
!

!PDFDataArray class methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 1/11/2013 11:47'!
from: aCollection
	
	| dataArray |
	dataArray := self new.
	aCollection do: [:anElement | dataArray addElement: anElement ].
	^ dataArray! !

!PDFDataArray methodsFor: 'visit' stamp: 'guillaumelarcheveque 2/15/2013 14:44'!
acceptVisitor: aVisitor
	^ aVisitor visitPDFDataArray: self! !

!PDFDataArray methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/14/2012 13:50'!
addElement: anElement
	elements addLast: anElement ! !

!PDFDataArray methodsFor: 'accessing' stamp: 'guillaumelarcheveque 1/11/2013 11:49'!
elements
	^ elements! !

!PDFDataArray methodsFor: 'accessing' stamp: 'guillaumelarcheveque 1/11/2013 11:49'!
elements: anObject
	elements := anObject! !

!PDFDataArray methodsFor: 'initialize-release' stamp: 'guillaumelarcheveque 12/14/2012 14:19'!
initialize 
	elements := OrderedCollection new! !

!PDFDataArray methodsFor: 'testing' stamp: 'guillaumelarcheveque 2/15/2013 15:45'!
isPrintable
	"Because it will never contain an unprintable dataType"
	^ true! !

!PDFDataArray methodsFor: 'printing' stamp: 'guillaumelarcheveque 12/14/2012 13:52'!
printOn: aStream
	aStream nextPut: $[; space.
	elements do: [:anElement | anElement printOn: aStream. aStream space].
	aStream nextPut: $]! !

PDFDataType subclass: #PDFDataAssociativeArray
	instanceVariableNames: 'associativeArray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-DataTypes'!

!PDFDataAssociativeArray commentStamp: '<historical>' prior: 0!
A PDFDataAssociativeArray is the representation for associative arrays in PDF.

Instance Variables
	associativeArray:		<Object>

associativeArray
	- xxxxx
!

!PDFDataAssociativeArray methodsFor: 'visit' stamp: 'guillaumelarcheveque 2/15/2013 14:44'!
acceptVisitor: aVisitor
	^ aVisitor visitPDFDataAssociativeArray: self! !

!PDFDataAssociativeArray methodsFor: 'accessing' stamp: 'guillaumelarcheveque 1/11/2013 11:26'!
add: aPDFDataCouple
	associativeArray add: aPDFDataCouple! !

!PDFDataAssociativeArray methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/14/2012 13:44'!
associativeArray
	^ associativeArray! !

!PDFDataAssociativeArray methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/14/2012 13:44'!
associativeArray: anObject
	associativeArray := anObject! !

!PDFDataAssociativeArray methodsFor: 'initialize-release' stamp: 'guillaumelarcheveque 1/11/2013 11:27'!
initialize 
	associativeArray := OrderedCollection new! !

!PDFDataAssociativeArray methodsFor: 'testing' stamp: 'GuillaumeLarcheveque 3/21/2013 15:11'!
isPrintable
	^ self associativeArray allSatisfy: [ :anElement | anElement isPrintable ]! !

!PDFDataAssociativeArray methodsFor: 'printing' stamp: 'OlivierAuverlot 3/29/2013 15:13'!
printOn: aStream
	aStream nextPutAll: '<<'; lf.
	associativeArray do: 
		[:aCouple | 
			aCouple printOn: aStream. 
			aStream lf ].
	aStream nextPutAll: '>>'! !

!PDFDataAssociativeArray methodsFor: 'printing' stamp: 'GuillaumeLarcheveque 3/21/2013 14:45'!
printWith: aPDFPrinter
	aPDFPrinter printPDFDataAssociativeArray: self! !

PDFDataType subclass: #PDFDataComment
	instanceVariableNames: 'comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-DataTypes'!

!PDFDataComment commentStamp: '<historical>' prior: 0!
a PDFDataComment is the representation for comments in PDF.!

!PDFDataComment class methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 1/11/2013 10:13'!
text: aTextComment
	^ self new comment: aTextComment! !

!PDFDataComment methodsFor: 'visit' stamp: 'guillaumelarcheveque 2/15/2013 14:44'!
acceptVisitor: aVisitor
	^ aVisitor visitPDFDataComment: self! !

!PDFDataComment methodsFor: 'accessing' stamp: 'guillaumelarcheveque 1/11/2013 10:09'!
comment
	^ comment! !

!PDFDataComment methodsFor: 'accessing' stamp: 'guillaumelarcheveque 1/11/2013 10:09'!
comment: anObject
	comment := anObject! !

!PDFDataComment methodsFor: 'printing' stamp: 'guillaumelarcheveque 2/15/2013 15:36'!
isPrintable
	^ true! !

!PDFDataComment methodsFor: 'printing' stamp: 'guillaumelarcheveque 1/11/2013 10:09'!
printOn: aStream
	aStream nextPut: $%; nextPutAll: comment asString! !

PDFDataType subclass: #PDFDataCouple
	instanceVariableNames: 'key value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-DataTypes'!

!PDFDataCouple commentStamp: '<historical>' prior: 0!
A PDFDataCouple is the representation for couples in PDF.

Instance Variables
	key:		<Object>
	value:		<Object>

key
	- xxxxx

value
	- xxxxx
!

!PDFDataCouple class methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 1/11/2013 11:30'!
key: aKey value: aValue
	^ self new key: aKey; value: aValue; yourself! !

!PDFDataCouple methodsFor: 'visit' stamp: 'guillaumelarcheveque 2/15/2013 14:44'!
acceptVisitor: aVisitor
	^ aVisitor visitPDFDataCouple: self! !

!PDFDataCouple methodsFor: 'testing' stamp: 'GuillaumeLarcheveque 3/21/2013 15:11'!
isPrintable
	"Because it will never contain an unprintable dataType"
	^ key isPrintable and: [ value isPrintable ]! !

!PDFDataCouple methodsFor: 'accessing' stamp: 'guillaumelarcheveque 1/11/2013 11:31'!
key
	^ key! !

!PDFDataCouple methodsFor: 'accessing' stamp: 'guillaumelarcheveque 1/11/2013 11:31'!
key: anObject
	key := anObject! !

!PDFDataCouple methodsFor: 'printing' stamp: 'OlivierAuverlot 3/29/2013 15:14'!
printOn: aStream
	key printOn: aStream. 
	aStream space. 
	value printOn: aStream.! !

!PDFDataCouple methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/21/2013 15:12'!
printWith: aPDFPrinter
	aPDFPrinter printPDFDataCouple: self! !

!PDFDataCouple methodsFor: 'accessing' stamp: 'guillaumelarcheveque 1/11/2013 11:31'!
value
	^ value! !

!PDFDataCouple methodsFor: 'accessing' stamp: 'guillaumelarcheveque 1/11/2013 11:31'!
value: anObject
	value := anObject! !

PDFDataType subclass: #PDFDataDateAndTime
	instanceVariableNames: 'date time'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-DataTypes'!

!PDFDataDateAndTime commentStamp: '<historical>' prior: 0!
A PDFDataDateAndTime is the representation for datetimes in PDF.

Instance Variables
	date:		<Object>
	time:		<Object>

date
	- xxxxx

time
	- xxxxx
!

!PDFDataDateAndTime class methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 2/15/2013 13:37'!
date: aDate time: aTime
	^ self new date: aDate; time: aTime; yourself! !

!PDFDataDateAndTime methodsFor: 'visit' stamp: 'guillaumelarcheveque 2/15/2013 14:44'!
acceptVisitor: aVisitor
	^ aVisitor visitPDFDataDateAndTime: self! !

!PDFDataDateAndTime methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/7/2013 21:12'!
date
	^ date! !

!PDFDataDateAndTime methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/7/2013 21:12'!
date: anObject
	date := anObject! !

!PDFDataDateAndTime methodsFor: 'as yet unclassified' stamp: 'AntoanHristov 2/17/2017 15:48'!
dateToday
^ Date today.! !

!PDFDataDateAndTime methodsFor: 'private' stamp: 'AntoanHristov 2/17/2017 15:00'!
formatDate: aDate time: aTime
	"Answer a correct date and time for a PDF document : yyyymmddhhmmss"
	
	| str timeStr hour minutes seconds |

	hour := aTime hours.
	str := hour asString.
	(hour < 10) ifTrue: [ str := '0' , str ].
	timeStr := str.
	
 	minutes := aTime minutes.
	str := minutes asString.
	(minutes < 10) ifTrue: [ str := '0' , str ].
	timeStr := timeStr , str.
	
	seconds := aTime seconds.
	str := seconds asString.
	(seconds < 10) ifTrue: [ str := '0' , str ].
	timeStr := timeStr , str.
	
	^((aDate yyyymmdd copyWithRegex: '-' matchesReplacedWith: '') , timeStr)! !

!PDFDataDateAndTime methodsFor: 'initialize - release' stamp: 'AntoanHristov 2/17/2017 16:14'!
initialize
date:= self dateToday.
time:= self timeToday ! !

!PDFDataDateAndTime methodsFor: 'testing' stamp: 'guillaumelarcheveque 2/15/2013 15:37'!
isPrintable
	^ true! !

!PDFDataDateAndTime methodsFor: 'printing' stamp: 'OlivierAuverlot 2/7/2013 21:15'!
printOn: aStream
	aStream nextPutAll: '(D:'; nextPutAll: (self formatDate: (self date) time: (self time)); nextPut: $)! !

!PDFDataDateAndTime methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/7/2013 21:12'!
time
	^ time! !

!PDFDataDateAndTime methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/7/2013 21:12'!
time: anObject
	time := anObject! !

!PDFDataDateAndTime methodsFor: 'as yet unclassified' stamp: 'AntoanHristov 2/17/2017 15:48'!
timeToday
^ Time now.! !

PDFDataType subclass: #PDFDataObject
	instanceVariableNames: 'id revision contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-DataTypes'!

!PDFDataObject commentStamp: '<historical>' prior: 0!
A PDFDataObject is the representation for objects in PDF.

Instance Variables
	contents:		<Object>
	id:		<Object>
	revision:		<Object>

contents
	- xxxxx

id
	- xxxxx

revision
	- xxxxx
!

!PDFDataObject methodsFor: 'visit' stamp: 'guillaumelarcheveque 2/15/2013 14:44'!
acceptVisitor: aVisitor
	^ aVisitor visitPDFDataObject: self! !

!PDFDataObject methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/14/2012 13:17'!
addContent: aContent
	contents addLast: aContent! !

!PDFDataObject methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/14/2012 13:37'!
contents
	^ contents! !

!PDFDataObject methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/14/2012 13:37'!
contents: anObject
	contents := anObject! !

!PDFDataObject methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/14/2012 13:37'!
id
	^ id! !

!PDFDataObject methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/14/2012 13:37'!
id: anObject
	id := anObject! !

!PDFDataObject methodsFor: 'initialize-release' stamp: 'guillaumelarcheveque 12/14/2012 13:16'!
initialize 
	contents := OrderedCollection new! !

!PDFDataObject methodsFor: 'accessing' stamp: 'OlivierAuverlot 3/29/2013 15:14'!
printOn: aStream
	aStream nextPutAll: id asString; space; nextPutAll: revision asString; space; nextPutAll: 'obj'; lf.
	contents do: [:aContent | aContent printOn: aStream. aStream lf].
	aStream nextPutAll: 'endobj'! !

!PDFDataObject methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/14/2012 13:37'!
revision
	^ revision! !

!PDFDataObject methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/14/2012 13:37'!
revision: anObject
	revision := anObject! !

PDFDataType subclass: #PDFDataReference
	instanceVariableNames: 'referencedObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-DataTypes'!

!PDFDataReference commentStamp: '<historical>' prior: 0!
A PDFDataReference is the representation for references to objects in PDF.

Instance Variables
	referencedObject:		<Object>

referencedObject
	- xxxxx
!

!PDFDataReference class methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 12/14/2012 14:13'!
reference: aPDFDataObject
	^ self new referencedObject: aPDFDataObject; yourself! !

!PDFDataReference methodsFor: 'visit' stamp: 'guillaumelarcheveque 2/15/2013 14:44'!
acceptVisitor: aVisitor
	^ aVisitor visitPDFDataReference: self! !

!PDFDataReference methodsFor: 'testing' stamp: 'guillaumelarcheveque 2/15/2013 15:37'!
isPrintable
	^ true! !

!PDFDataReference methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/14/2012 14:15'!
printOn: aStream
	aStream nextPutAll: referencedObject id asString; space; nextPutAll: referencedObject revision asString; space; nextPut: $R! !

!PDFDataReference methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/14/2012 13:27'!
referencedObject
	^ referencedObject! !

!PDFDataReference methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/14/2012 13:27'!
referencedObject: anObject
	referencedObject := anObject! !

PDFDataType subclass: #PDFDataStartXref
	instanceVariableNames: 'xref'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-DataTypes'!

!PDFDataStartXref commentStamp: '<historical>' prior: 0!
A PDFDataStartXref is the representation for the stream position of the xref table in PDF.

Instance Variables
	xref:		<Object>

xref
	- xxxxx
!

!PDFDataStartXref class methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 2/15/2013 14:05'!
to: aPDFDataXRef
	^ self new
		xref: aPDFDataXRef;
		yourself! !

!PDFDataStartXref methodsFor: 'visit' stamp: 'guillaumelarcheveque 2/15/2013 14:44'!
acceptVisitor: aVisitor
	^ aVisitor visitPDFDataStartXref: self! !

!PDFDataStartXref methodsFor: 'printing' stamp: 'guillaumelarcheveque 2/15/2013 16:55'!
printWith: aPDFPrinter
	aPDFPrinter printPDFDataStartXref: self! !

!PDFDataStartXref methodsFor: 'accessing' stamp: 'guillaumelarcheveque 2/15/2013 14:05'!
xref
	^ xref! !

!PDFDataStartXref methodsFor: 'accessing' stamp: 'guillaumelarcheveque 2/15/2013 14:05'!
xref: anObject
	xref := anObject! !

PDFDataType subclass: #PDFDataStream
	instanceVariableNames: 'codeSegment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-DataTypes'!

!PDFDataStream commentStamp: '<historical>' prior: 0!
A PDFDataStream is the representation for stream in PDF.

It contains all codeSegments of a page which are the result of the PDFElements generation by PDFGenerator

Instance Variables
	codeSegment:		<Object>

codeSegment
	- xxxxx
!

!PDFDataStream class methodsFor: 'as yet unclassified' stamp: 'GuillaumeLarcheveque 3/1/2013 13:09'!
codeSegment: aCodeSegment
	^ self new
		codeSegment: aCodeSegment;
		yourself! !

!PDFDataStream methodsFor: 'visit' stamp: 'guillaumelarcheveque 2/15/2013 14:44'!
acceptVisitor: aVisitor
	^ aVisitor visitPDFDataStream: self! !

!PDFDataStream methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/1/2013 13:09'!
codeSegment
	^ codeSegment! !

!PDFDataStream methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/1/2013 13:09'!
codeSegment: anObject
	codeSegment := anObject! !

!PDFDataStream methodsFor: 'printing' stamp: 'guillaumelarcheveque 2/15/2013 16:51'!
printWith: aPDFPrinter
	aPDFPrinter printPDFDataStream: self! !

PDFDataType subclass: #PDFDataStreamRefSize
	instanceVariableNames: 'pdfDataStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-DataTypes'!

!PDFDataStreamRefSize commentStamp: '<historical>' prior: 0!
A PDFDataStreamRefSize is the representation for a stream size in PDF.

Instance Variables
	pdfDataStream:		<Object>

pdfDataStream
	- xxxxx
!

!PDFDataStreamRefSize class methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 2/1/2013 14:00'!
stream: aStream
	^ self new
		pdfDataStream: aStream;
		yourself! !

!PDFDataStreamRefSize methodsFor: 'visit' stamp: 'guillaumelarcheveque 2/15/2013 14:44'!
acceptVisitor: aVisitor
	^ aVisitor visitPDFDataStreamRefSize: self! !

!PDFDataStreamRefSize methodsFor: 'accessing' stamp: 'guillaumelarcheveque 2/1/2013 13:47'!
pdfDataStream
	^ pdfDataStream! !

!PDFDataStreamRefSize methodsFor: 'accessing' stamp: 'guillaumelarcheveque 2/1/2013 13:47'!
pdfDataStream: anObject
	pdfDataStream := anObject! !

!PDFDataStreamRefSize methodsFor: 'printing' stamp: 'guillaumelarcheveque 2/15/2013 16:47'!
printWith: aPDFPrinter
	aPDFPrinter printPDFDataStreamRefSize: self! !

PDFDataType subclass: #PDFDataString
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-DataTypes'!

!PDFDataString commentStamp: '<historical>' prior: 0!
A PDFDataString is the representation for a string in PDF.

Instance Variables
	text:		<Object>

text
	- xxxxx
!

!PDFDataString class methodsFor: 'creation' stamp: 'guillaumelarcheveque 2/15/2013 10:30'!
text: aText
	^ self new text: aText; yourself! !

!PDFDataString methodsFor: 'visit' stamp: 'guillaumelarcheveque 2/15/2013 14:44'!
acceptVisitor: aVisitor
	^ aVisitor visitPDFDataString: self! !

!PDFDataString methodsFor: 'action' stamp: 'OlivierAuverlot 2/7/2013 20:56'!
escape: aString
	"answer a clean string at PDF format"
	
	| str |
	str := aString copyWithRegex: '\\' matchesReplacedWith: '\\\'.	
	str := str copyWithRegex: '\(' matchesReplacedWith: '\('.
	str := str copyWithRegex: '\)' matchesReplacedWith: '\)'.

	^str! !

!PDFDataString methodsFor: 'testing' stamp: 'guillaumelarcheveque 2/15/2013 15:38'!
isPrintable
	^ true! !

!PDFDataString methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/7/2013 20:57'!
printOn: aStream
	aStream nextPut: $(; nextPutAll: (self escape: self text); nextPut: $)! !

!PDFDataString methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/7/2013 20:58'!
text
	^ text asString! !

!PDFDataString methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/7/2013 20:51'!
text: anObject
	text := anObject! !

PDFDataType subclass: #PDFDataSymbol
	instanceVariableNames: 'symbol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-DataTypes'!

!PDFDataSymbol commentStamp: '<historical>' prior: 0!
A PDFDataSymbol is the representation for a symbol in PDF.

Instance Variables
	symbol:		<Object>

symbol
	- xxxxx
!

!PDFDataSymbol class methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 12/14/2012 14:09'!
symbol: aSymbol
	^ self new symbol: aSymbol; yourself! !

!PDFDataSymbol methodsFor: 'visit' stamp: 'guillaumelarcheveque 2/15/2013 14:44'!
acceptVisitor: aVisitor
	^ aVisitor visitPDFDataSymbol: self! !

!PDFDataSymbol methodsFor: 'testing' stamp: 'guillaumelarcheveque 2/15/2013 15:38'!
isPrintable
	^ true! !

!PDFDataSymbol methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/14/2012 13:35'!
printOn: aStream
	aStream nextPut: $/; nextPutAll: symbol asString! !

!PDFDataSymbol methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/14/2012 13:18'!
symbol
	^ symbol! !

!PDFDataSymbol methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/14/2012 13:18'!
symbol: anObject
	symbol := anObject! !

PDFDataType subclass: #PDFDataTrailer
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-DataTypes'!

!PDFDataTrailer commentStamp: '<historical>' prior: 0!
A PDFDataTrailer is the representation for the trailer in PDF.

Instance Variables
	contents:		<Object>

contents
	- xxxxx
!

!PDFDataTrailer methodsFor: 'visit' stamp: 'guillaumelarcheveque 2/15/2013 14:44'!
acceptVisitor: aVisitor
	^ aVisitor visitPDFDataTrailer: self! !

!PDFDataTrailer methodsFor: 'accessing' stamp: 'guillaumelarcheveque 2/15/2013 13:32'!
addContent: aContent
	contents addLast: aContent! !

!PDFDataTrailer methodsFor: 'accessing' stamp: 'guillaumelarcheveque 2/15/2013 13:33'!
contents
	^ contents! !

!PDFDataTrailer methodsFor: 'accessing' stamp: 'guillaumelarcheveque 2/15/2013 13:33'!
contents: anObject
	contents := anObject! !

!PDFDataTrailer methodsFor: 'initialize-release' stamp: 'guillaumelarcheveque 2/15/2013 13:33'!
initialize 
	contents := OrderedCollection new! !

!PDFDataTrailer methodsFor: 'printing' stamp: 'OlivierAuverlot 3/29/2013 15:15'!
printOn: aStream
	aStream nextPutAll: 'trailer'; lf.
	contents do: [:aContent | aContent printOn: aStream. aStream lf].! !

!PDFDataType methodsFor: 'visit' stamp: 'guillaumelarcheveque 2/15/2013 14:41'!
acceptVisitor: aVisitor
	^ self subclassResponsibility ! !

!PDFDataType methodsFor: 'visit' stamp: 'guillaumelarcheveque 2/15/2013 15:36'!
isPrintable
	^ false! !

PDFDataType subclass: #PDFDataValue
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-DataTypes'!

!PDFDataValue commentStamp: '<historical>' prior: 0!
A PDFDataValue is the representation for a value in PDF.

Instance Variables
	value:		<Object>

value
	- xxxxx
!

!PDFDataValue class methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 12/14/2012 14:04'!
value: aValue
	^ self new value: aValue; yourself! !

!PDFDataValue methodsFor: 'visit' stamp: 'guillaumelarcheveque 2/15/2013 14:44'!
acceptVisitor: aVisitor
	^ aVisitor visitPDFDataValue: self! !

!PDFDataValue methodsFor: 'testing' stamp: 'guillaumelarcheveque 2/15/2013 15:38'!
isPrintable
	^ true! !

!PDFDataValue methodsFor: 'printing' stamp: 'guillaumelarcheveque 12/14/2012 13:33'!
printOn: aStream
	aStream nextPutAll: value asString! !

!PDFDataValue methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 4/26/2013 10:12'!
value
	^ value! !

!PDFDataValue methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/14/2012 13:31'!
value: anObject
	value := anObject! !

PDFDataType subclass: #PDFDataXObjectStream
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-DataTypes'!

!PDFDataXObjectStream commentStamp: '<historical>' prior: 0!
A PDFDataXObjectStream is a pdf stream which contain multimedia resource.

Instance Variables
	stream:		<Object>

stream
	- xxxxx
!

!PDFDataXObjectStream class methodsFor: 'as yet unclassified' stamp: 'GuillaumeLarcheveque 3/21/2013 13:52'!
stream: aStream
	^ self new
		stream: aStream;
		yourself! !

!PDFDataXObjectStream methodsFor: 'visit' stamp: 'GuillaumeLarcheveque 3/21/2013 10:54'!
acceptVisitor: aVisitor
	^ aVisitor visitPDFDataXObjectStream: self! !

!PDFDataXObjectStream methodsFor: 'printing' stamp: 'GuillaumeLarcheveque 3/21/2013 14:16'!
printWith: aPDFPrinter
	aPDFPrinter printPDFDataXObjectStream: self! !

!PDFDataXObjectStream methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/21/2013 10:52'!
stream
	^ stream! !

!PDFDataXObjectStream methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/21/2013 10:52'!
stream: anObject
	stream := anObject! !

PDFDataType subclass: #PDFDataXRef
	instanceVariableNames: 'referencies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-DataTypes'!

!PDFDataXRef commentStamp: '<historical>' prior: 0!
A PDFDataXRef is the representation for the xref table in PDF.

Instance Variables
	referencies:		<Object>

referencies
	- xxxxx
!

!PDFDataXRef methodsFor: 'accessing' stamp: 'guillaumelarcheveque 2/15/2013 14:00'!
AddReferenceTo: aPDFDataObject
	referencies addLast: (PDFDataXRefEntry referencedObject: aPDFDataObject)! !

!PDFDataXRef methodsFor: 'visit' stamp: 'guillaumelarcheveque 2/15/2013 14:44'!
acceptVisitor: aVisitor
	^ aVisitor visitPDFDataXRef: self! !

!PDFDataXRef methodsFor: 'initialize-release' stamp: 'guillaumelarcheveque 2/15/2013 13:58'!
initialize
	referencies := OrderedCollection new.
	referencies add: PDFDataXRefEntry new.! !

!PDFDataXRef methodsFor: 'accessing' stamp: 'guillaumelarcheveque 2/15/2013 13:59'!
referencies
	^ referencies! !

!PDFDataXRef methodsFor: 'accessing' stamp: 'guillaumelarcheveque 2/15/2013 13:59'!
referencies: anObject
	referencies := anObject! !

PDFDataType subclass: #PDFDataXRefEntry
	instanceVariableNames: 'referencedObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-DataTypes'!

!PDFDataXRefEntry commentStamp: '<historical>' prior: 0!
A PDFDataXRefEntry is the representation an xref entry which point to an object in PDF.

Instance Variables
	referencedObject:		<Object>

referencedObject
	- xxxxx
!

!PDFDataXRefEntry class methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 2/15/2013 13:59'!
referencedObject: aPDFDataTypeObject
	^ self new
		referencedObject: aPDFDataTypeObject;
		yourself! !

!PDFDataXRefEntry methodsFor: 'visit' stamp: 'guillaumelarcheveque 2/15/2013 14:44'!
acceptVisitor: aVisitor
	^ aVisitor visitPDFDataXRefEntry: self! !

!PDFDataXRefEntry methodsFor: 'accessing' stamp: 'guillaumelarcheveque 2/15/2013 13:58'!
referencedObject
	^ referencedObject! !

!PDFDataXRefEntry methodsFor: 'accessing' stamp: 'guillaumelarcheveque 2/15/2013 13:58'!
referencedObject: anObject
	referencedObject := anObject! !

Object subclass: #PDFDocument
	instanceVariableNames: 'metaData pages orientation format styleSheet zoom displayMode displayLayout version compression'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Base'!

!PDFDocument commentStamp: 'OlivierAuverlot 1/11/2015 09:26' prior: 0!
ARTEFACT

an easy to use, extensible and cool framework to generate PDF

Authors: Olivier Auverlot and Guillaume Larcheveque aka The Pasta Team

PS: Titles are stupid but it was a hard work to express our pleasure to work together.

!! Introduction: The PDF stays where it is, and the Artefact move the universe around it

Artefact is a framework to generate PDF documents. It is fully written in Smalltalk and doesn't require any native library. Artefact is light, platform independant and offer to users a high level of abstraction in order to easily creating PDF documents.  

 * completely written in Smalltalk (and only Smalltalk),
 * complete freedom about the order of creation for pages, elements... (no need to follow the document order)
 * multi format and orientation for pages
 * page composition based on reusables PDF elements,
 * extensibility by offering a composition standard to create your own high level elements
 * styleSheet that can be reused in many documents and avoid wasting time and place with duplication
 * image support with the JPEG format
 * pre-defined high level elements like datagrid
 * support PDF compression to produce compact files

!! Your first PDF document (for dummies)
The best way to start with Artefact is to look at Artefact-Demos package and to run each PDFDemos class methods.

By default each generation result is written in the default pharo directory but you can define your own in the demoPath method 

example: 

	demoPath
		^ '/Users/pharo/pdf/'

If you want to run all demos, just execute: PDFDemos runAllDemos :-)

!!Artefact global scheme, the cortex syndrom

The basic brick in Artefact is the PDFDocument which represent the whole document. In this PDFDocument you will add some PDFPage. A page is a drawing surface where you can put any PDFElement. Elements are the graphics object like texts, lines, arrows… Elements can be more complex as we will see in the PDFCompositeElement section. Every PDFElement can be included in a more complex composite elements and reused in many documents. We encourage you to create your own elements library and share it with other users.

Unlike many PDF frameworks, you don't have to create your pages in the order you want to print them. Moreover you can use the same page in many documents. Elements follow the same logical at the page level. 

Artefact use a tree structure to represent a document. It's important to understand that any property defined at a level will be applied at lower levels and will surcharge a higher one (example: if you define a format at the document level, it will be applied on all pages except the ones that define a specific format).

As you can see, Artefact is really easy to use:

	PDFDocument new add: (PDFPage new add: (PDFTextElement new text: 'Hello'; from: 10mm@10mm)); exportTo: 'test.pdf' asFileReference writeStream

!!Positionning elements with the unprobability drive

Coordinates start from the upper left corner (0mm@0mm). As you can expect the x axis is the horizontal one and the y axis the vertical one. By convention, every PDFElement is positioned from his upper left corner.

As you probably noticed, Artefact use units like mm, pt... Every positions and size must be expressed with a unit and every unit can be used for anything (you can express font size with km if you want… but it's probably not a good idea!! ). Thanks to the Units framework and its authors: http://smalltalkhub.com/#!!/~MarcusDenker/Units

!!Document: the world on top of four elephants

A PDFDocument is an ordered collection of pages. A document defines default values for pages and elements. By default, a document contains A4 portrait pages. You can change it with the format: method.

	PDFDocument new format: PDFA3Format new setLandscape.

A PDFDocument could be documented with metaData. All these data are contained in a PDFMetaData object which define following properties:
 * title
 * subject
 * author
 * keywords
 * creator
 * producer

	PDFDocument new metaData title: 'Document title'; 
		subject: 'subject of the document'; 
		author: 'The Pasta Team'; 
		keywords: 'cool rock best';
		creator: 'Artefact - Pharo'.

By default Artefact generate compressed document but you can disable and generate raw documents:

	PDFDocument new uncompressed

!!Pages: no paper no trees (but lots of dead unicorns)

A page is included in a document (or more if you want to use it in many documents). By default, a page is in an A4 portrait format. You can change the format in the same way you does with document:

	PDFPage new format: PDFA3Format new setLandscape.

You can mix multiple formats and orientations in the same document.

Like painters and poets, an empty surface is just a base to expression. From this point of view, the most useful method of the PDFPage object is probably add: that allow you to write, draw or paint.

!!Elements: a quill of ice and fire

A PDFElement is a reusable component that represent a text, an image, a geometric shape or even a complex graph or table.

There are two kinds of PDFElement:
 * Simple elements inherit from PDFBasic (primitive operation in the pdf specification)
 * Composite elements inherit from PDFComposite (a wrap between multiple PDFElements whether they are basic or composite)

Each PDFElement have a set of properties that define its appearance (text color, font, dots…). Those properties are grouped in a stylesheet owned by each element. Every element controls its own appearance and doesn't affect other (in opposition as many PDF framework that use a flow logic). This behavior allow you to move or even use in multiple pages or document the same element.

!!!!Basic Elements (Small is beautiful)

* PDFBezierCurveElement
* PDFCircleElement
* PDFLineElement
* PDFPolygonElement
* PDFRectElement
* PDFJpegElement
* PDFPngElement
* PDFTextElement

!!!!Composite Elements (just tape a bunch of cats together to create a horse)

The power of artefact is to avoid redefining each combination by creating high-level elements (datatable, charts, barcode...).

Instead of creating methods, Artefact offers you a way to define your composition with a standard mechanism. This context allow you to benefit from every cool stuff in artefact like stylesheet, layout, isolation and reusability.

!!!!!!Composites provided by Artefact

 * PDFFormattedTextElement
 * PDFParagraphElement
 * PDFArrowElement
 * PDFDoubleArrowElement
 * PDFCellElement
 * PDFDataTableElement
 * PDFDataTableWithColumnsCaptionElement
 * PDFDataTableWithRowsCaptionElement

!!!!!!Creating your own composite element

The spirit of Artefact is to reduce the complexity of pdf generation. When you have to create a document, a good idea is to avoid wasting time to reinvent the wheel.

When you create a composite element inherit from PDFComposite or PDFCompositeText if your element will be based around a String.

!!Stylesheet, turn a frog into a prince without kissing

A PDFStyleSheet is a dictionary that map rendering properties. A default stylesheet is defined at the document level when this one is created. Consequently, you don't have to specify every values if you want a generic rendering. 
Following the hierarchy logic, a stylesheet defined at a lower level will surcharge properties. For example, if you define a textColor in the document stylesheet, every text will be written in that color except elements where textColor is define in their stylesheet. Like pages and elements, the same stylesheet can be used with different elements or documents.

Artefact introduce a style context. Every PDFElement can be associated to a specific style:

	PDFText from: 10mm@15mm text: 'My title' style: #title

Then, at any upper level (document, page…), you can express the specific title style context:

	myDocument stylesheet > #title at: #font put: PDFCourierFont size: 32 pt

!!!!Fonts
	
Artefact support integrated PDF fonts (PDFCourierFont, PDFHelveticaFont, PDFSymbolFont, PDFTimesFont and PDFZapfdingbatsFont). These fonts are available in any PDF viewer.
A PDFFont object supports the basic style: bold and italic.

	PDFText from: 10mm@15mm text: 'My title' font: ((PDFTimesFont size: 24 pt) bold: true).

!!!!Dots

All the geometric shapes can use a dotted style. It is defined by a PDFDotted object that specify the length of each segment and the space between them.

	((PDFArrowElement from: 125 mm @ 40 mm to:  100 mm @ 80 mm)
				drawColor: (PDFColor r: 0 g: 255 b: 0);
				dotted:
						(PDFDotted new
								length: 2 mm;
								space: 3 mm)).

!!Tutorial: learn how to hunt a white rabbit

In this tutorial, we will create a clock, which is basically a circle and two arrows. This element will be drawed depending on the provided time and properties (size, colors, thickness).


!!!!Create the clock

First create the class of your element:
	PDFComposite subclass: #PDFClockElement
		instanceVariableNames: 'time'
		classVariableNames: ''
		poolDictionaries: ''
		category: 'Artefact-Tutorial'

Don't forget to comment your class ;-).

As you can see, we create an instance variable that will contain the time to display.

Then, create or generate accessors methods to this variable.

The only two required method by Artefact is:
	getSubElementsWith: aGenerator styleSheet: aStyleSheet 

This method must return a collection of PDFElements (basics or composites).

	defaultStyle

This method must return a symbol that associate the composite element with a style definition. However it's not necessary to define this style in your document, Artefact will use the default style instead.

Define the default style:
	defaultStyle
		^ #clock

Then define the method that will draw the clock.
At the beginning, this method will just return the circle:
	getSubElementsWith: aGenerator styleSheet: aStyleSheet
		^ { PDFCircleElement from: self from to: self to }

The circle will be drawed depending on this composite position and size. We are using from: to: for the circle instead of center: radius: because it's easier for us to create a clock using the boundary box of the circle.

Now we will create the clock hands with two PDFArrowElements and a filled little circle in the middle:
	getSubElementsWith: aGenerator styleSheet: aStyleSheet
		| hourAngle minuteAngle |
		hourAngle := Float pi / 2 - (time hour12 * 2 * Float pi / 12).
		minuteAngle := Float pi / 2 - (time minute * 2 * Float pi / 60).

		^ {(PDFCircleElement from: self from to: self to).
		(PDFCircleElement center: self center radius: self dimension x * 0.05).
		(PDFArrowElement from: self center angle: hourAngle length: dimension x * 0.25).
		(PDFArrowElement from: self center angle: minuteAngle length: dimension x * 0.45)}

Don't be afraid about the two angle calculus, it's just to convert hours and minutes to radian angles.

At this time, your PDFClockElement is already usable and fully integrated into Artefact.

We can insert it into a PDF document and export it:
	PDFDocument new
		add: (PDFPage new add: ((PDFClockElement from: 2 cm @ 2 cm to: 10 cm @ 10 cm) time: Time current));
		exportTo: 'clockTutorialStep1.pdf' asFileReference writeStream

!!!! Make the clock personnalizable


Your clock is already personnalizable independently of other elements because you previously define its style as #clock.

	| doc |
	doc := PDFDocument new.
		doc add: (PDFPage new add: ((PDFClockElement from: 2 cm @ 2 cm to: 10 cm @ 10 cm) time: Time current)).
		doc styleSheet > #clock drawColor: (PDFColor r:180 g: 24 b:24); fillColor: (PDFColor r:230 g: 230 b:10).
		doc exportTo: 'clockTutorialStep2.pdf' asFileReference writeStream

You can also personnalize the subelements of your clock by their own default style.

	| doc |
	doc := PDFDocument new.
		doc add: (PDFPage new add: ((PDFClockElement from: 2 cm @ 2 cm to: 10 cm @ 10 cm) time: Time current)).
		doc styleSheet > #clock drawColor: (PDFColor r:180 g: 24 b:24); fillColor: (PDFColor r:230 g: 230 b:10).
		doc styleSheet > #clock > #arrow drawColor: (PDFColor r:0 g: 45 b:200).
		doc exportTo: 'clockTutorialStep3.pdf' asFileReference writeStream

At this time, you don't have defined specific styles for sub elements of your clock. Consequently, you will not be able to personnalize each element with different styles (so you cannot have hands of differents colors for example).

To increase personnalization possibilities, you should define specific styles for sub elements you reuse.

	getSubElementsWith: aGenerator styleSheet: aStyleSheet
		| hourAngle minuteAngle |
		hourAngle := Float pi / 2 - (time hour12 * 2 * Float pi / 12).
		minuteAngle := Float pi / 2 - (time minute * 2 * Float pi / 60).
		^ {(PDFCircleElement from: self from to: self to).
		(PDFCircleElement center: self center radius: self dimension min * 0.05).
		((PDFArrowElement from: self center angle: hourAngle length: dimension min * 0.25) style: #hourHand).
		((PDFArrowElement from: self center angle: minuteAngle length: dimension min * 0.45) style: #minuteHand)}


As you can see, we just send #style: on each subelement that we want to define a specific style.

Now, we can personnalize each hand like that:

	| doc |
	doc := PDFDocument new.
		doc add: (PDFPage new add: ((PDFClockElement from: 2 cm @ 2 cm to: 10 cm @ 10 cm) time: Time current)).
		doc styleSheet > #clock drawColor: (PDFColor r:180 g: 24 b:24); fillColor: (PDFColor r:230 g: 230 b:10).
		doc styleSheet > #clock > #hourHand drawColor: (PDFColor r:0 g: 45 b:200).
		doc styleSheet > #clock > #minuteHand drawColor: (PDFColor r:0 g: 200 b:45).
		doc exportTo: 'clockTutorialStep4.pdf' asFileReference writeStream

As you can see, the clock hands have different colors.

Moreover, like any element in Artefact, you can specify a style on an instance of a PDFClockElement that allow you to reuse and adapt each clock:

	| doc |
	doc := PDFDocument new.
	doc add:
		(PDFPage new
			add: ((PDFClockElement from: 2 cm @ 2 cm to: 10 cm @ 10 cm) time: Time current);
			add: ((PDFClockElement from: 12 cm @ 2 cm to: 20 cm @ 10 cm)
					time: Time current;
					style: #apocalypseClock)).
	doc styleSheet > #clock
		drawColor: (PDFColor r: 180 g: 24 b: 24);
		fillColor: (PDFColor r: 230 g: 230 b: 10).
	doc styleSheet > #clock > #hourHand drawColor: (PDFColor r: 0 g: 45 b: 200).
	doc styleSheet > #clock > #minuteHand drawColor: (PDFColor r: 0 g: 200 b: 45).
	doc styleSheet > #apocalypseClock
		fillColor: (PDFColor r: 244 g: 221 b: 25);
		thickness: 2 mm;
		roundCap: true.
	doc styleSheet > #apocalypseClock > #minuteHand
		drawColor: (PDFColor r: 240 g: 6 b: 7);
		thickness: 1 mm.
	doc exportTo: 'clockTutorialStep5.pdf' asFileReference writeStream

That's all Folks!!!!!!!

!PDFDocument class methodsFor: 'as yet unclassified' stamp: 'OlivierAuverlot 11/28/2012 08:24'!
FrameworkManual
	<wikiStyleHelp: #'Artefact (PDF framework)'>
	^ self comment! !

!PDFDocument methodsFor: 'action' stamp: 'GuillaumeLarcheveque 2/22/2013 13:42'!
add: aPage
	"add a new page in the PDF document"
	self pages add: aPage.
	aPage document: self

	
	
! !

!PDFDocument methodsFor: 'configuration' stamp: 'GuillaumeLarcheveque 5/31/2013 15:03'!
compressed
	self compression: true! !

!PDFDocument methodsFor: 'accessing' stamp: 'OlivierAuverlot 4/3/2013 08:59'!
compression
	^compression! !

!PDFDocument methodsFor: 'accessing' stamp: 'OlivierAuverlot 4/3/2013 09:00'!
compression: aBoolean 	
	compression := aBoolean! !

!PDFDocument methodsFor: 'displayLayout' stamp: 'OlivierAuverlot 4/15/2013 23:54'!
continuousPages
	self displayLayout: #continuousPages! !

!PDFDocument methodsFor: 'displayLayout' stamp: 'OlivierAuverlot 4/15/2013 23:55'!
defaultDisplayLayout
	self displayLayout: #defaultDisplayLayout! !

!PDFDocument methodsFor: 'displayMode' stamp: 'OlivierAuverlot 4/16/2013 11:31'!
defaultDisplayMode
	self displayMode: #defaultDisplayMode.
	self zoom: nil! !

!PDFDocument methodsFor: 'configuration' stamp: 'OlivierAuverlot 3/14/2012 15:18'!
defaultFormat
	^PDFA4Format new! !

!PDFDocument methodsFor: 'accessing' stamp: 'guillaumelarcheveque 11/30/2012 14:25'!
displayLayout
	^ displayLayout! !

!PDFDocument methodsFor: 'accessing' stamp: 'guillaumelarcheveque 11/30/2012 14:25'!
displayLayout: anObject
	displayLayout := anObject! !

!PDFDocument methodsFor: 'accessing' stamp: 'guillaumelarcheveque 11/30/2012 13:21'!
displayMode
	^ displayMode! !

!PDFDocument methodsFor: 'accessing' stamp: 'guillaumelarcheveque 11/30/2012 13:21'!
displayMode: anObject
	displayMode := anObject! !

!PDFDocument methodsFor: 'generate' stamp: 'OlivierAuverlot 4/16/2013 00:09'!
exportTo: aStream
	"generate a PDFDataObject from document"

	^ PDFStreamPrinter new
		printModel: (PDFGenerator new generatePDFCompleteModelFrom: self)
		compression: self compression
		on: aStream! !

!PDFDocument methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/4/2012 11:31'!
format
	^format! !

!PDFDocument methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/4/2012 11:31'!
format: aValue
	format := aValue! !

!PDFDocument methodsFor: 'displayMode' stamp: 'OlivierAuverlot 4/16/2013 12:18'!
fullPage
	self displayMode: #fullPage.
	self zoom: nil! !

!PDFDocument methodsFor: 'displayMode' stamp: 'OlivierAuverlot 4/16/2013 12:18'!
fullWidth
	self displayMode: #fullWidth.
	self zoom: nil! !

!PDFDocument methodsFor: 'generate' stamp: 'guillaumelarcheveque 2/15/2013 16:02'!
generate
	"generate a PDFDataObject from document"

	^ PDFGenerator new generatePDFCompleteModelFrom: self! !

!PDFDocument methodsFor: 'accessing' stamp: 'OlivierAuverlot 3/14/2012 14:24'!
height
	^(self format size y)! !

!PDFDocument methodsFor: 'initialize-release' stamp: 'GuillaumeLarcheveque 3/4/2015 13:04'!
initialize
	super initialize.

	self setFormat: self defaultFormat.
	self styleSheet: (StyleSheet default).
	self metaData: PDFMetaData new.
	self compression: true.
	self defaultDisplayLayout.
	self defaultDisplayMode.! !

!PDFDocument methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/7/2012 15:11'!
metaData
	^ metaData! !

!PDFDocument methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/7/2012 15:11'!
metaData: anObject
	metaData := anObject! !

!PDFDocument methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/3/2012 21:48'!
orientation
	^ orientation! !

!PDFDocument methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/3/2012 21:45'!
orientation: aValue
	orientation := aValue! !

!PDFDocument methodsFor: 'accessing' stamp: 'OlivierAuverlot 1/7/2012 22:28'!
pages
	^ pages ifNil: [ pages := OrderedCollection new ]! !

!PDFDocument methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/12/2012 21:51'!
pages: aListOfPDFPage
	pages := aListOfPDFPage! !

!PDFDocument methodsFor: 'displayMode' stamp: 'OlivierAuverlot 4/16/2013 12:18'!
real
	self displayMode: #real.
	self zoom: nil! !

!PDFDocument methodsFor: 'page setup' stamp: 'OlivierAuverlot 3/14/2012 14:42'!
setFormat: aFormat
	self format: aFormat.! !

!PDFDocument methodsFor: 'displayLayout' stamp: 'OlivierAuverlot 4/15/2013 23:55'!
singlePage
	self displayLayout: #singlePage! !

!PDFDocument methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 10/5/2012 13:04'!
styleSheet
	^ styleSheet! !

!PDFDocument methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 10/5/2012 13:04'!
styleSheet: anObject
	styleSheet := anObject! !

!PDFDocument methodsFor: 'displayLayout' stamp: 'OlivierAuverlot 4/15/2013 23:55'!
twoPages
	self displayLayout: #twoPages! !

!PDFDocument methodsFor: 'configuration' stamp: 'GuillaumeLarcheveque 5/3/2013 10:40'!
uncompressed
	self compression: false! !

!PDFDocument methodsFor: 'accessing' stamp: 'OlivierAuverlot 3/14/2012 14:36'!
width
	^(self format size x)! !

!PDFDocument methodsFor: 'accessing' stamp: 'OlivierAuverlot 4/16/2013 11:30'!
zoom
	^zoom! !

!PDFDocument methodsFor: 'accessing' stamp: 'OlivierAuverlot 4/16/2013 11:30'!
zoom: anIntegerValue
	zoom := anIntegerValue! !

Object subclass: #PDFDotted
	instanceVariableNames: 'length space'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Base'!

!PDFDotted commentStamp: '<historical>' prior: 0!
A PDFDotted is a style of dotted line defined by the length of the segment and space between two of these.

Instance Variables
	length:		<Object>
	space:		<Object>

length
	- xxxxx

space
	- xxxxx
!

!PDFDotted methodsFor: 'private' stamp: 'GuillaumeLarcheveque 3/8/2013 16:58'!
generateCodeWith: aPDFGenerator
	"Answer the dotted configuration"

	^(String streamContents: [ :s |
		s nextPutAll: '[';
		print: (aPDFGenerator convertToPoints: self length);
		space;
		print: (aPDFGenerator convertToPoints: self space);
		nextPutAll: '] 0';
		space;
		nextPutAll: PDFByteCode dotted
	]).! !

!PDFDotted methodsFor: 'accessing' stamp: 'OlivierAuverlot 4/23/2013 15:24'!
initialize 
	super initialize.
	self length: 1 pt.
	self space: 1 pt! !

!PDFDotted methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/8/2013 17:01'!
length
	^ length! !

!PDFDotted methodsFor: 'accessing' stamp: 'OlivierAuverlot 9/21/2012 21:02'!
length: anObject
	length := anObject! !

!PDFDotted methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/8/2013 17:02'!
space
	^ space! !

!PDFDotted methodsFor: 'accessing' stamp: 'OlivierAuverlot 9/21/2012 21:02'!
space: anObject
	space := anObject! !

Object subclass: #PDFElement
	uses: TStyledElement
	instanceVariableNames: 'styleSheet from styles dimension orientation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Elements'!

!PDFElement commentStamp: '<historical>' prior: 0!
A PDFElement is the abstract class for each element that can be included in a PDFPage.

Each PDFElement have the possibility to define which style will be applyed on it instead of the default one.

Instance Variables
	styleSheet:		<Object>

styleSheet
	- xxxxx
!

PDFElement class
	uses: TStyledElement classTrait
	instanceVariableNames: ''!

PDFElement subclass: #PDFBasic
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Elements'!

!PDFBasic commentStamp: '<historical>' prior: 0!
A PDFBasic is the superclass for all elements directly implemented in PDF like lines, text... If you want to create a new PDFBasic look at PDFUnsecureBasic.

Instance Variables
!

!PDFBasic methodsFor: 'render' stamp: 'GuillaumeLarcheveque 3/17/2013 16:07'!
codeSegmentClass
	^ PDFElementCodeSegment! !

!PDFBasic methodsFor: 'action' stamp: 'guillaumelarcheveque 11/23/2012 14:38'!
determinePosition: aPosition on: aPage
	"answer the real position of the PDF element on the page"
	
	^(aPage document convertToPoints: aPosition x) @ ((aPage format defaultSize y) - (aPage document convertToPoints: aPosition y))! !

!PDFBasic methodsFor: 'render' stamp: 'OlivierAuverlot 5/19/2014 09:57'!
generateCodeSegmentWith: aPDFGenerator styleSheet: aStyleSheet format: aFormat

	^ self codeSegmentClass
		code: (self producePageElementCodeWith: aPDFGenerator StyleSheet: aStyleSheet)
		styleSheet: aStyleSheet
		format: aFormat
		isDrawElement: self isDrawElement
		fontId: ([(aPDFGenerator getFontIdFor: aStyleSheet font)] on: KeyNotFound do: [nil])
		opacityId: ([(aPDFGenerator getOpacityIdFor: aStyleSheet opacity)] on: KeyNotFound do: [nil])
		fromElement: self! !

!PDFBasic methodsFor: 'action' stamp: 'GuillaumeLarcheveque 2/22/2013 13:15'!
isDrawElement
	^ self subclassResponsibility ! !

!PDFBasic methodsFor: 'accessing' stamp: 'OlivierAuverlot 1/18/2014 18:58'!
opacity: anOpacity
	self styleSheet opacity: anOpacity ! !

!PDFBasic methodsFor: 'render' stamp: 'GuillaumeLarcheveque 3/1/2013 10:03'!
producePageElementCodeWith: aPDFGenerator StyleSheet: aStyleSheet
	self subclassResponsibility ! !

!PDFBasic methodsFor: 'action' stamp: 'OlivierAuverlot 11/16/2012 10:58'!
splitCoordinates: aPosition
	"Answer a formated string with x and y"
	^(String streamContents: [ :s | s print: aPosition x; space; print: aPosition y ])! !

PDFBasic subclass: #PDFDraw
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Elements-Basic'!

!PDFDraw commentStamp: '<historical>' prior: 0!
A PDFDraw is the superclass for all basics draw elements.

Instance Variables
	filled:		<Object>
	to:		<Object>

filled
	- xxxxx

to
	- xxxxx
!

PDFDraw subclass: #PDFBezierCurveElement
	instanceVariableNames: 'points'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Elements-Basic'!

!PDFBezierCurveElement commentStamp: '<historical>' prior: 0!
A PDFBezierCurveElement is the basic element for bezier curve.

The from position is the origin of the curve and all the points are placed relative to this origin.

Instance Variables
!

!PDFBezierCurveElement class methodsFor: 'instance creation' stamp: 'GuillaumeLarcheveque 5/24/2013 11:36'!
from: aPosition points: anArrayOfPoints
	"Positions of points are relative to aPosition"
	^ (self from: aPosition) points: anArrayOfPoints! !

!PDFBezierCurveElement methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/24/2013 11:29'!
points
	^ points! !

!PDFBezierCurveElement methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/24/2013 11:29'!
points: anObject
	points := anObject! !

!PDFBezierCurveElement methodsFor: 'render' stamp: 'GuillaumeLarcheveque 5/24/2013 11:34'!
producePageElementCodeWith: aPDFGenerator StyleSheet: anObject
	"Draw a Bezier curve from xy to destination (3 control points)"

	^ String
		streamContents: [ :s | 
			s nextPutAll: (self moveTo: self from with: aPDFGenerator).
			self points
				do: [ :p | 
					s
						nextPutAll: (self splitCoordinates: (aPDFGenerator determinePositionOnCurrentPage: self from + p));
						space ].
			s
				nextPutAll: PDFByteCode curve;
				space;
				nextPutAll: PDFByteCode noFilling ]! !

!PDFBezierCurveElement methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/24/2013 19:00'!
requiredAttributes
	^ #( from points )! !

PDFDraw subclass: #PDFCircleElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Elements-Basic'!

!PDFCircleElement commentStamp: '<historical>' prior: 0!
A PDFCircleElement is  the basic element for circle.

Instance Variables
	radius:		<Object>

radius
	- xxxxx
!

!PDFCircleElement class methodsFor: 'instance creation' stamp: 'GuillaumeLarcheveque 5/24/2013 13:28'!
center: aPoint radius: aRadius
	^ self from: aPoint - (aRadius @ aRadius) to: aPoint + (aRadius @ aRadius)! !

!PDFCircleElement methodsFor: 'render' stamp: 'GuillaumeLarcheveque 5/24/2013 14:07'!
producePageElementCodeWith: aPDFGenerator StyleSheet: aStyleSheet
	"Draw a line from xy to destination"
	
	| origin r |
	
	origin := aPDFGenerator determinePositionOnCurrentPage: self center.
	 	
	r := aPDFGenerator convertToPoints: self radius.
	
	^ (String streamContents: [ :s |
		s nextPutAll: (self moveTo: ((self center x + self radius) @ (self center y)) with: aPDFGenerator); 
		print: (origin x + r); space; print: ((r * 0.552) + origin y); space;
		print: ((r * 0.552) + origin x); space; print: (origin y + r); space;
		print: origin x; space; print: (origin y + r); nextPutAll: ' c ';
		print: ((-0.552 * r) + origin x); space; print: (origin y + r); space;
		print: (origin x - r); space; print: ((r * 0.552) + origin y); space;
		print: (origin x - r); space; print: origin y; nextPutAll: ' c ';
		print: (origin x - r); space; print: ((-0.552 * r) + origin y); space;
		print: ((-0.552 * r) + origin x); space; print:  (origin y - r); space;
		print: origin x; space; print: (origin y - r); nextPutAll: ' c ';
		print: ((0.552 * r) + origin x); space; print: (origin y - r); space;
		print: (origin x + r); space; print: ((-0.552 * r) + origin y); space;
		print: (origin x + r); space; print: origin y; nextPutAll: ' c h ';
		nextPutAll:( self fillMode: (aStyleSheet filled))
	]).
 	! !

!PDFCircleElement methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/24/2013 13:21'!
radius
	| box |
	box :=  self to - self from.
	^ (box x max: box y) / 2! !

!PDFDraw methodsFor: 'defaults' stamp: 'GuillaumeLarcheveque 5/3/2013 13:42'!
defaultStyle 
	^#draw! !

!PDFDraw methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 10/5/2012 14:12'!
dotted: anObject
	self styleSheet dotted: anObject! !

!PDFDraw methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 10/5/2012 14:01'!
drawColor: aPDFColor
	self styleSheet drawColor: aPDFColor ! !

!PDFDraw methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/17/2013 10:53'!
fillColor: aPDFColor
	self styleSheet fillColor: aPDFColor ! !

!PDFDraw methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/17/2013 10:56'!
fillMode: filled
	^ filled
		ifTrue: [ PDFByteCode filling ]
		ifFalse: [ PDFByteCode noFilling ]! !

!PDFDraw methodsFor: 'accessing' stamp: 'guillaumelarcheveque 11/23/2012 15:21'!
isDrawElement
	^ true! !

!PDFDraw methodsFor: 'action' stamp: 'GuillaumeLarcheveque 3/1/2013 10:12'!
moveTo: aPosition with: aGenerator
	"answer the PDF code to setting the start position for drawing"
	
	| pos |
	
	pos := aGenerator determinePositionOnCurrentPage: aPosition.
	 
	^(String streamContents: [ :s |
		s print: (pos x);
		space;
		print: (pos y);
		space;
		nextPutAll: PDFByteCode moveTo;
		space
	]) ! !

!PDFDraw methodsFor: 'accessing' stamp: 'OlivierAuverlot 4/10/2013 21:28'!
roundCap: aBoolean
	self styleSheet roundCap: aBoolean! !

!PDFDraw methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 10/5/2012 14:12'!
thickness: anObject
	self styleSheet thickness: anObject! !

PDFDraw subclass: #PDFEllipseElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Elements-Basic'!

!PDFEllipseElement commentStamp: 'StephanEggermont 8/12/2015 11:02' prior: 0!
A basic ellipse!

!PDFEllipseElement class methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/12/2015 11:40'!
center: aPoint radius: aRadius
	^ self from: aPoint - (aRadius @ aRadius) to: aPoint + (aRadius @ aRadius)! !

!PDFEllipseElement methodsFor: 'render' stamp: 'StephanEggermont 8/12/2015 12:05'!
producePageElementCodeWith: aPDFGenerator StyleSheet: aStyleSheet
	
	| hw hh magic cx cy lx rx ty by |

	magic := 0.551784.
	cx := aPDFGenerator convertToPoints: self center x.
	cy := aPDFGenerator convertToPoints: self center y.
	hw := 0.5*magic * (aPDFGenerator convertToPoints: self width).
	hh := 0.5*magic * (aPDFGenerator convertToPoints: self height).
	lx := aPDFGenerator convertToPoints: (self center x - (self width / 2 )).
	rx := aPDFGenerator convertToPoints: (self center x + (self width / 2 )).
	ty := aPDFGenerator convertToPoints: (self center y - (self height / 2 )).
	by := aPDFGenerator convertToPoints: (self center y + (self height / 2 )).
	
	^ (String streamContents: [ :s |
		s print: cx; space; print: ty; nextPutAll: ' m '; 
		print: cx+hw; space; print: ty; space;
		print: rx; space; print: cy-hh; space;
		print: rx; space; print: cy; nextPutAll: ' c ';
		print: rx; space; print: cy+hh; space;
		print: cx+hw; space; print: by; space;
		print: cx; space; print: by; nextPutAll: ' c ';
		print: cx-hw; space; print: by; space;
		print: lx; space; print:  cy+hh; space;
		print: lx; space; print:cy; nextPutAll: ' c ';
		print: lx; space; print: cy-hh; space;
		print: cx-hw; space; print: ty; space;
		print: cx; space; print: ty; nextPutAll: ' c h ';
		nextPutAll:( self fillMode: (aStyleSheet filled))
	]).
 	! !

PDFDraw subclass: #PDFLineElement
	uses: PDFAngleDirected
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Elements-Basic'!

!PDFLineElement commentStamp: '<historical>' prior: 0!
A PDFLineElement is  the basic element for line.

Instance Variables
!

PDFLineElement class
	uses: PDFAngleDirected classTrait
	instanceVariableNames: ''!

!PDFLineElement class methodsFor: 'instance creation' stamp: ''!
from: from angle: angle length: aLength
	^ self from: from to: from + ((angle cos * aLength) @ (angle sin * aLength))! !

!PDFLineElement methodsFor: 'render' stamp: 'GuillaumeLarcheveque 5/24/2013 15:52'!
producePageElementCodeWith: aPDFGenerator StyleSheet: anObject
	| dest |
	
	dest := aPDFGenerator determinePositionOnCurrentPage: self orientedTo .
	 			
	^  (String streamContents: [ :s |
		s nextPutAll: (self moveTo: self orientedFrom with: aPDFGenerator);
		nextPutAll: (self splitCoordinates: dest);
		space;
		nextPutAll: PDFByteCode line;
		space;
		nextPutAll: PDFByteCode noFilling
	]).! !

!PDFLineElement methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/24/2013 19:03'!
requiredAttributes
	^ #( from to orientation )! !

PDFDraw subclass: #PDFPolygonElement
	instanceVariableNames: 'points'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Elements-Basic'!

!PDFPolygonElement commentStamp: '<historical>' prior: 0!
A PDFPolygonElement is  the basic element for polygons.

Instance Variables
!

!PDFPolygonElement class methodsFor: 'instance creation' stamp: 'GuillaumeLarcheveque 5/24/2013 12:58'!
from: aPosition points: anArrayOfPoints
	^(self from: aPosition) points: anArrayOfPoints ! !

!PDFPolygonElement methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/24/2013 11:45'!
points
	^ points! !

!PDFPolygonElement methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/24/2013 11:45'!
points: anObject
	points := anObject! !

!PDFPolygonElement methodsFor: 'render' stamp: 'GuillaumeLarcheveque 5/24/2013 13:05'!
producePageElementCodeWith: aPDFGenerator StyleSheet: aStyleSheet
	"Draw a polygon from xy to destination (a array of positions)"

	^ String
		streamContents: [ :s | 
			s nextPutAll: (self moveTo: self from with: aPDFGenerator).
			self points , {self points first}
				do: [ :p | 
					s
						nextPutAll: (self splitCoordinates: (aPDFGenerator determinePositionOnCurrentPage: self from + p));
						space.
					s
						nextPutAll: PDFByteCode line;
						space ].
			s
				nextPutAll: (self fillMode: aStyleSheet filled);
				space ]! !

!PDFPolygonElement methodsFor: 'checking' stamp: 'GuillaumeLarcheveque 5/24/2013 19:01'!
requiredAttributes
	^ #( from points )! !

PDFDraw subclass: #PDFRectElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Elements-Basic'!

!PDFRectElement commentStamp: '<historical>' prior: 0!
A PDFRectElement is the basic element for rectangle.

Instance Variables
!

!PDFRectElement methodsFor: 'render' stamp: 'GuillaumeLarcheveque 5/24/2013 13:45'!
producePageElementCodeWith: aPDFGenerator StyleSheet: aStyleSheet
	"Draw a rectangle from xy with a specified dimension"
	
	| position |
	
	position := aPDFGenerator determinePositionOnCurrentPage: self from.
	 
	^(String streamContents: [ :s |
		s nextPutAll: (self splitCoordinates: position);
		space;
		print: (aPDFGenerator convertToPoints: self dimension x);
		space;
		print: ((aPDFGenerator convertToPoints: self dimension y) * -1);
		space;
		nextPutAll: PDFByteCode rectangle;
		space;
		nextPutAll:( self fillMode: (aStyleSheet filled))
	 ]).	
		! !

PDFBasic subclass: #PDFImage
	instanceVariableNames: 'stream originalImageDimensions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Elements-Basic'!

!PDFImage commentStamp: '<historical>' prior: 0!
A PDFImage is the superclass for all basics image elements.

Instance Variables
	data:		<Object>
	reader:		<Object>
	to:		<Object>

data
	- xxxxx

reader
	- xxxxx

to
	- xxxxx
!

!PDFImage class methodsFor: 'instance creation' stamp: 'OlivierAuverlot 5/27/2014 08:45'!
from: aPosition dimension: aDimension fromStream: aStream
	^ self new
		from: aPosition;
		dimension: aDimension;
		stream: aStream;
		yourself! !

!PDFImage class methodsFor: 'instance creation' stamp: 'OlivierAuverlot 2/20/2015 14:59'!
fromMorph: aMorph
	self subclassResponsibility 
! !

!PDFImage class methodsFor: 'instance creation' stamp: 'GuillaumeLarcheveque 3/21/2013 13:49'!
fromStream: aStream
	^ self new
		stream: aStream;
		yourself! !

!PDFImage methodsFor: 'defaults' stamp: 'GuillaumeLarcheveque 5/3/2013 13:42'!
defaultStyle 
	^ #image! !

!PDFImage methodsFor: 'as yet unclassified' stamp: 'GuillaumeLarcheveque 8/5/2013 15:33'!
height: aHeight
	self dimension: (aHeight / self originalImageDimensions y * self originalImageDimensions x) @ aHeight! !

!PDFImage methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/21/2013 13:51'!
isDrawElement 
	^ false! !

!PDFImage methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 8/5/2013 15:25'!
originalImageDimensions
	^ originalImageDimensions! !

!PDFImage methodsFor: 'render' stamp: 'OlivierAuverlot 1/9/2015 11:16'!
producePageElementCodeWith: aPDFGenerator StyleSheet: anObject
	| origin imageId |
	
	"Determine the vertical position of the image"
	 origin := aPDFGenerator determinePositionOnCurrentPage: (self from + (0 @ self dimension y) ).

	"Determine the id of the image"
	imageId:= aPDFGenerator getImageIdFor: self.
	 			
	^  (String streamContents: [ :s |
		s nextPutAll:  'q'; space;
		nextPutAll: (aPDFGenerator convertToPoints: self dimension x) asString; space;
		nextPutAll: '0 0'; space;
		nextPutAll: (aPDFGenerator convertToPoints: self dimension y) asString; space;
		nextPutAll: (origin x asString); space;
		nextPutAll: (origin y asString); space;
		nextPutAll: 'cm';space; 
		nextPut: $/; nextPutAll: imageId; space;
		nextPutAll: 'Do Q'
	 ]).! !

!PDFImage methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/21/2013 13:22'!
stream
	^ stream! !

!PDFImage methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 8/5/2013 15:27'!
stream: anImageStream
	stream := anImageStream.
	! !

!PDFImage methodsFor: 'as yet unclassified' stamp: 'GuillaumeLarcheveque 8/5/2013 15:34'!
width: aWidth
	self dimension: aWidth @ (aWidth / self originalImageDimensions x * self originalImageDimensions y) ! !

PDFImage subclass: #PDFJpegElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Elements-Basic'!

!PDFJpegElement commentStamp: 'OlivierAuverlot 1/9/2015 11:15' prior: 0!
A PDFJpegElement is the pdf representation of an image


!

!PDFJpegElement class methodsFor: 'instance creation' stamp: 'OlivierAuverlot 2/20/2015 15:06'!
fromMorph: aMorph
	| imgpng |
	
	imgpng := ReadWriteStream  on: (ByteArray new).
	PluginBasedJPEGReadWriter new on: imgpng; nextPutImage: (aMorph imageForm).

	^ self fromStream: imgpng! !

!PDFJpegElement methodsFor: 'accessing' stamp: 'OlivierAuverlot 1/9/2015 11:41'!
stream: anImageStream
	| readWriter |
	stream := anImageStream.	"Compute original dimensions for this image"
	readWriter := (JPEGReadWriter on: anImageStream)
		nextImage;
		yourself.
	originalImageDimensions := readWriter width pt @ readWriter height pt.
! !

PDFImage subclass: #PDFPngElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Elements-Basic'!

!PDFPngElement commentStamp: 'OlivierAuverlot 1/9/2015 11:15' prior: 0!
A PDFPngElement is the pdf representation of an image
!

!PDFPngElement class methodsFor: 'instance creation' stamp: 'OlivierAuverlot 2/20/2015 15:04'!
fromMorph: aMorph
	| imgpng |
	
	imgpng := ReadWriteStream  on: (ByteArray new).
	PNGReadWriter new on: imgpng; nextPutImage: (aMorph imageForm).
	^ self fromStream: imgpng
		! !

!PDFPngElement methodsFor: 'accessing' stamp: 'OlivierAuverlot 1/9/2015 11:45'!
stream: anImageStream
	| readWriter |
	"The PNG is converted to JPEG"
	stream := (ReadWriteStream with: (ByteArray new)).
	(PluginBasedJPEGReadWriter on: stream) nextPutImage: (PNGReadWriter on: anImageStream) nextImage.
		
	readWriter := (JPEGReadWriter on: stream)
		nextImage;
		yourself.
	originalImageDimensions := readWriter width pt @ readWriter height pt.
	

	

	
! !

PDFBasic subclass: #PDFText
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Elements-Basic'!

!PDFText commentStamp: '<historical>' prior: 0!
A PDFText is the superclass for all basics text elements.

Instance Variables
	text:		<Object>

text
	- xxxxx
!

!PDFText class methodsFor: 'instance creation' stamp: 'OlivierAuverlot 5/24/2013 09:01'!
from: aPosition text: aText
	^ self new
		from: aPosition;
		text: aText;
		yourself! !

!PDFText class methodsFor: 'instance creation' stamp: 'GuillaumeLarcheveque 10/2/2014 11:41'!
from: aPosition text: aText font: aFont
	^ self new
		from: aPosition;
		text: aText;
		font: aFont;
		yourself! !

!PDFText methodsFor: 'defaults' stamp: 'GuillaumeLarcheveque 5/3/2013 13:41'!
defaultStyle
	^ #text! !

!PDFText methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/1/2013 12:49'!
escape: aString
	"answer a clean string at PDF format"
	
	| str |
	str := aString copyWithRegex: '\\' matchesReplacedWith: '\\\'.	
	str := str copyWithRegex: '\(' matchesReplacedWith: '\('.
	str := str copyWithRegex: '\)' matchesReplacedWith: '\)'.

	^str! !

!PDFText methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 10/5/2012 15:10'!
font: aFont
	self styleSheet font: aFont! !

!PDFText methodsFor: 'accessing' stamp: 'guillaumelarcheveque 11/23/2012 15:21'!
isDrawElement
	^ false! !

!PDFText methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/16/2012 15:39'!
text
	(text isNil) ifTrue: [ text := '' ].
	^text! !

!PDFText methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/15/2012 14:38'!
text: anObject
	text := anObject! !

!PDFText methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 10/5/2012 15:10'!
textColor: aColor
	self styleSheet textColor: aColor! !

!PDFText methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/1/2013 12:49'!
textString: aString
	"Answer a formated text string"
	
	^('(' , (self escape: (aString asString)) , ')')! !

PDFText subclass: #PDFTextElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Elements-Basic'!

!PDFTextElement commentStamp: '<historical>' prior: 0!
A PDFTextElement is the basic element for text.

Instance Variables
!

!PDFTextElement methodsFor: 'render' stamp: 'GuillaumeLarcheveque 5/17/2013 14:04'!
minimumDimensionWith: aPDFGenerator styleSheet: aStyleSheet
	^ ((aStyleSheet font getStringWidth: self text) + (2 * aStyleSheet margin)) @ (aStyleSheet font fontSize + (2 * aStyleSheet margin))! !

!PDFTextElement methodsFor: 'render' stamp: 'GuillaumeLarcheveque 4/5/2013 15:33'!
producePageElementCodeWith: aGenerator StyleSheet: aStyleSheet
	"Draw a text at xy position"

	| position |
	position := aGenerator determinePositionOnCurrentPage: self from + (0 @ (aStyleSheet font fontSize * 0.8)).
	^ String
		streamContents: [ :s | 
			s
				nextPutAll: PDFByteCode beginText;
				space;
				nextPutAll: (self splitCoordinates: position);
				space;
				nextPutAll: PDFByteCode setTextPosition;
				space;
				nextPutAll: (self textString: self text);
				space;
				nextPutAll: PDFByteCode showTextString;
				space;
				nextPutAll: PDFByteCode endOfText ]! !

!PDFTextElement methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/24/2013 19:04'!
requiredAttributes
	^ #( from text )! !

PDFBasic subclass: #PDFUnsecureBasic
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Elements'!

!PDFUnsecureBasic commentStamp: '<historical>' prior: 0!
A PDFUnsecureBasic is the class you should inherit from if you want to directly insert PDF code into your document. This code will be considered as unsecure to protect other PDFElement. You will benefit automatically from stylesheets for colors, thickness...

You have to implement:
-producePageElementCodeWith: aPDFGenerator StyleSheet: aStyleSheet (must return a String representation of your pdf code)
-isDrawElement (Artefact use differents colors parameters to distinguish text and draw elements but pdf only have one for both)

Instance Variables
!

!PDFUnsecureBasic methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/17/2013 16:10'!
codeSegmentClass
	^ PDFUnsecureElementCodeSegment ! !

PDFElement subclass: #PDFComposite
	instanceVariableNames: 'filled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Elements'!

!PDFComposite commentStamp: '<historical>' prior: 0!
A PDFComposite is the abstract class which any composite inherit. A composite is a PDFElement grouping many PDFElement to create more elaborated elements than PDFBasic (for example a PDFArrowElement is a composition of PDFLine to draw an arrow).

A composit that inherit from PDFComposite just have to implement a getSubElements method returning a collection of PDFElement.

Instance Variables
	filled:		<Object>

filled
	- xxxxx
!

PDFComposite subclass: #PDFArrow
	uses: PDFAngleDirected
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Elements-Composites'!

!PDFArrow commentStamp: '<historical>' prior: 0!
A PDFArrow is the superclass for arrows (not directly usable).
!

PDFArrow class
	uses: PDFAngleDirected classTrait
	instanceVariableNames: ''!

!PDFArrow class methodsFor: 'as yet unclassified' stamp: 'GuillaumeLarcheveque 6/21/2013 15:43'!
from: from angle: angle length: aLength
	^ self from: from to: from + ((angle cos * aLength) @ ((angle sin * aLength) negated))! !

!PDFArrow methodsFor: 'action' stamp: 'GuillaumeLarcheveque 5/24/2013 15:56'!
angle
	^ ((self orientedTo  y - self orientedFrom y) convertTo: Unit point) value arcTan: ((self orientedTo x - self orientedFrom x) convertTo: Unit point) value! !

!PDFArrow methodsFor: 'initialize-release' stamp: 'GuillaumeLarcheveque 4/26/2013 14:22'!
defaultStyle
	^ #arrow! !

!PDFArrow methodsFor: 'action' stamp: 'OlivierAuverlot 10/27/2012 15:11'!
destinationOfHeadItem: aAngleValue with: aPosition
	"Answer the destination of a head item"
	^(aPosition x - (self headLength * (aAngleValue cos)))@(aPosition y - (self headLength * (aAngleValue sin)))! !

!PDFArrow methodsFor: 'render' stamp: 'GuillaumeLarcheveque 3/8/2013 10:59'!
getSubElementsWith: anObject styleSheet: anObject1
	self subclassResponsibility! !

!PDFArrow methodsFor: 'action' stamp: 'GuillaumeLarcheveque 3/16/2015 12:20'!
headAt: aPosition angle: anAngle
	^ {(PDFLineElement
		from: aPosition
		to: (self destinationOfHeadItem: anAngle - (Float pi / 6) with: aPosition)
		style: #head).
	(PDFLineElement from: aPosition to: (self destinationOfHeadItem: anAngle + (Float pi / 6) with: aPosition) style: #head)}! !

!PDFArrow methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/8/2013 16:45'!
headLength
	"answer the length of the head of the arrow"
	^3 pt! !

!PDFArrow methodsFor: 'checking' stamp: 'GuillaumeLarcheveque 5/24/2013 19:03'!
requiredAttributes
	^ #( from to orientation )! !

PDFArrow subclass: #PDFArrowElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Elements-Composites'!

!PDFArrowElement commentStamp: '<historical>' prior: 0!
A PDFArrowElement is the element to draw a simple arrow (with one head at the end). An arrow MUST be created with the from:to: method on class side (to determine orientation).

Styles hierarchy:
#arrow
#arrow > #head!

!PDFArrowElement methodsFor: 'render' stamp: 'GuillaumeLarcheveque 5/24/2013 15:56'!
getSubElementsWith: aGenerator styleSheet: aStyleSheet 
	"answer the style description"
	
	^ {(PDFLineElement from: self orientedFrom to: self orientedTo)}, (self headAt: self orientedTo angle: self angle)
! !

PDFArrow subclass: #PDFDoubleArrowElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Elements-Composites'!

!PDFDoubleArrowElement commentStamp: '<historical>' prior: 0!
A PDFDoubleArrowElement is the element to draw a double arrow (with one head at each extremity). An arrow MUST be created with the from:to: method on class side (to determine orientation)

Styles hierarchy:
#arrow
#arrow > #head

!

!PDFDoubleArrowElement methodsFor: 'render' stamp: 'GuillaumeLarcheveque 5/24/2013 15:56'!
getSubElementsWith: aPDFGenerator styleSheet: aStyleSheet
	"answer the style description"

	^ {(PDFLineElement 
		from: self orientedFrom
		to: self orientedTo)} , (self headAt: self orientedTo angle: self angle) , (self headAt: self orientedFrom angle: self angle - Float pi)! !

PDFComposite subclass: #PDFBorderElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Elements-Composites'!

!PDFBorderElement commentStamp: 'GuillaumeLarcheveque 3/16/2015 13:00' prior: 0!
A PDFBorderElement is basically a square with independently parametrizable #top, #bottom, #left, #right.
!

!PDFBorderElement methodsFor: 'style' stamp: 'GuillaumeLarcheveque 3/13/2015 11:50'!
defaultStyle
	^ #border! !

!PDFBorderElement methodsFor: 'render' stamp: 'GuillaumeLarcheveque 3/16/2015 10:45'!
getSubElementsWith: aPDFGenerator styleSheet: aStyleSheet
	^ { (PDFRectElement from: self from to: self to) thickness: 0cm.
	(PDFLineElement from: self from x @ self from y to: self to x @ self from y style: #top).
	(PDFLineElement from: self to x @ self from y to: self to x @ self to y style: #right).
	(PDFLineElement from: self to x @ self to y to: self from x @ self to y style: #bottom).
	(PDFLineElement from: self from x @ self to y to: self from x @ self from y style: #left)}! !

!PDFComposite methodsFor: 'accessing' stamp: 'guillaumelarcheveque 11/23/2012 10:53'!
dotted: aPDFDottedObject
	self styleSheet dotted: aPDFDottedObject! !

!PDFComposite methodsFor: 'accessing' stamp: 'guillaumelarcheveque 11/23/2012 10:57'!
drawColor: aColor
	self styleSheet drawColor: aColor! !

!PDFComposite methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/15/2013 14:01'!
fillColor: aColor
	self filled: true.
	self styleSheet fillColor: aColor! !

!PDFComposite methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/15/2013 14:00'!
filled
	^ filled! !

!PDFComposite methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/15/2013 14:00'!
filled: anObject
	filled := anObject! !

!PDFComposite methodsFor: 'accessing' stamp: 'guillaumelarcheveque 11/23/2012 10:55'!
font: aFont
	self styleSheet font: aFont! !

!PDFComposite methodsFor: 'render' stamp: 'OlivierAuverlot 5/19/2014 09:58'!
generateCodeSegmentWith: aPDFGenerator styleSheet: aStyleSheet format: aFormat
	^ PDFCompositeCodeSegment
		from: (self generateCodeSegmentsCollectionWith: aPDFGenerator styleSheet: aStyleSheet format: aFormat)
		styleSheet: aStyleSheet! !

!PDFComposite methodsFor: 'render' stamp: 'OlivierAuverlot 5/19/2014 09:59'!
generateCodeSegmentsCollectionWith: aPDFGenerator styleSheet: compositeStyleSheet format: aFormat
	^ (self getSubElementsWith: aPDFGenerator styleSheet: compositeStyleSheet)
		collect: [ :aSubElement | 
			aSubElement
				generateCodeSegmentWith: aPDFGenerator
				styleSheet: (aSubElement buildCompositeStyleSheetFrom: compositeStyleSheet)
				format: aFormat ]! !

!PDFComposite methodsFor: 'render' stamp: 'GuillaumeLarcheveque 5/3/2013 09:57'!
getSubElementsWith: aPDFGenerator styleSheet: aStyleSheet
	""
	self subclassResponsibility! !

!PDFComposite methodsFor: 'initialize-release' stamp: 'GuillaumeLarcheveque 3/15/2013 14:00'!
initialize 
	super initialize.
	self filled: false! !

!PDFComposite methodsFor: 'as yet unclassified' stamp: 'GuillaumeLarcheveque 6/21/2013 14:00'!
roundCap: aBoolean
	self styleSheet roundCap: aBoolean! !

!PDFComposite methodsFor: 'accessing' stamp: 'guillaumelarcheveque 11/23/2012 10:55'!
textColor: aColor
	self styleSheet textColor: aColor! !

!PDFComposite methodsFor: 'accessing' stamp: 'guillaumelarcheveque 11/23/2012 10:58'!
thickness: aThickness
	self styleSheet thickness: aThickness 
 ! !

PDFComposite subclass: #PDFCompositeText
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Elements-Composites'!

!PDFCompositeText commentStamp: '<historical>' prior: 0!
A PDFCompositeText is the superclass for each text.

Instance Variables
	alignment:		<Object>
	margin:		<Object>
	text:		<Object>
	verticalAlignment:		<Object>

alignment
	- xxxxx

margin
	- xxxxx

text
	- xxxxx

verticalAlignment
	- xxxxx
!

!PDFCompositeText class methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 9/17/2014 11:13'!
text: aText
	^ self new text: aText; yourself! !

!PDFCompositeText methodsFor: 'private' stamp: 'GuillaumeLarcheveque 5/17/2013 13:54'!
alignment: aPDFAlignment
	self styleSheet alignment: aPDFAlignment! !

!PDFCompositeText methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/17/2013 14:06'!
margin: aMargin
	self styleSheet margin: aMargin! !

!PDFCompositeText methodsFor: 'render' stamp: 'GuillaumeLarcheveque 5/24/2013 13:43'!
minimumDimensionWith: aPDFGenerator styleSheet: aStyleSheet
	^ self dimension
		ifNil: [ ((aStyleSheet font getStringWidth: self text) + (2 * aStyleSheet margin)) @ (aStyleSheet font fontSize + (2 * aStyleSheet margin)) ]
	! !

!PDFCompositeText methodsFor: 'checking' stamp: 'GuillaumeLarcheveque 5/24/2013 19:04'!
requiredAttributes
	^ #( from text )! !

!PDFCompositeText methodsFor: 'accessing' stamp: 'OlivierAuverlot 10/30/2012 12:28'!
text
	^text! !

!PDFCompositeText methodsFor: 'accessing' stamp: 'OlivierAuverlot 10/30/2012 12:29'!
text: aString
	text := aString! !

PDFCompositeText subclass: #PDFFormattedTextElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Elements-Composites'!

!PDFFormattedTextElement commentStamp: '<historical>' prior: 0!
A PDFFormattedTextElement is an element to represent a text contained in a virtual box. the text can be positionned with differents alignments (left, middle, right) but will be displayed on one line (no carriage return).

Styles hierarchy:
#text
!

PDFFormattedTextElement subclass: #PDFCellElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Elements-Composites'!

!PDFCellElement commentStamp: '<historical>' prior: 0!
A PDFCellElement is a formatted text element drawed in a rectangle.

Styles hierarchy:
#cell
#cell > #text
#cell > #border
!

!PDFCellElement class methodsFor: 'instance creation' stamp: 'GuillaumeLarcheveque 5/24/2013 13:53'!
from: aPoint dimension: aDimension text: aText 	
	^ (self from: aPoint dimension: aDimension) text: aText ! !

!PDFCellElement methodsFor: 'initialize-release' stamp: 'GuillaumeLarcheveque 4/26/2013 14:25'!
defaultStyle
	^ #cell! !

!PDFCellElement methodsFor: 'action' stamp: 'GuillaumeLarcheveque 5/24/2013 13:43'!
determineDecyForTextStyleWith: aStyleSheet
	"Set right xy values for text"

	| decy |
	self dimension ifNil: [ ^ aStyleSheet margin ].	"determining the vertical offset"
	aStyleSheet alignment isBottom 
		ifTrue: [ decy := self dimension y - aStyleSheet margin - aStyleSheet font fontSize ]
		ifFalse: [ 
			aStyleSheet alignment isMiddle
				ifTrue: [ decy := (self dimension y - aStyleSheet font fontSize) / 2 ]
				ifFalse: [ decy := aStyleSheet margin ] ].
	^ decy! !

!PDFCellElement methodsFor: 'render' stamp: 'GuillaumeLarcheveque 3/16/2015 10:06'!
getSubElementsWith: aPDFGenerator styleSheet: aStyleSheet
	"get the current position in the page if xy is not defined"

	| decx decy dimensions |
	"set the position of the text element"
	dimensions := self minimumDimensionWith: aPDFGenerator styleSheet: aStyleSheet.
	decx := self determineDecxForTextStyle: self text styleSheet: aStyleSheet.
	decy := self determineDecyForTextStyleWith: aStyleSheet.
	^ {(PDFBorderElement from: self from dimension: dimensions).
	(PDFTextElement new
		text: self text;
		from: (decx + self from x) @ (self from y + decy))}! !

!PDFFormattedTextElement methodsFor: 'style' stamp: 'GuillaumeLarcheveque 5/3/2013 13:55'!
defaultStyle
	^ #text! !

!PDFFormattedTextElement methodsFor: 'action' stamp: 'GuillaumeLarcheveque 5/24/2013 13:43'!
determineDecxForTextStyle: aTextElement styleSheet: aStyleSheet
	"Set right x values for text"
	| width decx |
	
	self dimension ifNil: [ ^ aStyleSheet margin ].
	
	width := aStyleSheet font getStringWidth: aTextElement.
	
	"determining the horizontal offset"
	(aStyleSheet alignment isRight) 
			ifTrue: [ decx := self dimension x - aStyleSheet margin - width ] 
			ifFalse: [ 
				(aStyleSheet alignment isCenter) ifTrue: [ decx := ((self dimension x - width) / 2) ] ifFalse: [ decx := aStyleSheet margin ] 
			].
	^decx! !

!PDFFormattedTextElement methodsFor: 'render' stamp: 'GuillaumeLarcheveque 5/17/2013 13:27'!
getSubElementsWith: aPDFGenerator styleSheet: aStyleSheet

	| height font decx |

	font := aStyleSheet font.
	height := font fontSize.
	decx := self determineDecxForTextStyle: (self text) styleSheet: aStyleSheet.

	^ {PDFTextElement new text: (self text); from: (decx + self from x)@(self from y + height)}! !

!PDFFormattedTextElement methodsFor: 'initialize-release' stamp: 'OlivierAuverlot 10/30/2012 12:21'!
initialize
	super initialize.! !

PDFCompositeText subclass: #PDFParagraphElement
	instanceVariableNames: 'spacing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Elements-Composites'!

!PDFParagraphElement commentStamp: '<historical>' prior: 0!
A PDFParagraphElement is a text with carriage return (automatically calculated from width dimension).

Styles hierarchy:
#paragraph!

!PDFParagraphElement methodsFor: 'style' stamp: 'GuillaumeLarcheveque 5/3/2013 14:04'!
defaultStyle
	^ #text! !

!PDFParagraphElement methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/31/2013 15:13'!
getSubElementsWith: aPDFGenerator styleSheet: aStyleSheet
	| lines decalage currentXY current |
	lines := self splitOn: aPDFGenerator currentPage using: aStyleSheet font.
	decalage := aStyleSheet font fontSize.
	currentXY := self from.
	^ lines
		collect: [ :aLine | 
			current := PDFFormattedTextElement new
				from: currentXY;
				dimension: self dimension;
				text: aLine.
			currentXY := currentXY + (0 @ decalage) + (0 @ self spacing).
			current ]! !

!PDFParagraphElement methodsFor: 'initialize-release' stamp: 'OlivierAuverlot 4/20/2013 21:32'!
initialize
	super initialize.
	self spacing: 0 mm.! !

!PDFParagraphElement methodsFor: 'checking' stamp: 'GuillaumeLarcheveque 5/24/2013 19:05'!
requiredAttributes
	^ #( from text dimension )! !

!PDFParagraphElement methodsFor: 'accessing' stamp: 'OlivierAuverlot 4/20/2013 21:26'!
spacing
	^spacing! !

!PDFParagraphElement methodsFor: 'accessing' stamp: 'OlivierAuverlot 4/20/2013 21:26'!
spacing: aValue 	
	spacing := aValue! !

!PDFParagraphElement methodsFor: 'action' stamp: 'GuillaumeLarcheveque 5/24/2013 13:44'!
splitOn: aPage using: aFont
	"answer the lines of the paragraph (in the context of the specified page)"

	| widthOfLine widthOfWord line lines |
	widthOfLine := 0 pt.
	line := WriteStream on: String new.
	lines := OrderedCollection new.
	self wordsList
		do: [ :aWord | 
			| word |
			word := aWord , ' '.
			widthOfLine + (widthOfWord := aFont getStringWidth: word) <= self dimension x
				ifTrue: [ 
					line nextPutAll: word.
					widthOfLine := widthOfLine + widthOfWord ]
				ifFalse: [ 
					widthOfWord > self dimension x
						ifTrue: [ 
							ArtefactOverSizedContent new
								content: aWord;
								signal ].
					lines add: (line contents asString allButLast).
					line
						resetContents;
						nextPutAll: word.
					widthOfLine := widthOfWord ] ].
	lines add: (line contents asString allButLast).	"close the stream"
	line close.
	^ lines! !

!PDFParagraphElement methodsFor: 'private' stamp: 'CyrilFerlicot 5/31/2016 16:17'!
wordsList
	"answer the list of words in the text"

	^ self text substrings: ' '! !

PDFComposite subclass: #PDFDataTableElement
	instanceVariableNames: 'data customizationBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Elements-Composites'!

!PDFDataTableElement commentStamp: '<historical>' prior: 0!
A PDFDataTableElement is a basic table. You just have to fill it with a two dimensions array and the composite will create every cells.

Instance Variables
	data:		<Object>
	margin:		<Object>

data
	- xxxxx

margin
	- xxxxx
!

!PDFDataTableElement methodsFor: 'render' stamp: 'GuillaumeLarcheveque 9/17/2014 11:15'!
calculateMinimumDimensionsForCells: cells withGenerator: aGenerator styleSheet: aStyleSheet
	| individualMinimumDimensions contextualMinimumDimensions |
	individualMinimumDimensions := cells collect: [ :anArray | 
			(anArray
				collect: [ :aCell | 
					aCell minimumDimensionWith: aGenerator styleSheet: aStyleSheet
					]).
			].
		
	contextualMinimumDimensions := individualMinimumDimensions collect: [ :lines |
		|x y|
		y := lines max: #y.
		lines collectWithIndex: [ :dim :i  | x := individualMinimumDimensions max: [:line | (line at: i) x]. x@y]
	 ].
	^ contextualMinimumDimensions	! !

!PDFDataTableElement methodsFor: 'render' stamp: 'GuillaumeLarcheveque 5/24/2013 13:44'!
cellDimensions
	^ (self dimension x / self cellsData first size) @ (self dimension y / self cellsData size)! !

!PDFDataTableElement methodsFor: 'render' stamp: 'GuillaumeLarcheveque 5/3/2013 16:50'!
cellsData
	^ self data! !

!PDFDataTableElement methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 6/10/2013 11:29'!
customizationBlock
	^ customizationBlock! !

!PDFDataTableElement methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 6/10/2013 11:29'!
customizationBlock: anObject
	customizationBlock := anObject! !

!PDFDataTableElement methodsFor: 'accessing' stamp: 'OlivierAuverlot 10/31/2012 11:22'!
data
	^data! !

!PDFDataTableElement methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/3/2013 15:04'!
data: aTwoDimensionArray
	data := aTwoDimensionArray! !

!PDFDataTableElement methodsFor: 'initialize-release' stamp: 'GuillaumeLarcheveque 5/3/2013 14:28'!
defaultStyle
	^ #datatable! !

!PDFDataTableElement methodsFor: 'render' stamp: 'GuillaumeLarcheveque 9/17/2014 10:32'!
getCellsWith: aGenerator styleSheet: aStyleSheet
	| x y |
	y := 0.
	^ self cellsData
		collect: [ :anArray | 
			x := 1.
			y := y + 1.
			anArray
				collect: [ :aData | 
					| cell |
					cell := PDFCellElement text: aData asString.
					self customizationBlock
						value: cell
						value: x
						value: y
						value: aData.
					x := x + 1.
					cell ] ]! !

!PDFDataTableElement methodsFor: 'render' stamp: 'GuillaumeLarcheveque 9/17/2014 11:12'!
getOldSubElementsWith: aGenerator styleSheet: aStyleSheet
	| currentFrom aCellDimension x y |
	y := 1.
	currentFrom := self from.
	aCellDimension := self cellDimensions.
	^ self cellsData
		inject: OrderedCollection new
		into: [ :collection :anArray | 
			| result |
			x := 1.
			result := collection , (anArray
				collect: [ :aData | 
					| cell |
					cell := PDFCellElement from: currentFrom dimension: aCellDimension text: aData asString.
					self customizationBlock value: cell value: x value: y value: aData.
					currentFrom := currentFrom + (aCellDimension x @ 0pt).
					x := x + 1.
					cell ]).
			currentFrom := self from x @ (currentFrom y + aCellDimension y).
			y := y + 1.
			result ]! !

!PDFDataTableElement methodsFor: 'render' stamp: 'GuillaumeLarcheveque 9/17/2014 10:47'!
getProtoSubElementsWith: aGenerator styleSheet: aStyleSheet
	| currentFrom aCellDimension  cells minimumDimensions |
	currentFrom := self from.
	aCellDimension := self cellDimensions.
	cells:= self getCellsWith: aGenerator styleSheet: aStyleSheet.
	minimumDimensions := self calculateMinimumDimensionsForCells: cells withGenerator: aGenerator styleSheet: aStyleSheet.
	cells do: [ :anArray | 
			(anArray
				do: [ :aCell | 
					aCell from: currentFrom; dimension: aCellDimension.
					currentFrom := currentFrom + (aCellDimension x @ 0pt).
					]).
			currentFrom := self from x @ (currentFrom y + aCellDimension y).
			].
		
	^ cells flatten! !

!PDFDataTableElement methodsFor: 'render' stamp: 'GuillaumeLarcheveque 9/17/2014 11:26'!
getSubElementsWith: aGenerator styleSheet: aStyleSheet
	| currentFrom cells minimumDimensions cellsDimensions |
	currentFrom := self from.
	cells:= self getCellsWith: aGenerator styleSheet: aStyleSheet.
	minimumDimensions := self calculateMinimumDimensionsForCells: cells withGenerator: aGenerator styleSheet: aStyleSheet.
	cellsDimensions := self scaleMinimumCellsDimensions: minimumDimensions.
	cells doWithIndex: [ :anArray :line | 
			(anArray
				doWithIndex: [ :aCell :column | 
					aCell from: currentFrom; dimension: ((cellsDimensions at:line) at: column).
					currentFrom := currentFrom + (aCell dimension x @ 0pt).
					]).
			currentFrom := self from x @ (currentFrom y + (cellsDimensions at:line) first y).
			].
		
	^ cells flattened! !

!PDFDataTableElement methodsFor: 'initialize-release' stamp: 'GuillaumeLarcheveque 6/10/2013 11:42'!
initialize 
	super initialize.
	self customizationBlock: [ :cell :x :y :cellData | ].! !

!PDFDataTableElement methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/24/2013 19:07'!
margin: aMargin
	self styleSheet margin: aMargin! !

!PDFDataTableElement methodsFor: 'checking' stamp: 'GuillaumeLarcheveque 5/24/2013 19:08'!
requiredAttributes
	^ #( from data dimension )! !

!PDFDataTableElement methodsFor: 'render' stamp: 'GuillaumeLarcheveque 9/17/2014 11:41'!
scaleMinimumCellsDimensions: minimumDimensions
	| totalMinimumDimension scale |
	totalMinimumDimension := (minimumDimensions first sum: #x) @ (minimumDimensions sum: [ :line | line first y ]).
	self dimension ifNotNil: [ ((totalMinimumDimension x > self dimension x) or: [totalMinimumDimension y > self dimension y]) ifTrue: [self error: 'dimension too small for datas (required: ', (totalMinimumDimension x convertTo: self dimension x unit) asString, '@', (totalMinimumDimension y convertTo: self dimension y unit) asString, ' provided: ', self dimension asString ]].
	
	scale := self dimension / totalMinimumDimension.
	^ minimumDimensions collect: [ :line | line collect: [ :dim | dim * scale ] ]! !

PDFDataTableElement subclass: #PDFDataTableWithCaptions
	instanceVariableNames: 'captions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Elements-Composites'!

!PDFDataTableWithCaptions commentStamp: '<historical>' prior: 0!
A PDFDataTableWithCaptions is an abstract class for dataTable with a specific context for caption.

Instance Variables
	captions:		<Object>

captions
	- xxxxx
!

!PDFDataTableWithCaptions methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/3/2013 16:48'!
captions
	^ captions! !

!PDFDataTableWithCaptions methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/3/2013 16:48'!
captions: anObject
	captions := anObject! !

!PDFDataTableWithCaptions methodsFor: 'checking' stamp: 'GuillaumeLarcheveque 5/24/2013 19:10'!
requiredAttributes
	^ #( from data captions dimension )! !

PDFDataTableWithCaptions subclass: #PDFDataTableWithColumnsCaptionElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Elements-Composites'!

!PDFDataTableWithColumnsCaptionElement commentStamp: '<historical>' prior: 0!
A PDFDataTableWithColumnsCaptionElement is the specific dataTable for columns caption.

Instance Variables
!

!PDFDataTableWithColumnsCaptionElement methodsFor: 'render' stamp: 'GuillaumeLarcheveque 5/3/2013 16:51'!
cellsData 
	^ {self captions}, self data! !

!PDFDataTableWithColumnsCaptionElement methodsFor: 'render' stamp: 'GuillaumeLarcheveque 5/14/2015 10:57'!
getSubElementsWith: aPDFGenerator styleSheet: aStyleSheet
	"answer a datatable model with the captions in the columns"

	| elements |
	elements := super getSubElementsWith: aPDFGenerator styleSheet: aStyleSheet.
	1 to: self captions size do: [ :anIndex | (elements at: anIndex) addStyle: #caption ].
	^ elements! !

PDFDataTableWithCaptions subclass: #PDFDataTableWithRowsCaptionElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Elements-Composites'!

!PDFDataTableWithRowsCaptionElement commentStamp: '<historical>' prior: 0!
A PDFDataTableWithRowsCaptionElement is the specific dataTable for rows caption.

Instance Variables
!

!PDFDataTableWithRowsCaptionElement methodsFor: 'render' stamp: 'GuillaumeLarcheveque 5/12/2015 18:04'!
cellsData 
	| current |
	current := 0.
	^ self data collect: [ :aLine | current := current + 1. {self captions at: current}, aLine ]! !

!PDFDataTableWithRowsCaptionElement methodsFor: 'render' stamp: 'GuillaumeLarcheveque 3/16/2015 11:38'!
getSubElementsWith: aPDFGenerator styleSheet: aStyleSheet
	"answer a datatable model with the captions in the rows"

	| elements |
	elements := super getSubElementsWith: aPDFGenerator styleSheet: aStyleSheet.
	1 to: elements size by: self data first size + 1 do: [ :anIndex | (elements at: anIndex) addStyle: #caption ].
	^ elements! !

PDFComposite subclass: #PDFLayout
	instanceVariableNames: 'elements nextElementFrom'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Elements'!

!PDFLayout commentStamp: '<historical>' prior: 0!
A PDFLayout is the abstract class which any layout inherit. It contains a list of elements to place. A layout that inherit from PDFLayout just have to implement computeNextPositionElement

Instance Variables
	elements:		<Object>
	nextElementFrom:		<Object>

elements
	- xxxxx

nextElementFrom
	- xxxxx
!

!PDFLayout class methodsFor: 'instance creation' stamp: 'GuillaumeLarcheveque 4/5/2013 15:41'!
on: aCollection
	^ self new elements: aCollection! !

!PDFLayout methodsFor: 'adding' stamp: 'GuillaumeLarcheveque 3/16/2013 08:05'!
add: aPDFElement
	self elements addLast: aPDFElement! !

!PDFLayout methodsFor: 'render' stamp: 'GuillaumeLarcheveque 5/24/2013 13:44'!
createOriginalDimensionDictionary
	| dimensions |
	dimensions := Dictionary new. 
	self elements do: [ :anElement | dimensions at: anElement put: anElement dimension ].
	^ dimensions! !

!PDFLayout methodsFor: 'render' stamp: 'GuillaumeLarcheveque 3/20/2013 11:14'!
createOriginalPositionDictionary
	| positions |
	positions := Dictionary new. 
	self elements do: [ :anElement | positions at: anElement put: anElement from ].
	^ positions! !

!PDFLayout methodsFor: 'style' stamp: 'GuillaumeLarcheveque 5/17/2013 11:09'!
defaultStyle
	^ #default! !

!PDFLayout methodsFor: 'render' stamp: 'GuillaumeLarcheveque 5/24/2013 13:55'!
defineElementDimension: anElement with: aPDFGenerator styleSheet: aStyleSheet
	anElement dimension: (anElement minimumDimensionWith: aPDFGenerator styleSheet: aStyleSheet)! !

!PDFLayout methodsFor: 'render' stamp: 'GuillaumeLarcheveque 3/20/2013 13:22'!
defineElementPosition: anElement with: aPDFGenerator styleSheet: aStyleSheet
	^ self subclassResponsibility ! !

!PDFLayout methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/16/2013 08:04'!
elements
	^ elements! !

!PDFLayout methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/16/2013 08:04'!
elements: anObject
	elements := anObject! !

!PDFLayout methodsFor: 'render' stamp: 'OlivierAuverlot 5/19/2014 11:36'!
generateCodeSegmentsCollectionWith: aPDFGenerator styleSheet: aStyleSheet  format: aFormat
	| elementsOriginalPosition codeSegments compositeStyleSheet elementsOriginalDimension |
	elementsOriginalPosition := self createOriginalPositionDictionary.
	elementsOriginalDimension := self createOriginalDimensionDictionary.
	codeSegments := self elements
		collect: [ :anElement | 
			compositeStyleSheet := anElement buildCompositeStyleSheetFrom: aStyleSheet.
			self defineElementPosition: anElement with: aPDFGenerator styleSheet: compositeStyleSheet.
			self defineElementDimension: anElement with: aPDFGenerator styleSheet: compositeStyleSheet.
			anElement generateCodeSegmentWith: aPDFGenerator styleSheet: compositeStyleSheet format: aFormat ].
	elementsOriginalPosition keysAndValuesDo: [ :anElement :aPosition | anElement from: aPosition ].
	elementsOriginalDimension keysAndValuesDo: [ :anElement :aDimension | anElement dimension: aDimension ].
	^ codeSegments! !

!PDFLayout methodsFor: 'render' stamp: 'OlivierAuverlot 5/14/2014 16:22'!
generateCodeSegmentsCollectionWith: aPDFGenerator styleSheet: aStyleSheet  page: aPage
	| elementsOriginalPosition codeSegments compositeStyleSheet elementsOriginalDimension |
	elementsOriginalPosition := self createOriginalPositionDictionary.
	elementsOriginalDimension := self createOriginalDimensionDictionary.
	codeSegments := self elements
		collect: [ :anElement | 
			compositeStyleSheet := anElement buildCompositeStyleSheetFrom: aStyleSheet.
			self defineElementPosition: anElement with: aPDFGenerator styleSheet: compositeStyleSheet.
			self defineElementDimension: anElement with: aPDFGenerator styleSheet: compositeStyleSheet.
			anElement generateCodeSegmentWith: aPDFGenerator styleSheet: compositeStyleSheet page: aPage ].
	elementsOriginalPosition keysAndValuesDo: [ :anElement :aPosition | anElement from: aPosition ].
	elementsOriginalDimension keysAndValuesDo: [ :anElement :aDimension | anElement dimension: aDimension ].
	^ codeSegments! !

!PDFLayout methodsFor: 'initialize-release' stamp: 'GuillaumeLarcheveque 3/17/2013 15:07'!
initialize 
	super initialize.
	elements:= OrderedCollection new.! !

!PDFLayout methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/16/2013 08:33'!
nextElementFrom
	^ nextElementFrom ifNil: [ self from ]! !

!PDFLayout methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/16/2013 08:33'!
nextElementFrom: nextPosition
	nextElementFrom:= nextPosition! !

PDFLayout subclass: #PDFSpacedLayout
	instanceVariableNames: 'spacing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Layouts'!

!PDFSpacedLayout commentStamp: '<historical>' prior: 0!
A PDFSpacedLayout is the abstract class for each layout with space between contained elements.

Instance Variables
	spacing:		<Object>

spacing
	- xxxxx
!

PDFSpacedLayout subclass: #PDFHorizontalLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Layouts'!

!PDFHorizontalLayout commentStamp: '<historical>' prior: 0!
A PDFHorizontalLayout is a layout capable to display elements horizontally.

Instance Variables
!

!PDFHorizontalLayout methodsFor: 'layouting' stamp: 'GuillaumeLarcheveque 5/24/2013 13:44'!
defineElementPosition: anElement with: aPDFGenerator styleSheet: aStyleSheet
	| previousElement |
	anElement
		from:
			(self elements first = anElement
				ifTrue: [ self from ]
				ifFalse: [ 
					previousElement := self elements before: anElement.
					previousElement from + ((previousElement dimension x + self spacing) @ 0 pt) ])! !

!PDFSpacedLayout methodsFor: 'initialize-release' stamp: 'GuillaumeLarcheveque 3/20/2013 13:30'!
defaultSpacing

	^ 5 pt! !

!PDFSpacedLayout methodsFor: 'initialize-release' stamp: 'GuillaumeLarcheveque 3/20/2013 13:30'!
initialize 
	super initialize.
	spacing := self defaultSpacing.! !

!PDFSpacedLayout methodsFor: 'checking' stamp: 'GuillaumeLarcheveque 5/24/2013 19:19'!
requiredAttributes
	^ #( from spacing )! !

!PDFSpacedLayout methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/20/2013 11:08'!
spacing
	^ spacing! !

!PDFSpacedLayout methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/20/2013 11:08'!
spacing: anObject
	spacing := anObject! !

PDFSpacedLayout subclass: #PDFVerticalLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Layouts'!

!PDFVerticalLayout commentStamp: '<historical>' prior: 0!
A PDFVerticalLayout is a layout capable to display elements vertically.

Instance Variables
!

!PDFVerticalLayout methodsFor: 'layouting' stamp: 'GuillaumeLarcheveque 5/24/2013 13:44'!
defineElementPosition: anElement with: aPDFGenerator styleSheet: aStyleSheet
	| previousElement |
	anElement
		from:
			(self elements first = anElement
				ifTrue: [ self from ]
				ifFalse: [ 
					previousElement := self elements before: anElement.
					previousElement from + (0 pt @ (previousElement dimension y + self spacing)) ])! !

!PDFElement class methodsFor: 'orientation' stamp: 'GuillaumeLarcheveque 5/24/2013 15:36'!
determineOrientation: aPoint
	^ ((aPoint y < 0 ifTrue: [ 'top' ] ifFalse: [ 'bottom' ]) , (aPoint x < 0 ifTrue: [ 'Left' ] ifFalse: [ 'Right' ])) asSymbol! !

!PDFElement class methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/24/2013 11:24'!
from: aPosition
	^ self new from: aPosition! !

!PDFElement class methodsFor: 'instance creation' stamp: 'GuillaumeLarcheveque 5/24/2013 14:06'!
from: aPosition dimension: aDimension
	^ (self from: aPosition) dimension: aDimension! !

!PDFElement class methodsFor: 'instance creation' stamp: 'GuillaumeLarcheveque 5/24/2013 15:34'!
from: aPosition to: anotherPosition
	^ (self from: (aPosition min: anotherPosition) dimension: (anotherPosition - aPosition) abs ) orientation: (self determineOrientation: anotherPosition - aPosition)! !

!PDFElement class methodsFor: 'as yet unclassified' stamp: 'GuillaumeLarcheveque 3/16/2015 11:38'!
from: aPosition to: anotherPosition style: aStyleSymbol
	^ (self from: aPosition to: anotherPosition)
		addStyle: aStyleSymbol;
		yourself! !

!PDFElement methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 6/21/2013 15:51'!
center
	^ (self from + self to) / 2! !

!PDFElement methodsFor: 'checking' stamp: 'GuillaumeLarcheveque 5/24/2013 18:48'!
checkAttributes
	self requiredAttributes
		do: [ :anAttribute | (self perform: anAttribute) ifNil: [ ArtefactUndefinedAttribute signalMissingAttribute: anAttribute for: self ] ]! !

!PDFElement methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/24/2013 13:42'!
dimension
	^ dimension! !

!PDFElement methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/24/2013 13:55'!
dimension: aDimension
	dimension:= aDimension ! !

!PDFElement methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/17/2013 16:04'!
from
	^ from! !

!PDFElement methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/17/2013 16:04'!
from: anObject
	from := anObject! !

!PDFElement methodsFor: 'render' stamp: 'OlivierAuverlot 5/19/2014 09:57'!
generateCodeSegmentWith: aGenerator styleSheet: aStyleSheet format: aFormat
	^ self subclassResponsibility ! !

!PDFElement methodsFor: 'render' stamp: 'OlivierAuverlot 5/19/2014 09:56'!
generateWith: aGenerator styleSheet: aStyleSheet format: aFormat
	"this method is the main one to generate this PDFElement"
	self checkAttributes.

	^ self generateCodeSegmentWith: aGenerator styleSheet: (self buildCompositeStyleSheetFrom: aStyleSheet) format: aFormat! !

!PDFElement methodsFor: 'size' stamp: 'GuillaumeLarcheveque 7/26/2013 15:21'!
height
	^ self dimension y! !

!PDFElement methodsFor: 'initialize-release' stamp: 'GuillaumeLarcheveque 3/16/2015 12:43'!
initialize 
	super initialize.
	self orientation: #bottomRight.
	self initializeStyle! !

!PDFElement methodsFor: 'render' stamp: 'GuillaumeLarcheveque 5/24/2013 13:42'!
minimumDimensionWith: aPDFGenerator styleSheet: aStyleSheet
	"Return the minimum dimension for layout, by default its the one defined by the user"
	^ self dimension! !

!PDFElement methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/24/2013 15:53'!
orientation
	^ orientation! !

!PDFElement methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/24/2013 15:53'!
orientation: anObject
	orientation := anObject! !

!PDFElement methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/24/2013 15:50'!
orientedFrom
	^ ({(#bottomRight -> [ self from ]).
	(#bottomLeft -> [ self to x @ self from y ]).
	(#topRight -> [ self from x @ self to y ]).
	(#topLeft -> [ self to x @ self to y ])} asDictionary at: self orientation) value! !

!PDFElement methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/24/2013 15:51'!
orientedTo
	^ ({(#bottomRight -> [ self to ]).
	(#bottomLeft -> [ self from x @ self to y ]).
	(#topRight -> [ self to x @ self from y ]).
	(#topLeft -> [ self from x @ self from y ])} asDictionary at: self orientation) value! !

!PDFElement methodsFor: 'checking' stamp: 'GuillaumeLarcheveque 5/24/2013 18:50'!
requiredAttributes
	^ #( from dimension )! !

!PDFElement methodsFor: 'accessing' stamp: 'OlivierAuverlot 4/2/2013 15:03'!
rotation: anAngle
	self styleSheet rotation: anAngle 
 ! !

!PDFElement methodsFor: 'accessing' stamp: 'guillaumelarcheveque 2/1/2013 14:49'!
styleSheet
	^ styleSheet! !

!PDFElement methodsFor: 'accessing' stamp: 'guillaumelarcheveque 2/1/2013 14:49'!
styleSheet: anObject
	styleSheet := anObject! !

!PDFElement methodsFor: 'style' stamp: 'GuillaumeLarcheveque 3/16/2015 12:17'!
styles
	^ styles! !

!PDFElement methodsFor: 'style' stamp: 'GuillaumeLarcheveque 3/16/2015 12:17'!
styles: anObject
	styles := anObject! !

!PDFElement methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/24/2013 13:56'!
to
	^ self from + self dimension! !

!PDFElement methodsFor: 'size' stamp: 'GuillaumeLarcheveque 7/26/2013 15:21'!
width
	^ self dimension x! !

Object subclass: #PDFFont
	instanceVariableNames: 'bold italic fontSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Fonts'!

!PDFFont commentStamp: '<historical>' prior: 0!
A PDFFont is the abstract class that inherits all usable fonts for creating PDF.

Instance Variables
	bold:		<Object>
	fontSize:		<Object>
	italic:		<Object>
	pdfDocument:		<Object>

bold
	- xxxxx

fontSize
	- xxxxx

italic
	- xxxxx

pdfDocument
	- xxxxx
!

PDFFont subclass: #PDFCourierFont
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Fonts'!

!PDFCourierFont commentStamp: '<historical>' prior: 0!
A PDFCourierFont represent the Courrier font.

Instance Variables
!

!PDFCourierFont methodsFor: 'name' stamp: 'guillaumelarcheveque 2/1/2013 17:40'!
boldAndItalicName  
	^ 'Courier-BoldOblique'! !

!PDFCourierFont methodsFor: 'widths' stamp: 'guillaumelarcheveque 2/1/2013 17:30'!
boldAndItalicWidths
	
	"answer the widths for each characters of the courier font (bold & italic)"
	
	^{ 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 } asOrderedCollection.! !

!PDFCourierFont methodsFor: 'name' stamp: 'guillaumelarcheveque 2/1/2013 17:40'!
boldName
	^ 'Courier-Bold'! !

!PDFCourierFont methodsFor: 'widths' stamp: 'guillaumelarcheveque 2/1/2013 17:27'!
boldWidths
	
	"answer the widths for each characters of the courier font (bold)"
	
	^{ 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 } asOrderedCollection.! !

!PDFCourierFont methodsFor: 'name' stamp: 'guillaumelarcheveque 2/1/2013 17:39'!
classicName 
	^ 'Courier'! !

!PDFCourierFont methodsFor: 'widths' stamp: 'guillaumelarcheveque 2/1/2013 17:31'!
classicWidths
	
	"answer the widths for each characters of the courier font"
	
	^{ 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 } asOrderedCollection.! !

!PDFCourierFont methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/22/2012 21:58'!
family
	^'courier'! !

!PDFCourierFont methodsFor: 'name' stamp: 'guillaumelarcheveque 2/1/2013 17:40'!
italicName 
	^ 'Courier-Oblique'! !

!PDFCourierFont methodsFor: 'widths' stamp: 'guillaumelarcheveque 2/1/2013 17:29'!
italicWidths
	
	"answer the widths for each characters of the courier font italic)"
	
	^{ 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 . 600 } asOrderedCollection.! !

!PDFFont class methodsFor: 'as yet unclassified' stamp: 'GuillaumeLarcheveque 5/31/2013 13:47'!
size: aFontSize
	^ self new fontSize: aFontSize! !

!PDFFont methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 9/20/2013 13:35'!
bold
	self bold: true! !

!PDFFont methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/22/2012 21:37'!
bold: anObject
	bold := anObject! !

!PDFFont methodsFor: 'name' stamp: 'guillaumelarcheveque 2/1/2013 17:38'!
boldAndItalicName
	^ self subclassResponsibility ! !

!PDFFont methodsFor: 'widths' stamp: 'guillaumelarcheveque 2/1/2013 15:54'!
boldAndItalicWidths
	^ self subclassResponsibility! !

!PDFFont methodsFor: 'name' stamp: 'guillaumelarcheveque 2/1/2013 17:38'!
boldName
	^ self subclassResponsibility ! !

!PDFFont methodsFor: 'widths' stamp: 'guillaumelarcheveque 2/1/2013 15:54'!
boldWidths
	^ self subclassResponsibility! !

!PDFFont methodsFor: 'widths' stamp: 'GuillaumeLarcheveque 9/20/2013 13:37'!
charWidths
	"Answer a collection of the width of each caracter"

	^ self isBold
		ifTrue: [ 
			self isItalic
				ifTrue: [ self boldAndItalicWidths ]
				ifFalse: [ self boldWidths ] ]
		ifFalse: [ 
			self isItalic
				ifTrue: [ self italicWidths ]
				ifFalse: [ self classicWidths ] ]! !

!PDFFont methodsFor: 'name' stamp: 'guillaumelarcheveque 2/1/2013 17:38'!
classicName
	^ self subclassResponsibility ! !

!PDFFont methodsFor: 'widths' stamp: 'guillaumelarcheveque 2/1/2013 15:54'!
classicWidths
	^ self subclassResponsibility! !

!PDFFont methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/22/2012 22:00'!
family
	"Answer the family name of the font"
	self subclassResponsibility! !

!PDFFont methodsFor: 'name' stamp: 'GuillaumeLarcheveque 9/20/2013 13:37'!
fontName

	^ self isBold
		ifTrue: [ 
			self isItalic
				ifTrue: [ self boldAndItalicName ]
				ifFalse: [ self boldName ] ]
		ifFalse: [ 
			self isItalic
				ifTrue: [ self italicName ]
				ifFalse: [ self classicName ] ]! !

!PDFFont methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/8/2013 11:08'!
fontSize
	^ fontSize ifNil: [ fontSize := 8 pt ]! !

!PDFFont methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/22/2012 21:37'!
fontSize: anObject
	fontSize := anObject! !

!PDFFont methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/8/2013 11:16'!
fontSizeAsPoints
	^ (self fontSize convertTo: Unit points) value ! !

!PDFFont methodsFor: 'action' stamp: 'GuillaumeLarcheveque 3/15/2013 11:20'!
getCharWidthOf: aChar
	"If the char is not a ascii char, the method return a default width"

	aChar asInteger > 255
		ifTrue: [ ^ 0 pt ]
		ifFalse: [ ^ (self charWidths at: aChar asInteger + 1) / 1000 * self fontSize ]! !

!PDFFont methodsFor: 'action' stamp: 'OlivierAuverlot 5/31/2013 08:09'!
getIdealFontSizeForTheString: aString width: aWidth
	"answer the ideal font size for the specified width. The size of the font is not modified"
	
	| fsize originalFontSize |

	"we preserve the original size"
	originalFontSize := self fontSize.
	
	"width for 1pt height"
	self fontSize: 1pt.
	
	fsize := ((aWidth convertTo: Unit points) / (self getStringWidth: aString)) asInteger pt.
	
	"the original font size will be restored"
	self fontSize: originalFontSize.
	^fsize
	
	! !

!PDFFont methodsFor: 'action' stamp: 'GuillaumeLarcheveque 4/18/2013 16:05'!
getStringWidth: aString
	"answer the width of the string using this font"
	
	^ aString inject: 0 pt 
		into: [:sum :char | sum + (self getCharWidthOf: char)]! !

!PDFFont methodsFor: 'initialization' stamp: 'GuillaumeLarcheveque 9/20/2013 13:39'!
initialize
	super initialize.
	bold := false.
	italic := false.! !

!PDFFont methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 9/20/2013 13:36'!
isBold
	^ bold! !

!PDFFont methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 9/20/2013 13:36'!
isItalic
	^ italic! !

!PDFFont methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 9/20/2013 13:36'!
italic
	self italic: true! !

!PDFFont methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/22/2012 21:37'!
italic: anObject
	italic := anObject! !

!PDFFont methodsFor: 'name' stamp: 'guillaumelarcheveque 2/1/2013 17:38'!
italicName
	^ self subclassResponsibility ! !

!PDFFont methodsFor: 'widths' stamp: 'guillaumelarcheveque 2/1/2013 15:54'!
italicWidths
	^ self subclassResponsibility! !

PDFFont subclass: #PDFHelveticaFont
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Fonts'!

!PDFHelveticaFont commentStamp: '<historical>' prior: 0!
A PDFHelveticaFont represent the Helvetica font

Instance Variables
!

!PDFHelveticaFont methodsFor: 'name' stamp: 'guillaumelarcheveque 2/1/2013 17:43'!
boldAndItalicName
	^ 'Helvetica-BoldOblique'! !

!PDFHelveticaFont methodsFor: 'widths' stamp: 'guillaumelarcheveque 2/1/2013 17:30'!
boldAndItalicWidths
	
	"answer the widths for each characters of the helvetica (bold & italic) font"
	
	^{ 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 333 . 474 . 556 . 556 . 889 . 722 . 238 . 333 . 333 . 389 . 584 . 278 . 333 . 278 . 278 . 556 . 556 . 556 . 556 . 556 . 556 . 556 . 556 . 556 . 556 . 333 . 333 . 584 . 584 . 584 . 611 . 975 . 722 . 722 . 722 . 722 . 667 . 611 . 778 . 722 . 278 . 556 . 722 . 611 . 833 . 722 . 778 . 667 . 778 . 722 . 667 . 611 . 722 . 667 . 944 . 667 . 667 . 611 . 333 . 278 . 333 . 584 . 556 . 333 . 556 . 611 . 556 . 611 . 556 . 333 . 611 . 611 . 278 . 278 . 556 . 278 . 889 . 611 . 611 . 611 . 611 . 389 . 556 . 333 . 611 . 556 . 778 . 556 . 556 . 500 . 389 . 280 . 389 . 584 . 350 . 556 . 350 . 278 . 556 . 500 . 1000 . 556 . 556 . 333 . 1000 . 667 . 333 . 1000 . 350 . 611 . 350 . 350 . 278 . 278 . 500 . 500 . 350 . 556 . 1000 . 333 . 1000 . 556 . 333 . 944 . 350 . 500 . 667 . 278 . 333 . 556 . 556 . 556 . 556 . 280 . 556 . 333 . 737 . 370 . 556 . 584 . 333 . 737 . 333 . 400 . 584 . 333 . 333 . 333 . 611 . 556 . 278 . 333 . 333 . 365 . 556 . 834 . 834 . 834 . 611 . 722 . 722 . 722 . 722 . 722 . 722 . 1000 . 722 . 667 . 667 . 667 . 667 . 278 . 278 . 278 . 278 . 722 . 722 . 778 . 778 . 778 . 778 . 778 . 584 . 778 . 722 . 722 . 722 . 722 . 667 . 667 . 611 . 556 . 556 . 556 . 556 . 556 . 556 . 889 . 556 . 556 . 556 . 556 . 556 . 278 . 278 . 278 . 278 . 611 . 611 . 611 . 611 . 611 . 611 . 611 . 584 . 611 . 611 . 611 . 611 . 611 . 556 . 611 } asOrderedCollection.
	! !

!PDFHelveticaFont methodsFor: 'name' stamp: 'guillaumelarcheveque 2/1/2013 17:43'!
boldName 
	^ 'Helvetica-Bold'! !

!PDFHelveticaFont methodsFor: 'widths' stamp: 'guillaumelarcheveque 2/1/2013 17:27'!
boldWidths
	
	"answer the widths for each characters of the helvetica (bold) font"
	
	^{ 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 333 . 474 . 556 . 556 . 889 . 722 . 238 . 333 . 333 . 389 . 584 . 278 . 333 . 278 . 278 . 556 . 556 . 556 . 556 . 556 . 556 . 556 . 556 . 556 . 556 . 333 . 333 . 584 . 584 . 584 . 611 . 975 . 722 . 722 . 722 . 722 . 667 . 611 . 778 . 722 . 278 . 556 . 722 . 611 . 833 . 722 . 778 . 667 . 778 . 722 . 667 . 611 . 722 . 667 . 944 . 667 . 667 . 611 . 333 . 278 . 333 . 584 . 556 . 333 . 556 . 611 . 556 . 611 . 556 . 333 . 611 . 611 . 278 . 278 . 556 . 278 . 889 . 611 . 611 . 611 . 611 . 389 . 556 . 333 . 611 . 556 . 778 . 556 . 556 . 500 . 389 . 280 . 389 . 584 . 350 . 556 . 350 . 278 . 556 . 500 . 1000 . 556 . 556 . 333 . 1000 . 667 . 333 . 1000 . 350 . 611 . 350 . 350 . 278 . 278 . 500 . 500 . 350 . 556 . 1000 . 333 . 1000 . 556 . 333 . 944 . 350 . 500 . 667 . 278 . 333 . 556 . 556 . 556 . 556 . 280 . 556 . 333 . 737 . 370 . 556 . 584 . 333 . 737 . 333 . 400 . 584 . 333 . 333 . 333 . 611 . 556 . 278 . 333 . 333 . 365 . 556 . 834 . 834 . 834 . 611 . 722 . 722 . 722 . 722 . 722 . 722 . 1000 . 722 . 667 . 667 . 667 . 667 . 278 . 278 . 278 . 278 . 722 . 722 . 778 . 778 . 778 . 778 . 778 . 584 . 778 . 722 . 722 . 722 . 722 . 667 . 667 . 611 . 556 . 556 . 556 . 556 . 556 . 556 . 889 . 556 . 556 . 556 . 556 . 556 . 278 . 278 . 278 . 278 . 611 . 611 . 611 . 611 . 611 . 611 . 611 . 584 . 611 . 611 . 611 . 611 . 611 . 556 . 611 } asOrderedCollection.
	! !

!PDFHelveticaFont methodsFor: 'name' stamp: 'guillaumelarcheveque 2/1/2013 17:42'!
classicName 
	^ 'Helvetica'! !

!PDFHelveticaFont methodsFor: 'widths' stamp: 'guillaumelarcheveque 2/1/2013 17:31'!
classicWidths
	
	"answer the widths for each characters of the helvetica font"

	^{ 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 355 . 556 . 556 . 889 . 667 . 191 . 333 . 333 . 389 . 584 . 278 . 333 . 278 . 278 . 556 . 556 . 556 . 556 . 556 . 556 . 556 . 556 . 556 . 556 . 278 . 278 . 584 . 584 . 584 . 556 . 1015 . 667 . 667 . 722 . 722 . 667 . 611 . 778 . 722 . 278 . 500 . 667 . 556 . 833 . 722 . 778 . 667 . 778 . 722 . 667 . 611 . 722 . 667 . 944 . 667 . 667 . 611 . 278 . 278 . 278 . 469 . 556 . 333 . 556 . 556 . 500 . 556 . 556 . 278 . 556 . 556 . 222 . 222 . 500 . 222 . 833 . 556 . 556 . 556 . 556 . 333 . 500 . 278 . 556 . 500 . 722 . 500 . 500 . 500 . 334 . 260 . 334 . 584 . 350 . 556 . 350 . 222 . 556 . 333 . 1000 . 556 . 556 . 333 . 1000 . 667 . 333 . 1000 . 350 . 611 . 350 . 350 . 222 . 222 . 333 . 333 . 350 . 556 . 1000 . 333 . 1000 . 500 . 333 . 944 . 350 . 500 . 667 . 278 . 333 . 556 . 556 . 556 . 556 . 260 . 556 . 333 . 737 . 370 . 556 . 584 . 333 . 737 . 333 . 400 . 584 . 333 . 333 . 333 . 556 . 537 . 278 . 333 . 333 . 365 . 556 . 834 . 834 . 834 . 611 . 667 . 667 . 667 . 667 . 667 . 667 . 1000 . 722 . 667 . 667 . 667 . 667 . 278 . 278 . 278 . 278 . 722 . 722 . 778 . 778 . 778 . 778 . 778 . 584 . 778 . 722 . 722 . 722 . 722 . 667 . 667 . 611 . 556 . 556 . 556 . 556 . 556 . 556 . 889 . 500 . 556 . 556 . 556 . 556 . 278 . 278 . 278 . 278 . 556 . 556 . 556 . 556 . 556 . 556 . 556 . 584 . 611 . 556 . 556 . 556 . 556 . 500 . 556 } asOrderedCollection.! !

!PDFHelveticaFont methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/22/2012 21:58'!
family
	^'helvetica'! !

!PDFHelveticaFont methodsFor: 'name' stamp: 'guillaumelarcheveque 2/1/2013 17:43'!
italicName  
	^ 'Helvetica-Oblique'! !

!PDFHelveticaFont methodsFor: 'widths' stamp: 'guillaumelarcheveque 2/1/2013 17:30'!
italicWidths
	
	"answer the widths for each characters of the helvetica (italic) font"
	
	^{ 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 278 . 355 . 556 . 556 . 889 . 667 . 191 . 333 . 333 . 389 . 584 . 278 . 333 . 278 . 278 . 556 . 556 . 556 . 556 . 556 . 556 . 556 . 556 . 556 . 556 . 278 . 278 . 584 . 584 . 584 . 556 . 1015 . 667 . 667 . 722 . 722 . 667 . 611 . 778 . 722 . 278 . 500 . 667 . 556 . 833 . 722 . 778 . 667 . 778 . 722 . 667 . 611 . 722 . 667 . 944 . 667 . 667 . 611 . 278 . 278 . 278 . 469 . 556 . 333 . 556 . 556 . 500 . 556 . 556 . 278 . 556 . 556 . 222 . 222 . 500 . 222 . 833 . 556 . 556 . 556 . 556 . 333 . 500 . 278 . 556 . 500 . 722 . 500 . 500 . 500 . 334 . 260 . 334 . 584 . 350 . 556 . 350 . 222 . 556 . 333 . 1000 . 556 . 556 . 333 . 1000 . 667 . 333 . 1000 . 350 . 611 . 350 . 350 . 222 . 222 . 333 . 333 . 350 . 556 . 1000 . 333 . 1000 . 500 . 333 . 944 . 350 . 500 . 667 . 278 . 333 . 556 . 556 . 556 . 556 . 260 . 556 . 333 . 737 . 370 . 556 . 584 . 333 . 737 . 333 . 400 . 584 . 333 . 333 . 333 . 556 . 537 . 278 . 333 . 333 . 365 . 556 . 834 . 834 . 834 . 611 . 667 . 667 . 667 . 667 . 667 . 667 . 1000 . 722 . 667 . 667 . 667 . 667 . 278 . 278 . 278 . 278 . 722 . 722 . 778 . 778 . 778 . 778 . 778 . 584 . 778 . 722 . 722 . 722 . 722 . 667 . 667 . 611 . 556 . 556 . 556 . 556 . 556 . 556 . 889 . 500 . 556 . 556 . 556 . 556 . 278 . 278 . 278 . 278 . 556 . 556 . 556 . 556 . 556 . 556 . 556 . 584 . 611 . 556 . 556 . 556 . 556 . 500 . 556 } asOrderedCollection.
	! !

PDFFont subclass: #PDFSymbolFont
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Fonts'!

!PDFSymbolFont commentStamp: '<historical>' prior: 0!
A PDFSymbolFont represent the Symbol font

Instance Variables
!

!PDFSymbolFont methodsFor: 'widths' stamp: 'guillaumelarcheveque 2/1/2013 17:49'!
charWidths
	
	"answer the widths for each characters of the symbol font"
	
	^{ 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 333 . 713 . 500 . 549 . 833 . 778 . 439 . 333 . 333 . 500 . 549 . 250 . 549 . 250 . 278 . 500 . 500 . 500 . 500 . 500 . 500 . 500 . 500 . 500 . 500 . 278 . 278 . 549 . 549 . 549 . 444 . 549 . 722 . 667 . 722 . 612 . 611 . 763 . 603 . 722 . 333 . 631 . 722 . 686 . 889 . 722 . 722 . 768 . 741 . 556 . 592 . 611 . 690 . 439 . 768 . 645 . 795 . 611 . 333 . 863 . 333 . 658 . 500 . 500 . 631 . 549 . 549 . 494 . 439 . 521 . 411 . 603 . 329 . 603 . 549 . 549 . 576 . 521 . 549 . 549 . 521 . 549 . 603 . 439 . 576 . 713 . 686 . 493 . 686 . 494 . 480 . 200 . 480 . 549 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 750 . 620 . 247 . 549 . 167 . 713 . 500 . 753 . 753 . 753 . 753 . 1042 . 987 . 603 . 987 . 603 . 400 . 549 . 411 . 549 . 549 . 713 . 494 . 460 . 549 . 549 . 549 . 549 . 1000 . 603 . 1000 . 658 . 823 . 686 . 795 . 987 . 768 . 768 . 823 . 768 . 768 . 713 . 713 . 713 . 713 . 713 . 713 . 713 . 768 . 713 . 790 . 790 . 890 . 823 . 549 . 250 . 713 . 603 . 603 . 1042 . 987 . 603 . 987 . 603 . 494 . 329 . 790 . 790 . 786 . 713 . 384 . 384 . 384 . 384 . 384 . 384 . 494 . 494 . 494 . 494 . 0 . 329 . 274 . 686 . 686 . 686 . 384 . 384 . 384 . 384 . 384 . 384 . 494 . 494 . 494 } asOrderedCollection.! !

!PDFSymbolFont methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/22/2012 21:59'!
family
	^'symbol'! !

!PDFSymbolFont methodsFor: 'name' stamp: 'guillaumelarcheveque 2/1/2013 17:48'!
fontName 
	^ 'Symbol'! !

PDFFont subclass: #PDFTimesFont
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Fonts'!

!PDFTimesFont commentStamp: '<historical>' prior: 0!
A PDFTimesFont represent the Times font

Instance Variables
!

!PDFTimesFont methodsFor: 'name' stamp: 'guillaumelarcheveque 2/1/2013 17:48'!
boldAndItalicName    
	^ 'Times-BoldItalic' ! !

!PDFTimesFont methodsFor: 'widths' stamp: 'guillaumelarcheveque 2/1/2013 17:31'!
boldAndItalicWidths
	
	"answer the widths for each characters of the Times font (bold & italic)"
	
	^{ 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 389 . 555 . 500 . 500 . 833 . 778 . 278 . 333 . 333 . 500 . 570 . 250 . 333 . 250 . 278 . 500 . 500 . 500 . 500 . 500 . 500 . 500 . 500 . 500 . 500 . 333 . 333 . 570 . 570 . 570 . 500 . 832 . 667 . 667 . 667 . 722 . 667 . 667 . 722 . 778 . 389 . 500 . 667 . 611 . 889 . 722 . 722 . 611 . 722 . 667 . 556 . 611 . 722 . 667 . 889 . 667 . 611 . 611 . 333 . 278 . 333 . 570 . 500 . 333 . 500 . 500 . 444 . 500 . 444 . 333 . 500 . 556 . 278 . 278 . 500 . 278 . 778 . 556 . 500 . 500 . 500 . 389 . 389 . 278 . 556 . 444 . 667 . 500 . 444 . 389 . 348 . 220 . 348 . 570 . 350 . 500 . 350 . 333 . 500 . 500 . 1000 . 500 . 500 . 333 . 1000 . 556 . 333 . 944 . 350 . 611 . 350 . 350 . 333 . 333 . 500 . 500 . 350 . 500 . 1000 . 333 . 1000 . 389 . 333 . 722 . 350 . 389 . 611 . 250 . 389 . 500 . 500 . 500 . 500 . 220 . 500 . 333 . 747 . 266 . 500 . 606 . 333 . 747 . 333 . 400 . 570 . 300 . 300 . 333 . 576 . 500 . 250 . 333 . 300 . 300 . 500 . 750 . 750 . 750 . 500 . 667 . 667 . 667 . 667 . 667 . 667 . 944 . 667 . 667 . 667 . 667 . 667 . 389 . 389 . 389 . 389 . 722 . 722 . 722 . 722 . 722 . 722 . 722 . 570 . 722 . 722 . 722 . 722 . 722 . 611 . 611 . 500 . 500 . 500 . 500 . 500 . 500 . 500 . 722 . 444 . 444 . 444 . 444 . 444 . 278 . 278 . 278 . 278 . 500 . 556 . 500 . 500 . 500 . 500 . 500 . 570 . 500 . 556 . 556 . 556 . 556 . 444 . 500 } asOrderedCollection.! !

!PDFTimesFont methodsFor: 'name' stamp: 'guillaumelarcheveque 2/1/2013 17:47'!
boldName   
	^ 'Times-Bold'! !

!PDFTimesFont methodsFor: 'widths' stamp: 'guillaumelarcheveque 2/1/2013 17:28'!
boldWidths
	
	"answer the widths for each characters of the Times font (bold)"
	
	^{ 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 333 . 555 . 500 . 500 . 1000 . 833 . 278 . 333 . 333 . 500 . 570 . 250 . 333 . 250 . 278 . 500 . 500 . 500 . 500 . 500 . 500 . 500 . 500 . 500 . 500 . 333 . 333 . 570 . 570 . 570 . 500 . 930 . 722 . 667 . 722 . 722 . 667 . 611 . 778 . 778 . 389 . 500 . 778 . 667 . 944 . 722 . 778 . 611 . 778 . 722 . 556 . 667 . 722 . 722 . 1000 . 722 . 722 . 667 . 333 . 278 . 333 . 581 . 500 . 333 . 500 . 556 . 444 . 556 . 444 . 333 . 500 . 556 . 278 . 333 . 556 . 278 . 833 . 556 . 500 . 556 . 556 . 444 . 389 . 333 . 556 . 500 . 722 . 500 . 500 . 444 . 394 . 220 . 394 . 520 . 350 . 500 . 350 . 333 . 500 . 500 . 1000 . 500 . 500 . 333 . 1000 . 556 . 333 . 1000 . 350 . 667 . 350 . 350 . 333 . 333 . 500 . 500 . 350 . 500 . 1000 . 333 . 1000 . 389 . 333 . 722 . 350 . 444 . 722 . 250 . 333 . 500 . 500 . 500 . 500 . 220 . 500 . 333 . 747 . 300 . 500 . 570 . 333 . 747 . 333 . 400 . 570 . 300 . 300 . 333 . 556 . 540 . 250 . 333 . 300 . 330 . 500 . 750 . 750 . 750 . 500 . 722 . 722 . 722 . 722 . 722 . 722 . 1000 . 722 . 667 . 667 . 667 . 667 . 389 . 389 . 389 . 389 . 722 . 722 . 778 . 778 . 778 . 778 . 778 . 570 . 778 . 722 . 722 . 722 . 722 . 722 . 611 . 556 . 500 . 500 . 500 . 500 . 500 . 500 . 722 . 444 . 444 . 444 . 444 . 444 . 278 . 278 . 278 . 278 . 500 . 556 . 500 . 500 . 500 . 500 . 500 . 570 . 500 . 556 . 556 . 556 . 556 . 500 . 556 } asOrderedCollection.! !

!PDFTimesFont methodsFor: 'name' stamp: 'guillaumelarcheveque 2/1/2013 17:47'!
classicName 
	^ 'Times-Roman'! !

!PDFTimesFont methodsFor: 'widths' stamp: 'guillaumelarcheveque 2/1/2013 17:31'!
classicWidths
	
	"answer the widths for each characters of the Times font"
	
	^{ 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 333 . 408 . 500 . 500 . 833 . 778 . 180 . 333 . 333 . 500 . 564 . 250 . 333 . 250 . 278 . 500 . 500 . 500 . 500 . 500 . 500 . 500 . 500 . 500 . 500 . 278 . 278 . 564 . 564 . 564 . 444 . 921 . 722 . 667 . 667 . 722 . 611 . 556 . 722 . 722 . 333 . 389 . 722 . 611 . 889 . 722 . 722 . 556 . 722 . 667 . 556 . 611 . 722 . 722 . 944 . 722 . 722 . 611 . 333 . 278 . 333 . 469 . 500 . 333 . 444 . 500 . 444 . 500 . 444 . 333 . 500 . 500 . 278 . 278 . 500 . 278 . 778 . 500 . 500 . 500 . 500 . 333 . 389 . 278 . 500 . 500 . 722 . 500 . 500 . 444 . 480 . 200 . 480 . 541 . 350 . 500 . 350 . 333 . 500 . 444 . 1000 . 500 . 500 . 333 . 1000 . 556 . 333 . 889 . 350 . 611 . 350 . 350 . 333 . 333 . 444 . 444 . 350 . 500 . 1000 . 333 . 980 . 389 . 333 . 722 . 350 . 444 . 722 . 250 . 333 . 500 . 500 . 500 . 500 . 200 . 500 . 333 . 760 . 276 . 500 . 564 . 333 . 760 . 333 . 400 . 564 . 300 . 300 . 333 . 500 . 453 . 250 . 333 . 300 . 310 . 500 . 750 . 750 . 750 . 444 . 722 . 722 . 722 . 722 . 722 . 722 . 889 . 667 . 611 . 611 . 611 . 611 . 333 . 333 . 333 . 333 . 722 . 722 . 722 . 722 . 722 . 722 . 722 . 564 . 722 . 722 . 722 . 722 . 722 . 722 . 556 . 500 . 444 . 444 . 444 . 444 . 444 . 444 . 667 . 444 . 444 . 444 . 444 . 444 . 278 . 278 . 278 . 278 . 500 . 500 . 500 . 500 . 500 . 500 . 500 . 564 . 500 . 500 . 500 . 500 . 500 . 500 . 500 } asOrderedCollection.! !

!PDFTimesFont methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/22/2012 21:59'!
family
	^'times'! !

!PDFTimesFont methodsFor: 'name' stamp: 'guillaumelarcheveque 2/1/2013 17:47'!
italicName  
	^ 'Times-Oblique'! !

!PDFTimesFont methodsFor: 'widths' stamp: 'guillaumelarcheveque 2/1/2013 17:30'!
italicWidths
	
	"answer the widths for each characters of the Times font (italic)"
	
	^{ 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 250 . 333 . 420 . 500 . 500 . 833 . 778 . 214 . 333 . 333 . 500 . 675 . 250 . 333 . 250 . 278 . 500 . 500 . 500 . 500 . 500 . 500 . 500 . 500 . 500 . 500 . 333 . 333 . 675 . 675 . 675 . 500 . 920 . 611 . 611 . 667 . 722 . 611 . 611 . 722 . 722 . 333 . 444 . 667 . 556 . 833 . 667 . 722 . 611 . 722 . 611 . 500 . 556 . 722 . 611 . 833 . 611 . 556 . 556 . 389 . 278 . 389 . 422 . 500 . 333 . 500 . 500 . 444 . 500 . 444 . 278 . 500 . 500 . 278 . 278 . 444 . 278 . 722 . 500 . 500 . 500 . 500 . 389 . 389 . 278 . 500 . 444 . 667 . 444 . 444 . 389 . 400 . 275 . 400 . 541 . 350 . 500 . 350 . 333 . 500 . 556 . 889 . 500 . 500 . 333 . 1000 . 500 . 333 . 944 . 350 . 556 . 350 . 350 . 333 . 333 . 556 . 556 . 350 . 500 . 889 . 333 . 980 . 389 . 333 . 667 . 350 . 389 . 556 . 250 . 389 . 500 . 500 . 500 . 500 . 275 . 500 . 333 . 760 . 276 . 500 . 675 . 333 . 760 . 333 . 400 . 675 . 300 . 300 . 333 . 500 . 523 . 250 . 333 . 300 . 310 . 500 . 750 . 750 . 750 . 500 . 611 . 611 . 611 . 611 . 611 . 611 . 889 . 667 . 611 . 611 . 611 . 611 . 333 . 333 . 333 . 333 . 722 . 667 . 722 . 722 . 722 . 722 . 722 . 675 . 722 . 722 . 722 . 722 . 722 . 556 . 611 . 500 . 500 . 500 . 500 . 500 . 500 . 500 . 667 . 444 . 444 . 444 . 444 . 444 . 278 . 278 . 278 . 278 . 500 . 500 . 500 . 500 . 500 . 500 . 500 . 675 . 500 . 500 . 500 . 500 . 500 . 444 . 500 } asOrderedCollection.
	! !

PDFFont subclass: #PDFZapfdingbatsFont
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Fonts'!

!PDFZapfdingbatsFont commentStamp: '<historical>' prior: 0!
A PDFZapfdingbatsFont represent the Zapfdingbats font

Instance Variables
!

!PDFZapfdingbatsFont methodsFor: 'widths' stamp: 'guillaumelarcheveque 2/1/2013 17:50'!
charWidths
	
	"answer the widths for each characters of the zapfdingbats font"
	
	^{ 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 278 . 974 . 961 . 974 . 980 . 719 . 789 . 790 . 791 . 690 . 960 . 939 . 549 . 855 . 911 . 933 . 911 . 945 . 974 . 755 . 846 . 762 . 761 . 571 . 677 . 763 . 760 . 759 . 754 . 494 . 552 . 537 . 577 . 692 . 786 . 788 . 788 . 790 . 793 . 794 . 816 . 823 . 789 . 841 . 823 . 833 . 816 . 831 . 923 . 744 . 723 . 749 . 790 . 792 . 695 . 776 . 768 . 792 . 759 . 707 . 708 . 682 . 701 . 826 . 815 . 789 . 789 . 707 . 687 . 696 . 689 . 786 . 787 . 713 . 791 . 785 . 791 . 873 . 761 . 762 . 762 . 759 . 759 . 892 . 892 . 788 . 784 . 438 . 138 . 277 . 415 . 392 . 392 . 668 . 668 . 0 . 390 . 390 . 317 . 317 . 276 . 276 . 509 . 509 . 410 . 410 . 234 . 234 . 334 . 334 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 0 . 732 . 544 . 544 . 910 . 667 . 760 . 760 . 776 . 595 . 694 . 626 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 788 . 894 . 838 . 1016 . 458 . 748 . 924 . 748 . 918 . 927 . 928 . 928 . 834 . 873 . 828 . 924 . 924 . 917 . 930 . 931 . 463 . 883 . 836 . 836 . 867 . 867 . 696 . 696 . 874 . 0 . 874 . 760 . 946 . 771 . 865 . 771 . 888 . 967 . 888 . 831 . 873 . 927 . 970 . 918 } asOrderedCollection.! !

!PDFZapfdingbatsFont methodsFor: 'accessing' stamp: 'OlivierAuverlot 2/22/2012 21:59'!
family
	^'zapfdingbats'! !

!PDFZapfdingbatsFont methodsFor: 'name' stamp: 'guillaumelarcheveque 2/1/2013 17:48'!
fontName
	^ 'ZapfDingbats' ! !

Object subclass: #PDFFormat
	instanceVariableNames: 'portrait margins size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Formats'!

!PDFFormat commentStamp: 'OlivierAuverlot 8/5/2012 19:04' prior: 0!
PDFFormat has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	portrait	<ProtoObject>
	margins	<Point | TTPoint>
	size	<Point | TTPoint>
		
	28,347619048
	!

PDFFormat subclass: #PDFA0Format
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Formats'!

!PDFA0Format commentStamp: 'TorstenBergmann 12/30/2013 10:17' prior: 0!
The A0 paper format!

!PDFA0Format methodsFor: 'defaults' stamp: 'GuillaumeLarcheveque 3/1/2013 11:16'!
defaultSize
	^ 2384.03 point @ 3370.53 point! !

PDFFormat subclass: #PDFA10Format
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Formats'!

!PDFA10Format commentStamp: 'TorstenBergmann 12/30/2013 10:17' prior: 0!
The A10 paper format!

!PDFA10Format methodsFor: 'defaults' stamp: 'GuillaumeLarcheveque 3/1/2013 11:20'!
defaultSize
	^ 73.7 point @ 104.88 point! !

PDFFormat subclass: #PDFA1Format
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Formats'!

!PDFA1Format commentStamp: 'TorstenBergmann 12/30/2013 10:17' prior: 0!
The A1 paper format!

!PDFA1Format methodsFor: 'defaults' stamp: 'GuillaumeLarcheveque 3/1/2013 11:17'!
defaultSize
	^ 1683.84 point @ 2384.03 point! !

PDFFormat subclass: #PDFA2Format
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Formats'!

!PDFA2Format commentStamp: 'TorstenBergmann 12/30/2013 10:17' prior: 0!
The A2 paper format!

!PDFA2Format methodsFor: 'defaults' stamp: 'GuillaumeLarcheveque 3/1/2013 11:17'!
defaultSize
	^ 1190.55 point @ 1683.84 point! !

PDFFormat subclass: #PDFA3Format
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Formats'!

!PDFA3Format commentStamp: 'TorstenBergmann 12/30/2013 10:17' prior: 0!
The A3 paper format!

!PDFA3Format methodsFor: 'defaults' stamp: 'GuillaumeLarcheveque 3/1/2013 11:17'!
defaultSize
	^ 841.89 point @ 1190.55 point! !

PDFFormat subclass: #PDFA4Format
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Formats'!

!PDFA4Format commentStamp: 'TorstenBergmann 12/30/2013 10:18' prior: 0!
The A4 paper format!

!PDFA4Format methodsFor: 'defaults' stamp: 'GuillaumeLarcheveque 3/1/2013 11:17'!
defaultSize
	^ 595.3 point @ 841.9 point! !

PDFFormat subclass: #PDFA5Format
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Formats'!

!PDFA5Format commentStamp: 'TorstenBergmann 12/30/2013 10:18' prior: 0!
The A5 paper format!

!PDFA5Format methodsFor: 'defaults' stamp: 'GuillaumeLarcheveque 3/1/2013 11:18'!
defaultSize
	^ 420.94 point @ 595.28 point! !

PDFFormat subclass: #PDFA6Format
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Formats'!

!PDFA6Format commentStamp: 'TorstenBergmann 12/30/2013 10:18' prior: 0!
The A6 paper format!

!PDFA6Format methodsFor: 'defaults' stamp: 'GuillaumeLarcheveque 3/1/2013 11:18'!
defaultSize
	^ 297.65 point @ 419.54 point! !

PDFFormat subclass: #PDFA7Format
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Formats'!

!PDFA7Format commentStamp: 'TorstenBergmann 12/30/2013 10:19' prior: 0!
The A7 paper format!

!PDFA7Format methodsFor: 'defaults' stamp: 'GuillaumeLarcheveque 3/1/2013 11:18'!
defaultSize
	^ 209.77 point @ 297.65 point! !

PDFFormat subclass: #PDFA8Format
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Formats'!

!PDFA8Format commentStamp: 'TorstenBergmann 12/30/2013 10:19' prior: 0!
The A8 paper format!

!PDFA8Format methodsFor: 'defaults' stamp: 'GuillaumeLarcheveque 3/1/2013 11:19'!
defaultSize
	^ 147.4 point @ 209.77 point! !

PDFFormat subclass: #PDFA9Format
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Formats'!

!PDFA9Format commentStamp: 'TorstenBergmann 12/30/2013 10:19' prior: 0!
The A9 paper format!

!PDFA9Format methodsFor: 'defaults' stamp: 'GuillaumeLarcheveque 3/1/2013 11:19'!
defaultSize
	^ 104.88 point @ 147.4 point! !

PDFFormat subclass: #PDFEbookFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Formats'!

!PDFEbookFormat commentStamp: 'TorstenBergmann 12/30/2013 10:19' prior: 0!
The EBook format!

!PDFEbookFormat methodsFor: 'defaults' stamp: 'GuillaumeLarcheveque 3/1/2013 11:19'!
defaultSize
	^ 324 point @ 431.9 point! !

!PDFFormat methodsFor: 'defaults' stamp: 'TorstenBergmann 1/10/2014 16:26'!
defaultMargins

	^28.35 point @ 28.35 point! !

!PDFFormat methodsFor: 'defaults' stamp: 'TorstenBergmann 1/10/2014 16:26'!
defaultSize

	^ self subclassResponsibility ! !

!PDFFormat methodsFor: 'description' stamp: 'OlivierAuverlot 2/17/2012 12:48'!
height
	"Answer the height of a page"
	^self size y! !

!PDFFormat methodsFor: 'initialize-release' stamp: 'TorstenBergmann 1/10/2014 16:25'!
initialize
	super initialize.
	self margins: self defaultMargins.
	self size: self defaultSize.
	self setPortrait! !

!PDFFormat methodsFor: 'description' stamp: 'OlivierAuverlot 3/14/2012 14:54'!
leftMargin
	^(self margins x)! !

!PDFFormat methodsFor: 'accessing' stamp: 'OlivierAuverlot 3/14/2012 13:58'!
margins
	^ margins! !

!PDFFormat methodsFor: 'accessing' stamp: 'OlivierAuverlot 3/14/2012 13:58'!
margins: anObject
	margins := anObject! !

!PDFFormat methodsFor: 'accessing' stamp: 'OlivierAuverlot 3/14/2012 14:03'!
portrait
	^ portrait! !

!PDFFormat methodsFor: 'accessing' stamp: 'OlivierAuverlot 3/14/2012 14:03'!
portrait: anObject
	portrait := anObject! !

!PDFFormat methodsFor: 'page setup' stamp: 'OlivierAuverlot 3/14/2012 14:13'!
setLandscape
	"Set the page in landscape orientation"
	self portrait: false.
	self size: (self size y) @ (self size x).	! !

!PDFFormat methodsFor: 'page setup' stamp: 'OlivierAuverlot 3/20/2012 22:27'!
setPortrait
	"Set the page in portrait orientation"
	self portrait: true.
	self size: (self size x) @ (self size y). 
! !

!PDFFormat methodsFor: 'accessing' stamp: 'OlivierAuverlot 3/14/2012 14:02'!
size
	^ size! !

!PDFFormat methodsFor: 'accessing' stamp: 'OlivierAuverlot 3/14/2012 14:02'!
size: anObject
	size := anObject! !

!PDFFormat methodsFor: 'description' stamp: 'OlivierAuverlot 3/14/2012 14:54'!
topMargin
	^(self margins y)! !

!PDFFormat methodsFor: 'description' stamp: 'OlivierAuverlot 2/17/2012 12:47'!
width
	"Answer the width of the page"
	^self size x! !

PDFFormat subclass: #PDFLetterFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Formats'!

!PDFLetterFormat commentStamp: 'TorstenBergmann 12/30/2013 10:21' prior: 0!
The letter format!

!PDFLetterFormat methodsFor: 'defaults' stamp: 'GuillaumeLarcheveque 3/1/2013 11:19'!
defaultSize
	^ 612 point @ 1008 point! !

Object subclass: #PDFGenerator
	instanceVariableNames: 'currentObjectNumber document usedFonts xref currentPage currentFontId usedImages currentImageId currentOpacityId usedOpacities compression firstPage displayLayout displayMode zoom'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Generator'!

!PDFGenerator commentStamp: '<historical>' prior: 0!
A PDFGenerator has the responsibility to transform a PDFDocument and all the PDFElement inside into many PDFDataType.

Instance Variables
!

!PDFGenerator methodsFor: 'accessing' stamp: 'OlivierAuverlot 4/3/2013 11:57'!
compression
	^compression! !

!PDFGenerator methodsFor: 'accessing' stamp: 'OlivierAuverlot 4/3/2013 11:58'!
compression: aBoolean
	compression := aBoolean! !

!PDFGenerator methodsFor: 'conversion' stamp: 'GuillaumeLarcheveque 3/1/2013 17:06'!
convertToPoints: aUnitValue 
	^ (aUnitValue convertTo: #points) value
	! !

!PDFGenerator methodsFor: 'font' stamp: 'GuillaumeLarcheveque 3/1/2013 15:20'!
createFontObject: aFontName
	| fontObject |
	fontObject := self createNewPDFDataObject.
	fontObject
		addContent:
			(PDFDataAssociativeArray new
				add: (PDFDataCouple key: (PDFDataSymbol symbol: 'Type') value: (PDFDataSymbol symbol: 'Font'));
				add: (PDFDataCouple key: (PDFDataSymbol symbol: 'Subtype') value: (PDFDataSymbol symbol: 'Type1'));
				add: (PDFDataCouple key: (PDFDataSymbol symbol: 'BaseFont') value: (PDFDataSymbol symbol: aFontName));
				add: (PDFDataCouple key: (PDFDataSymbol symbol: 'Encoding') value: (PDFDataSymbol symbol: 'WinAnsiEncoding'));
				yourself).
	^ fontObject! !

!PDFGenerator methodsFor: 'image' stamp: 'OlivierAuverlot 3/29/2013 10:42'!
createImageObject: anImageStream
	| imageObject imageStream readWriter |
	self flag: 'Only works with JPEG'.
	imageObject := self createNewPDFDataObject.
	readWriter := (JPEGReadWriter on: anImageStream) nextImage; yourself.
	imageStream := PDFDataXObjectStream stream: anImageStream.
	imageObject
		addContent:
			(PDFDataAssociativeArray new
				add: (PDFDataCouple key: (PDFDataSymbol symbol: 'Type') value: (PDFDataSymbol symbol: 'XObject'));
				add: (PDFDataCouple key: (PDFDataSymbol symbol: 'Subtype') value: (PDFDataSymbol symbol: 'Image'));
				add: (PDFDataCouple key: (PDFDataSymbol symbol: 'Width') value: (PDFDataValue value: readWriter width));
				add: (PDFDataCouple key: (PDFDataSymbol symbol: 'Height') value: (PDFDataValue value: readWriter height));
				add: (PDFDataCouple key: (PDFDataSymbol symbol: 'ColorSpace') value: (PDFDataSymbol symbol: 'DeviceRGB'));
				add: (PDFDataCouple key: (PDFDataSymbol symbol: 'Filter') value: (PDFDataSymbol symbol: 'DCTDecode'));
				add:
						(PDFDataCouple key: (PDFDataSymbol symbol: 'BitsPerComponent') value: (PDFDataValue value: readWriter dataPrecision));
				add: (PDFDataCouple key: (PDFDataSymbol symbol: 'Length') value: (PDFDataValue value: imageStream stream size));
				yourself);
		addContent: imageStream.
	^ imageObject! !

!PDFGenerator methodsFor: 'section' stamp: 'AntoanHristov 3/3/2017 17:02'!
createMetaDataObject: aMetaData
	| metadataObject |
	metadataObject := self createNewPDFDataObject.
	
	metadataObject
		addContent:
			(PDFDataAssociativeArray new
				add: (PDFDataCouple key: (PDFDataSymbol symbol: 'Producer') value: (PDFDataString text: (aMetaData producer)));
				add: (PDFDataCouple key: (PDFDataSymbol symbol: 'Title') value: (PDFDataString text: (aMetaData title)));
				add: (PDFDataCouple key: (PDFDataSymbol symbol: 'Subject') value: (PDFDataString text: (aMetaData subject)));
				add: (PDFDataCouple key: (PDFDataSymbol symbol: 'Author') value: (PDFDataString text: (aMetaData author)));
				add: (PDFDataCouple key: (PDFDataSymbol symbol: 'Keywords') value: (PDFDataString text: (aMetaData keywords)));
				add: (PDFDataCouple key: (PDFDataSymbol symbol: 'Creator') value: (PDFDataString text: (aMetaData creator)));
				add: (PDFDataCouple key: (PDFDataSymbol symbol: 'CreationDate') value: (PDFDataDateAndTime date: (aMetaData date) time: (aMetaData time)));
				yourself).
	^ metadataObject! !

!PDFGenerator methodsFor: 'action' stamp: 'guillaumelarcheveque 2/15/2013 14:02'!
createNewPDFDataObject
	| object |
	currentObjectNumber := currentObjectNumber + 1.
	object := PDFDataObject new
		id: currentObjectNumber;
		revision: 0;
		yourself.
	xref AddReferenceTo: object.
	^ object! !

!PDFGenerator methodsFor: 'opacity' stamp: 'OlivierAuverlot 1/18/2014 18:26'!
createOpacityObject: aOpacityObject
	| opacityObject |
	opacityObject := self createNewPDFDataObject.
	opacityObject
		addContent:
			(PDFDataAssociativeArray new
				add: (PDFDataCouple key: (PDFDataSymbol symbol: 'Type') value: (PDFDataSymbol symbol: 'ExtGState'));
				add: (PDFDataCouple key: (PDFDataSymbol symbol: 'ca ') value: (PDFDataValue value: aOpacityObject alpha));
				add: (PDFDataCouple key: (PDFDataSymbol symbol: 'CA') value: (PDFDataValue value: aOpacityObject alpha));
				add: (PDFDataCouple key: (PDFDataSymbol symbol: 'BM') value: (PDFDataSymbol symbol: (aOpacityObject blendMode)));
				yourself).
	^ opacityObject! !

!PDFGenerator methodsFor: 'action' stamp: 'OlivierAuverlot 5/19/2014 09:55'!
createPDFDataStreamFrom: aPage
	^ PDFDataStream
		codeSegment:
			(PDFCompositeCodeSegment
				from:
					(aPage elements collect: [ :anElement | anElement generateWith: self styleSheet: aPage styleSheet format: aPage format ])
				styleSheet: aPage styleSheet)! !

!PDFGenerator methodsFor: 'section' stamp: 'OlivierAuverlot 4/16/2013 12:33'!
createRootObject
	| rootObject content |
	rootObject := self createNewPDFDataObject.
	content := PDFDataAssociativeArray new 
		add: (PDFDataCouple key: (PDFDataSymbol symbol: 'Type') value: (PDFDataSymbol symbol: 'Catalog'));
		add: (PDFDataCouple key: (PDFDataSymbol symbol: 'Pages') value: (PDFDataReference reference: document)).
		
		(self zoom ~= nil)
			ifTrue: [  
				"We use the zoom value" 
				content add: (self generateZoom).
			]
			ifFalse: [  
				"we use the selected display mode"
				(self displayMode ~= #defaultDisplayMode) ifTrue: [ content add: (self generateDisplayMode) ]
			].	
		"add: (PDFDataCouple key: (PDFDataSymbol symbol: 'OpenAction') value: (PDFDataArray from: { 
			(PDFDataReference reference: self firstPage).
			(PDFDataSymbol symbol: 'Fit')
		}));"
				
		 (self displayLayout ~= #defaultDisplayLayout) ifTrue: [ 
			content add: (PDFDataCouple key: (PDFDataSymbol symbol: 'PageLayout') value: (self generateDisplayLayout)).
		].
			
	^ rootObject addContent: content.
	! !

!PDFGenerator methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/1/2013 11:22'!
currentPage
	^ currentPage! !

!PDFGenerator methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 3/1/2013 11:22'!
currentPage: anObject
	currentPage := anObject! !

!PDFGenerator methodsFor: 'conversion' stamp: 'GuillaumeLarcheveque 3/15/2013 14:49'!
determinePositionOnCurrentPage: aPosition 
	^ (self convertToPoints: (aPosition x)) @ (self convertToPoints: (self currentPage format size y - aPosition y) )! !

!PDFGenerator methodsFor: 'accessing' stamp: 'OlivierAuverlot 4/16/2013 11:45'!
displayLayout
	^displayLayout ! !

!PDFGenerator methodsFor: 'accessing' stamp: 'OlivierAuverlot 4/16/2013 11:46'!
displayLayout: aSymbol
	displayLayout :=  aSymbol! !

!PDFGenerator methodsFor: 'accessing' stamp: 'OlivierAuverlot 4/16/2013 11:45'!
displayMode
	^displayMode! !

!PDFGenerator methodsFor: 'accessing' stamp: 'OlivierAuverlot 4/16/2013 11:46'!
displayMode: aSymbol
	displayMode :=  aSymbol! !

!PDFGenerator methodsFor: 'accessing' stamp: 'OlivierAuverlot 4/16/2013 01:17'!
firstPage
	^firstPage! !

!PDFGenerator methodsFor: 'accessing' stamp: 'OlivierAuverlot 4/16/2013 01:17'!
firstPage: anObject
	firstPage := anObject! !

!PDFGenerator methodsFor: 'action' stamp: 'OlivierAuverlot 4/11/2013 15:24'!
generateContentsFor: aPage
	| contents associativeArray stream lengthObject |
	contents := self createNewPDFDataObject.
	associativeArray := PDFDataAssociativeArray new.
	stream := self createPDFDataStreamFrom: aPage.	

	lengthObject := self createNewPDFDataObject.
	lengthObject addContent: (PDFDataStreamRefSize stream: stream).
	
	associativeArray
		add: (PDFDataCouple key: (PDFDataSymbol symbol: 'Length') value: (PDFDataReference reference: lengthObject)).
	
	"compression support ?"	
	(self compression) ifTrue: [ 
		associativeArray
			add: (PDFDataCouple key: (PDFDataSymbol symbol: 'Filter') value: (PDFDataSymbol symbol: 'FlateDecode')).	
		 ].
		
	contents
		addContent: associativeArray;
		addContent: stream.
	^ contents! !

!PDFGenerator methodsFor: 'action' stamp: 'OlivierAuverlot 4/16/2013 13:02'!
generateDisplayLayout
	"Answer the PDF symbol for the selected display layout"
	
	^PDFDataSymbol symbol: ({ #singlePage->'SinglePage' . #continuousPages->'OneColumn' . #twoPages->'TwoColumnLeft' } asDictionary at: self displayLayout).
! !

!PDFGenerator methodsFor: 'action' stamp: 'OlivierAuverlot 4/16/2013 12:43'!
generateDisplayMode
	| value |
	value := PDFDataArray from:  { (PDFDataReference reference: self firstPage) }.
	
	(self displayMode = #fullPage)
		ifTrue: [  value addElement: (PDFDataSymbol symbol: 'Fit') ]
		ifFalse: [ 
			(self displayMode = #fullWidth)
				ifTrue: [  value addElement: (PDFDataSymbol symbol: 'FitH'); addElement: (PDFDataValue value: 'null'); yourself ]
				ifFalse: [ 
					(self displayMode = #real)
						ifTrue: [  
							value addElement: (PDFDataSymbol symbol: 'XYZ'); 
								addElement: (PDFDataValue value: 'null'); 
								addElement: (PDFDataValue value: 'null'); 
								addElement: (PDFDataValue value: 1); 
								yourself.
						]
				]
		 ].
	
	^PDFDataCouple key: (PDFDataSymbol symbol: 'OpenAction') value: value.! !

!PDFGenerator methodsFor: 'font' stamp: 'GuillaumeLarcheveque 3/1/2013 14:37'!
generateFontId
	currentFontId := currentFontId + 1.
	^ 'F' , currentFontId asString! !

!PDFGenerator methodsFor: 'image' stamp: 'GuillaumeLarcheveque 3/21/2013 10:33'!
generateImageId
	currentImageId := currentImageId + 1.
	^ 'I' , currentImageId asString! !

!PDFGenerator methodsFor: 'font' stamp: 'GuillaumeLarcheveque 3/1/2013 14:36'!
generateListOfFonts
	| fonts |
	fonts := PDFDataAssociativeArray new.
	usedFonts
		keysAndValuesDo: [ :aFontName :aFontId | 
			fonts
				add:
					(PDFDataCouple
						key: (PDFDataSymbol symbol: (aFontId asString))
						value: (PDFDataReference reference: (self createFontObject: aFontName))) ].
	^ fonts! !

!PDFGenerator methodsFor: 'image' stamp: 'GuillaumeLarcheveque 3/21/2013 13:26'!
generateListOfImages
	| images |
	images := PDFDataAssociativeArray new.
	usedImages
		keysAndValuesDo: [ :anImageStream :anImageId | 
			images
				add:
					(PDFDataCouple
						key: (PDFDataSymbol symbol: (anImageId asString))
						value: (PDFDataReference reference: (self createImageObject: anImageStream))) ].
	^ images! !

!PDFGenerator methodsFor: 'opacity' stamp: 'OlivierAuverlot 1/18/2014 18:34'!
generateListOfOpacities
	| opacities |
	
	opacities := PDFDataAssociativeArray new.
	
	usedOpacities
		keysAndValuesDo: [ :aOpacityObject :aOpacityId | 
			opacities
				add:
					(PDFDataCouple
						key: (PDFDataSymbol symbol: (aOpacityId asString))
						value: (PDFDataReference reference: (self createOpacityObject: aOpacityObject))) ].
	^ opacities! !

!PDFGenerator methodsFor: 'opacity' stamp: 'OlivierAuverlot 1/18/2014 18:37'!
generateOpacityId
	currentOpacityId := currentOpacityId + 1.
	^ 'GS' , currentOpacityId asString! !

!PDFGenerator methodsFor: 'action' stamp: 'OlivierAuverlot 5/11/2014 16:49'!
generatePDFCompleteModelFrom: aPDFDocument
	
	self compression: aPDFDocument compression.
	self displayLayout: aPDFDocument displayLayout.
	self displayMode: aPDFDocument displayMode.
	self zoom: aPDFDocument zoom.
	
	document := self generatePDFDocument: aPDFDocument.
	
	^ PDFDataTrailer new
		addContent:
				(PDFDataAssociativeArray new
						add:
								(PDFDataCouple key: (PDFDataSymbol symbol: 'Root') value: (PDFDataReference reference: self createRootObject));
						add:
								(PDFDataCouple
										key: (PDFDataSymbol symbol: 'Info')
										value: (PDFDataReference reference: (self createMetaDataObject: aPDFDocument metaData)));
						add: (PDFDataCouple key: (PDFDataSymbol symbol: 'Size') value: (PDFDataValue value: currentObjectNumber + 1)));
		addContent: (PDFDataStartXref to: xref)! !

!PDFGenerator methodsFor: 'action' stamp: 'OlivierAuverlot 1/17/2014 14:59'!
generatePDFDocument: aPDFDocument
	"should receive a PDFDocument and return a PDFDataObject representing the document"
	
	| associativeArray references resources |
	
	document := self createNewPDFDataObject.
	associativeArray := PDFDataAssociativeArray new.
	associativeArray add: (PDFDataCouple key: (PDFDataSymbol symbol: 'Type') value: (PDFDataSymbol symbol: 'Pages')).
	"Generate Pages"
	references := aPDFDocument pages collect: [ :aPage | PDFDataReference reference: (self generatePDFPage: aPage) ].
	associativeArray add: (PDFDataCouple key: (PDFDataSymbol symbol: 'Kids') value: (PDFDataArray from: references)).
	associativeArray add: (PDFDataCouple key: (PDFDataSymbol symbol: 'Count') value: (PDFDataValue value: references size)).
	associativeArray add: (self generatePDFFormat: aPDFDocument format).
	resources := PDFDataAssociativeArray new.
	resources
		add:
				(PDFDataCouple
						key: (PDFDataSymbol symbol: 'ProcSet')
						value:
							(PDFDataArray
								from:
									{(PDFDataSymbol symbol: 'PDF').
									(PDFDataSymbol symbol: 'Text').
									(PDFDataSymbol symbol: 'ImageC')}));
		add: (PDFDataCouple key: (PDFDataSymbol symbol: 'Font') value: self generateListOfFonts);
		add: (PDFDataCouple key: (PDFDataSymbol symbol: 'XObject') value: self generateListOfImages);
		add: (PDFDataCouple key: (PDFDataSymbol symbol: 'ExtGState') value: self generateListOfOpacities).
	associativeArray add: (PDFDataCouple key: (PDFDataSymbol symbol: 'Resources') value: resources).
	document addContent: associativeArray.
	
	^ document! !

!PDFGenerator methodsFor: 'section' stamp: 'GuillaumeLarcheveque 3/1/2013 14:02'!
generatePDFFormat: aPDFFormat
	^ PDFDataCouple new
		key: (PDFDataSymbol symbol: 'MediaBox');
		value:
				(PDFDataArray
						from:
							{(PDFDataValue value: 0).
							(PDFDataValue value: 0).
							(PDFDataValue value: (aPDFFormat width convertTo: Unit points) value).
							(PDFDataValue value: (aPDFFormat height convertTo: Unit points) value)})! !

!PDFGenerator methodsFor: 'action' stamp: 'OlivierAuverlot 1/17/2014 10:58'!
generatePDFPage: aPDFPage
	| page associativeArray |
	currentPage := aPDFPage.
	page := self createNewPDFDataObject.
	(self firstPage = nil) ifTrue: [ self firstPage: page ].

	associativeArray := PDFDataAssociativeArray
		new
		add: (PDFDataCouple key: (PDFDataSymbol symbol: 'Type') value: (PDFDataSymbol symbol: 'Page'));
		add: (PDFDataCouple key: (PDFDataSymbol symbol: 'Parent') value: (PDFDataReference reference: document));
		add: (PDFDataCouple key: (PDFDataSymbol symbol: 'Group') value: (PDFDataAssociativeArray new 
			add: (PDFDataSymbol symbol: 'Type');
			add: (PDFDataSymbol symbol: 'Group');
			add: (PDFDataSymbol symbol: 'S');
			add: (PDFDataSymbol symbol: 'Transparency');
			add: (PDFDataSymbol symbol: 'CS');
			add: (PDFDataSymbol symbol: 'DeviceRGB')
		));
		add: (self generatePDFFormat: (aPDFPage format ifNil: [ aPDFPage document format ]));
		add:
				(PDFDataCouple
						key: (PDFDataSymbol symbol: 'Contents')
						value: (PDFDataReference reference: (self generateContentsFor: aPDFPage)));
		yourself.
	page addContent: associativeArray.
	^ page
	

! !

!PDFGenerator methodsFor: 'section' stamp: 'OlivierAuverlot 2/1/2013 10:08'!
generatePDFVersion: aPDFVersion
	^ PDFDataComment new comment: ('PDF-' , aPDFVersion).
		! !

!PDFGenerator methodsFor: 'action' stamp: 'OlivierAuverlot 4/16/2013 12:50'!
generateZoom
	"answer the PDF code to set the user's zoom"
	^PDFDataCouple key: (PDFDataSymbol symbol: 'OpenAction') value: (PDFDataArray from:  { 
		(PDFDataReference reference: self firstPage).
		(PDFDataSymbol symbol: 'XYZ').
		(PDFDataValue value: 'null').
		(PDFDataValue value: 'null').
		(PDFDataValue value: ((self zoom / 100) asFloat))
	 })! !

!PDFGenerator methodsFor: 'font' stamp: 'GuillaumeLarcheveque 3/1/2013 17:51'!
getFontIdFor: aPDFFont
	^ usedFonts at: aPDFFont fontName ifAbsentPut: [ self generateFontId ]! !

!PDFGenerator methodsFor: 'image' stamp: 'GuillaumeLarcheveque 3/21/2013 13:26'!
getImageIdFor: aPDFImage
	^ usedImages at: (aPDFImage stream) ifAbsentPut: [ self generateImageId ]! !

!PDFGenerator methodsFor: 'opacity' stamp: 'OlivierAuverlot 1/18/2014 18:42'!
getOpacityIdFor: aOpacityObject

	^ usedOpacities at: aOpacityObject ifAbsentPut: [ self generateOpacityId ]
	! !

!PDFGenerator methodsFor: 'initialize-release' stamp: 'OlivierAuverlot 1/17/2014 15:12'!
initialize
	firstPage := nil.
	currentObjectNumber := 0.
	currentFontId := 0.
	currentImageId := 0.
	currentOpacityId := 0.
	usedFonts := Dictionary new.
	usedImages := Dictionary new.
	usedOpacities := Dictionary new.
	xref := PDFDataXRef new! !

!PDFGenerator methodsFor: 'as yet unclassified' stamp: 'GuillaumeLarcheveque 8/2/2013 15:48'!
splitPages: aCollectionOfPages
	^ self
		inject: OrderedCollection new
		into: [ :result :aPage | 
			aPage extensible
				ifTrue: [ result addAll: (self splitPage: aPage) ]
				ifFalse: [ result add: aPage ] ]! !

!PDFGenerator methodsFor: 'accessing' stamp: 'OlivierAuverlot 4/16/2013 12:15'!
zoom
	^zoom! !

!PDFGenerator methodsFor: 'accessing' stamp: 'OlivierAuverlot 4/16/2013 12:15'!
zoom: anInteger
	zoom := anInteger! !

Object subclass: #PDFMetaData
	instanceVariableNames: 'title subject author keywords creator producer time date'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Base'!

!PDFMetaData commentStamp: '<historical>' prior: 0!
A PDFMetaData is a description of the document (author, title...).

You can read it with a pdf viewer.

By default, a PDFDocument have one that you can access with #metadata method.

Instance Variables
	author:		<Object>
	creator:		<Object>
	keywords:		<Object>
	producer:		<Object>
	subject:		<Object>
	title:		<Object>

author
	- xxxxx

creator
	- xxxxx

keywords
	- xxxxx

producer
	- xxxxx

subject
	- xxxxx

title
	- xxxxx
!

!PDFMetaData methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/7/2012 14:22'!
author
	^ author! !

!PDFMetaData methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/7/2012 14:22'!
author: anObject
	author := anObject! !

!PDFMetaData methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/7/2012 14:22'!
creator
	^ creator! !

!PDFMetaData methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/7/2012 14:22'!
creator: anObject
	creator := anObject! !

!PDFMetaData methodsFor: 'accessing' stamp: 'AntoanHristov 3/10/2017 15:11'!
date
	^ date! !

!PDFMetaData methodsFor: 'accessing' stamp: 'AntoanHristov 3/10/2017 15:11'!
date: aDateObj

	date := aDateObj! !

!PDFMetaData methodsFor: 'initialize-release' stamp: 'AntoanHristov 3/13/2017 14:16'!
initialize
	self author: ''.
	self creator: ''.
	self keywords: ''.
	self producer: 'Artefact'.
	self subject: ''.
	self title: ''.
	self date: Date today.
	self time: Time now.! !

!PDFMetaData methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/7/2012 14:22'!
keywords
	^ keywords! !

!PDFMetaData methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/7/2012 14:22'!
keywords: anObject
	keywords := anObject! !

!PDFMetaData methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/7/2012 14:22'!
producer
	^ producer! !

!PDFMetaData methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/7/2012 14:22'!
producer: anObject
	producer := anObject! !

!PDFMetaData methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/7/2012 14:22'!
subject
	^ subject! !

!PDFMetaData methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/7/2012 14:22'!
subject: anObject
	subject := anObject! !

!PDFMetaData methodsFor: 'accessing' stamp: 'AntoanHristov 3/10/2017 15:10'!
time
	^ time! !

!PDFMetaData methodsFor: 'accessing' stamp: 'AntoanHristov 3/10/2017 15:10'!
time: aTimeObj
	
	time := aTimeObj! !

!PDFMetaData methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/7/2012 14:22'!
title
	^ title! !

!PDFMetaData methodsFor: 'accessing' stamp: 'guillaumelarcheveque 12/7/2012 14:22'!
title: anObject
	title := anObject! !

Object subclass: #PDFOpacity
	instanceVariableNames: 'alpha'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Opacity'!

!PDFOpacity commentStamp: '<historical>' prior: 0!
A PDFOpacity is thethe abstract class that inherits all usable opacity effects. 
!

!PDFOpacity class methodsFor: 'as yet unclassified' stamp: 'OlivierAuverlot 1/17/2014 12:48'!
alpha: aAlphaValue 
	"set the alpha value for opacity (between 0 and 1)"
	
	^self new alpha: aAlphaValue! !

!PDFOpacity methodsFor: 'accessing' stamp: 'OlivierAuverlot 1/17/2014 10:10'!
alpha
	^ alpha! !

!PDFOpacity methodsFor: 'accessing' stamp: 'OlivierAuverlot 1/17/2014 10:10'!
alpha: anObject
	alpha := anObject! !

!PDFOpacity methodsFor: 'effect' stamp: 'OlivierAuverlot 1/17/2014 10:05'!
blendMode
	"must answer the blendMode"
	self subclassResponsibility ! !

PDFOpacity subclass: #PDFOpacityColor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Opacity'!

!PDFOpacityColor commentStamp: '<historical>' prior: 0!
Opacity control and Color effect.
!

!PDFOpacityColor methodsFor: 'as yet unclassified' stamp: 'OlivierAuverlot 1/17/2014 12:49'!
blendMode
	 ^#Color! !

PDFOpacity subclass: #PDFOpacityColorBurn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Opacity'!

!PDFOpacityColorBurn commentStamp: '<historical>' prior: 0!
Opacity control and ColorBurn effect.!

!PDFOpacityColorBurn methodsFor: 'as yet unclassified' stamp: 'OlivierAuverlot 1/17/2014 12:49'!
blendMode
	 ^#ColorBurn! !

PDFOpacity subclass: #PDFOpacityColorDodge
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Opacity'!

!PDFOpacityColorDodge commentStamp: '<historical>' prior: 0!
Opacity control and ColorDodge effect.
!

!PDFOpacityColorDodge methodsFor: 'as yet unclassified' stamp: 'OlivierAuverlot 1/17/2014 12:50'!
blendMode
	 ^#ColorDodge! !

PDFOpacity subclass: #PDFOpacityDarken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Opacity'!

!PDFOpacityDarken commentStamp: '<historical>' prior: 0!
Opacity control and Darken effect.!

!PDFOpacityDarken methodsFor: 'as yet unclassified' stamp: 'OlivierAuverlot 1/17/2014 12:50'!
blendMode
	 ^#Darken! !

PDFOpacity subclass: #PDFOpacityDifference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Opacity'!

!PDFOpacityDifference commentStamp: '<historical>' prior: 0!
Opacity control and Difference effect.
!

!PDFOpacityDifference methodsFor: 'as yet unclassified' stamp: 'OlivierAuverlot 1/17/2014 12:50'!
blendMode
	 ^#Difference! !

PDFOpacity subclass: #PDFOpacityExclusion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Opacity'!

!PDFOpacityExclusion commentStamp: '<historical>' prior: 0!
Opacity control and Exclusion effect.!

!PDFOpacityExclusion methodsFor: 'as yet unclassified' stamp: 'OlivierAuverlot 1/17/2014 12:51'!
blendMode
	 ^#Exclusion! !

PDFOpacity subclass: #PDFOpacityHardLight
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Opacity'!

!PDFOpacityHardLight commentStamp: '<historical>' prior: 0!
Opacity control and HardLight effect.!

!PDFOpacityHardLight methodsFor: 'as yet unclassified' stamp: 'OlivierAuverlot 1/17/2014 12:51'!
blendMode
	 ^#HardLight! !

PDFOpacity subclass: #PDFOpacityHue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Opacity'!

!PDFOpacityHue commentStamp: '<historical>' prior: 0!
Opacity control and Hue effect.
!

!PDFOpacityHue methodsFor: 'as yet unclassified' stamp: 'OlivierAuverlot 1/17/2014 12:51'!
blendMode
	 ^#Hue! !

PDFOpacity subclass: #PDFOpacityLighten
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Opacity'!

!PDFOpacityLighten commentStamp: '<historical>' prior: 0!
Opacity control and Lighten effect.
!

!PDFOpacityLighten methodsFor: 'as yet unclassified' stamp: 'OlivierAuverlot 1/17/2014 12:51'!
blendMode
	 ^#Lighten! !

PDFOpacity subclass: #PDFOpacityLuminosity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Opacity'!

!PDFOpacityLuminosity commentStamp: '<historical>' prior: 0!
Opacity control and Luminosity effect.!

!PDFOpacityLuminosity methodsFor: 'as yet unclassified' stamp: 'OlivierAuverlot 1/17/2014 12:52'!
blendMode
	 ^#Luminosity! !

PDFOpacity subclass: #PDFOpacityMultiply
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Opacity'!

!PDFOpacityMultiply commentStamp: '<historical>' prior: 0!
Opacity control and Multiply effect.!

!PDFOpacityMultiply methodsFor: 'as yet unclassified' stamp: 'OlivierAuverlot 1/17/2014 12:52'!
blendMode
	 ^#Multiply! !

PDFOpacity subclass: #PDFOpacityNormal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Opacity'!

!PDFOpacityNormal commentStamp: '<historical>' prior: 0!
Opacity control and no effect.!

!PDFOpacityNormal methodsFor: 'as yet unclassified' stamp: 'OlivierAuverlot 1/17/2014 12:52'!
blendMode
	 ^#Normal! !

PDFOpacity subclass: #PDFOpacityOverlay
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Opacity'!

!PDFOpacityOverlay commentStamp: '<historical>' prior: 0!
Opacity control and Overlay effect.
!

!PDFOpacityOverlay methodsFor: 'as yet unclassified' stamp: 'OlivierAuverlot 1/17/2014 12:52'!
blendMode
	 ^#Overlay! !

PDFOpacity subclass: #PDFOpacitySaturation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Opacity'!

!PDFOpacitySaturation commentStamp: '<historical>' prior: 0!
Opacity control and Saturation effect.!

!PDFOpacitySaturation methodsFor: 'as yet unclassified' stamp: 'OlivierAuverlot 1/17/2014 12:52'!
blendMode
	 ^#Saturation! !

PDFOpacity subclass: #PDFOpacityScreen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Opacity'!

!PDFOpacityScreen commentStamp: '<historical>' prior: 0!
Opacity control and Screen effect.!

!PDFOpacityScreen methodsFor: 'as yet unclassified' stamp: 'OlivierAuverlot 1/17/2014 12:52'!
blendMode
	 ^#Screen! !

PDFOpacity subclass: #PDFOpacitySoftLight
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Opacity'!

!PDFOpacitySoftLight commentStamp: '<historical>' prior: 0!
Opacity control and SoftLight effect.
!

!PDFOpacitySoftLight methodsFor: 'as yet unclassified' stamp: 'OlivierAuverlot 1/17/2014 12:52'!
blendMode
	 ^#SoftLight! !

Object subclass: #PDFPage
	instanceVariableNames: 'document format elements margins styleSheet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Base'!

!PDFPage commentStamp: '<historical>' prior: 0!
A PDFPage is a page of a PDFDocument. A page is composed by a collection of PDFElements.

Instance Variables
	document:		<Object>
	elements:		<Object>
	format:		<Object>
	margins:		<Object>

document
	- xxxxx

elements
	- xxxxx

format
	- xxxxx

margins
	- xxxxx
!

!PDFPage class methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 8/2/2013 11:31'!
elements: aCollectionOfElements
	^ self new
		elements: aCollectionOfElements;
		yourself! !

!PDFPage methodsFor: 'action' stamp: 'GuillaumeLarcheveque 2/22/2013 13:13'!
add: anElement
	"Use this to add a new element to this page"
	self elements add: anElement.! !

!PDFPage methodsFor: 'as yet unclassified' stamp: 'GuillaumeLarcheveque 5/13/2015 15:46'!
defaultFormat
	^PDFA4Format new! !

!PDFPage methodsFor: 'accessing' stamp: 'OlivierAuverlot 3/14/2012 07:59'!
document
	"answer the document which the page is attached"
	^ document! !

!PDFPage methodsFor: 'accessing' stamp: 'OlivierAuverlot 3/14/2012 07:59'!
document: aPDFDocument
	document :=  aPDFDocument! !

!PDFPage methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 2/22/2013 13:11'!
elements
	^ elements! !

!PDFPage methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 2/22/2013 13:12'!
elements: aCollectionOfPDFElements
	elements :=  aCollectionOfPDFElements! !

!PDFPage methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/13/2015 15:45'!
format
	^ format ifNil: [ format := self document ifNil: [ self defaultFormat ] ifNotNil: [self document format copy] ]! !

!PDFPage methodsFor: 'accessing' stamp: 'OlivierAuverlot 3/14/2012 15:17'!
format: aPDFFormat
	format :=  aPDFFormat! !

!PDFPage methodsFor: 'initialize-release' stamp: 'GuillaumeLarcheveque 2/22/2013 13:11'!
initialize
	super initialize.
	elements := OrderedCollection new! !

!PDFPage methodsFor: 'accessing' stamp: 'OlivierAuverlot 3/14/2012 15:04'!
margins
	^ margins! !

!PDFPage methodsFor: 'accessing' stamp: 'OlivierAuverlot 3/14/2012 15:04'!
margins: theMargins
	margins := theMargins! !

!PDFPage methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/12/2015 18:58'!
styleSheet
	^ styleSheet ifNil: [self document styleSheet ]! !

!PDFPage methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 5/12/2015 18:58'!
styleSheet: anObject
	styleSheet := anObject! !

PDFPage subclass: #PDFTemplate
	instanceVariableNames: 'dotted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Base'!

!PDFTemplate commentStamp: '<historical>' prior: 0!
A PDFTemplate is a kind of page containing pre-defined elements.

Instance Variables
	dotted:		<Object>

dotted
	- xxxxx
!

!PDFTemplate class methodsFor: 'as yet unclassified' stamp: 'OlivierAuverlot 4/25/2013 14:01'!
recommendedDocumentFormat
	self subclassResponsibility ! !

!PDFTemplate methodsFor: 'accessing' stamp: 'OlivierAuverlot 4/23/2013 15:34'!
dotted
	^dotted! !

!PDFTemplate methodsFor: 'accessing' stamp: 'OlivierAuverlot 4/23/2013 15:35'!
dotted: aPDFDotted
	dotted :=  aPDFDotted! !

!PDFTemplate methodsFor: 'action' stamp: 'OlivierAuverlot 4/22/2013 22:12'!
drawTemplate
	self subclassResponsibility ! !

!PDFTemplate methodsFor: 'initialize-release' stamp: 'OlivierAuverlot 4/23/2013 15:41'!
initialize
	super initialize.

	self dotted: (PDFDotted new length: 1 mm; space: 1 mm).
	self drawTemplate.	
! !

Object subclass: #PDFStreamPrinter
	instanceVariableNames: 'stream positions size streamContent compression'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Core-Generator'!

!PDFStreamPrinter commentStamp: '<historical>' prior: 0!
A PDFStreamPrinter takes many PDFDataType and produce a correct PDF file.

Instance Variables
!

!PDFStreamPrinter methodsFor: 'compression' stamp: 'OlivierAuverlot 4/15/2013 23:14'!
compressWithGZip: aString
	"format GZip data for use with PDF"
	|  data tA tB |
	
	data := self getGZipData: aString.
	
	tA := 1.
	tB := 0.

	aString do: [  :byte |
		tA := tA + (byte asInteger).
		(tA > 65521) ifTrue: [ tA := tA - 65521  ].
		tB := tB + tA.
		(tB > 65521) ifTrue: [ tB := tB - 65521  ].
	].
	
	data at: 1 put: (120 asCharacter).
	data at: 2 put: (156 asCharacter).

	data := data copyReplaceFrom: 3 to: 10 with: ''.
	
	data at: ((data size) - 7) put: (((tB bitAnd: 65280) / 256) asCharacter).
	data at: ((data size) - 6) put: ((tB bitAnd: 255) asCharacter).
	data at: ((data size) - 5) put: (((tA bitAnd: 65280) / 256) asCharacter).
	data at: ((data size) - 4) put: ((tA bitAnd: 255) asCharacter).
		
	^data copyReplaceFrom: (data size - 3) to: (data size) with: ''.! !

!PDFStreamPrinter methodsFor: 'accessing' stamp: 'OlivierAuverlot 4/3/2013 12:17'!
compression
	^compression! !

!PDFStreamPrinter methodsFor: 'accessing' stamp: 'OlivierAuverlot 4/3/2013 12:17'!
compression: aBoolean
	compression := aBoolean! !

!PDFStreamPrinter methodsFor: 'conversion' stamp: 'GuillaumeLarcheveque 3/1/2013 17:06'!
convertToPoints: aUnitValue 
	^ (aUnitValue convertTo: #points) value
	! !

!PDFStreamPrinter methodsFor: 'util' stamp: 'OlivierAuverlot 5/19/2014 16:04'!
generateRotationCodeFor: anElementCodeSegment styleSheet: styleSheet
	"insert rotation configuration"

	| angle cx cy |

	angle := (styleSheet get: #rotation) * (Float pi / 180).
	
	cx := (self convertToPoints: anElementCodeSegment fromElement from x) round: 4.
	cy := (self convertToPoints: anElementCodeSegment format height - (self convertToPoints: anElementCodeSegment fromElement from y)) round: 4.


	^ String
		streamContents: [ :code | 
			code
				nextPutAll: 'q';
				space;
				nextPutAll: (angle cos round: 4) asString;
				space;
				nextPutAll: (angle sin round: 4) asString;
				space;
				nextPutAll: (angle sin round: 4) negated asString;
				space;
				nextPutAll: (angle cos round: 4) asString;
				space;
				nextPutAll: cx asString;
				space;
				"il faut récupérer la hauteur de la page pour calculer la pos y ci dessous (h - y)"
				nextPutAll: cy asString;
				space;
				nextPutAll: 'cm 1 0 0 1';
				space;
				nextPutAll: (cx negated) asString;
				space;
				nextPutAll: (cy  negated) asString;
				space;
				nextPutAll: 'cm';
				nextPutAll: String lf ]! !

!PDFStreamPrinter methodsFor: 'util' stamp: 'OlivierAuverlot 5/14/2014 22:19'!
generateStyleCodeForElement: anElementCodeSegment
	| dotted thickness styleSheet |
	styleSheet := anElementCodeSegment styleSheet.
	^ String
		streamContents: [ :code | 
			((styleSheet get: #rotation) ~= 0) ifTrue: [ 
				code nextPutAll: (self generateRotationCodeFor: anElementCodeSegment styleSheet: styleSheet)
			].
			thickness := styleSheet get: #thickness.
			code nextPutAll: (self convertToPoints: thickness) asString , ' ' , PDFByteCode thickness , String lf.	
			"Set line cap style to square"
			code nextPutAll: (self setLineCapStyleFor: anElementCodeSegment stylesheet: styleSheet).
			"Set the colors or grey levels"
			code
				nextPutAll: (self initColors: styleSheet useDrawColor: anElementCodeSegment isDrawElement);
				nextPutAll: String lf.	"Set the dotted propertie"
			dotted := styleSheet get: #dotted.
			dotted
				ifNil: [ 
					code
						nextPutAll: '[] 0 ' , PDFByteCode dotted;
						nextPutAll: String lf ]
				ifNotNil: [ 
					code
						nextPutAll: (dotted generateCodeWith: self);
						nextPutAll: String lf ].	"Insert the font size in the PDF document"
			code
				nextPutAll: 'BT /' , anElementCodeSegment fontId , ' ' , styleSheet font fontSizeAsPoints asString , ' Tf ET';
				nextPutAll: String lf.
			code nextPutAll: '/' , anElementCodeSegment opacityId , ' ' , PDFByteCode setOpacity , String lf.
		]! !

!PDFStreamPrinter methodsFor: 'compression' stamp: 'OlivierAuverlot 4/12/2013 14:43'!
getGZipData: aString 
	| writer |
	writer := GZipWriteStream on: String new.
	writer nextPutAll: aString.
	writer close.
 	^writer encodedStream contents

! !

!PDFStreamPrinter methodsFor: 'util' stamp: 'OlivierAuverlot 3/29/2013 15:30'!
initColors: aStyleSheet useDrawColor: useDrawColor
	| drawColor fillColor textColor |
	
	drawColor := aStyleSheet get: #drawColor.
	fillColor := aStyleSheet get: #fillColor.
	textColor := aStyleSheet get: #textColor.
	
	^ String streamContents: [ :code |
		useDrawColor ifTrue: [
			(fillColor greyLevel isNil)
			ifTrue: [ (fillColor red isNil) ifFalse: [ code nextPutAll: ((PDFColor formatRGB: fillColor) , ' ' , PDFByteCode fillWithColor) ] ]
			ifFalse: [ code nextPutAll: (PDFColor round: (fillColor greyLevel)) , ' ' , PDFByteCode fillWithGreyLevel ].
		]
		ifFalse: [
			(textColor greyLevel isNil)
				ifTrue: [ (textColor red isNil) ifFalse: [ code nextPutAll: ((PDFColor formatRGB: textColor) , ' rg') ] ]
				ifFalse: [ code nextPutAll: (PDFColor round: (textColor greyLevel)) , ' g' ].
		].
		code nextPutAll: String lf.
		(drawColor greyLevel isNil) 
				ifTrue: [ (drawColor red isNil) ifFalse: [ code nextPutAll: ((PDFColor formatRGB: drawColor) , ' ' , PDFByteCode drawWithColor) ] ]
				ifFalse: [ code nextPutAll: (PDFColor round: (drawColor greyLevel)) , ' ' , PDFByteCode drawWithGreyLevel ].
		code nextPutAll: String lf.		
	]! !

!PDFStreamPrinter methodsFor: 'initialize-release' stamp: 'guillaumelarcheveque 2/15/2013 16:01'!
initialize 
	positions := Dictionary new.
	size := Dictionary new.! !

!PDFStreamPrinter methodsFor: 'accessing' stamp: 'guillaumelarcheveque 2/15/2013 16:01'!
positions
	^ positions! !

!PDFStreamPrinter methodsFor: 'print' stamp: 'GuillaumeLarcheveque 3/1/2013 14:49'!
printCompositeCodeSegment: aCompositeCodeSegment
	aCompositeCodeSegment segments do: [ :aSegment | aSegment printWith: self ]! !

!PDFStreamPrinter methodsFor: 'print' stamp: 'OlivierAuverlot 5/19/2014 11:00'!
printElementCodeSegment: anElementCodeSegment

	self streamContent nextPutAll: (self generateStyleCodeForElement: anElementCodeSegment).
	self streamContent nextPutAll: anElementCodeSegment code.
	self resetRotation: (anElementCodeSegment styleSheet get: #rotation) into: self streamContent.
	self streamContent nextPut: Character lf.

! !

!PDFStreamPrinter methodsFor: 'print' stamp: 'OlivierAuverlot 1/17/2014 10:34'!
printModel: aPDFCompleteModel compression: mustBeCompressed on: aStream 
	self compression: mustBeCompressed.
	stream := aStream.
	stream nextPutAll: '%PDF-1.4'; lf.
	aPDFCompleteModel acceptVisitor: self.
	stream nextPutAll: '%%EOF'; lf.
	! !

!PDFStreamPrinter methodsFor: 'print' stamp: 'OlivierAuverlot 3/29/2013 15:10'!
printPDFDataAssociativeArray: aPDFDataAssociativeArray
	stream
		nextPutAll: '<<';
		crlf.
	aPDFDataAssociativeArray associativeArray
		do: [ :aCouple | 
			aCouple isPrintable
				ifTrue: [ aCouple printOn: stream ]
				ifFalse: [ aCouple printWith: self ].
			stream lf ].
	stream nextPutAll: '>>'! !

!PDFStreamPrinter methodsFor: 'print' stamp: 'GuillaumeLarcheveque 3/21/2013 15:23'!
printPDFDataCouple: aPDFDataCouple
	aPDFDataCouple key isPrintable
		ifTrue: [ aPDFDataCouple key printOn: stream ]
		ifFalse: [ aPDFDataCouple key printWith: self ].
	stream space.
	aPDFDataCouple value isPrintable
		ifTrue: [ aPDFDataCouple value printOn: stream ]
		ifFalse: [ aPDFDataCouple value printWith: self ]! !

!PDFStreamPrinter methodsFor: 'print' stamp: 'OlivierAuverlot 3/29/2013 15:11'!
printPDFDataStartXref: aPDFDataStartXref
	stream
		nextPutAll: 'startxref';
		lf;
		nextPutAll: (self positions at: aPDFDataStartXref xref) asString;
		lf! !

!PDFStreamPrinter methodsFor: 'print' stamp: 'OlivierAuverlot 5/4/2014 12:09'!
printPDFDataStream: aPDFDataStream
	| endPosition startPosition streamData |
	
	stream
		nextPutAll: 'stream';
		lf.
	startPosition := stream position.
	
	self streamContent: (WriteStream on:  String new).
	aPDFDataStream codeSegment printWith: self.
	streamData := self streamContent contents.
	(self compression) ifTrue: [ streamData := (self compressWithGZip: streamData) asByteArray  ].

	stream
		nextPutAll: streamData; lf.

	endPosition := stream position.
	self size at: aPDFDataStream put: endPosition - startPosition.
	stream nextPutAll: 'endstream'! !

!PDFStreamPrinter methodsFor: 'print' stamp: 'GuillaumeLarcheveque 3/21/2013 15:24'!
printPDFDataStreamRefSize: aPDFDataStreamRefSize
	stream
		nextPutAll: (self size at: aPDFDataStreamRefSize pdfDataStream) asString! !

!PDFStreamPrinter methodsFor: 'visit' stamp: 'OlivierAuverlot 4/12/2013 15:06'!
printPDFDataXObjectStream: aPDFDataXObjectStream
	| endPosition startPosition |
	stream nextPutAll: 'stream'; lf.
	startPosition := stream position.
	stream nextPutAll: (aPDFDataXObjectStream stream reset contents).
	endPosition := stream position.
	stream lf.
	self size at: aPDFDataXObjectStream put: endPosition - startPosition.
	stream nextPutAll: 'endstream'.! !

!PDFStreamPrinter methodsFor: 'util' stamp: 'OlivierAuverlot 5/19/2014 13:33'!
resetRotation: aRotation into: aStream
	(aRotation = 0) ifFalse: [ 
		aStream
			nextPut: Character lf;
			nextPutAll: PDFByteCode restoreGraphicsState.
	]! !

!PDFStreamPrinter methodsFor: 'util' stamp: 'OlivierAuverlot 4/10/2013 21:26'!
setLineCapStyleFor: anElementCodeSegment stylesheet: styleSheet
	"insert line cap configuration"

	^ String
		streamContents: [ :code | 
			(styleSheet get: #roundCap)
				ifTrue: [ code nextPutAll: PDFByteCode  lineRoundCapStyle ]
				ifFalse: [  code nextPutAll: PDFByteCode  lineSquareCapStyle ].
			code nextPutAll: String lf.
		 ]

! !

!PDFStreamPrinter methodsFor: 'accessing' stamp: 'guillaumelarcheveque 2/15/2013 16:01'!
size
	^ size! !

!PDFStreamPrinter methodsFor: 'accessing' stamp: 'OlivierAuverlot 4/4/2013 09:08'!
streamContent
	^streamContent! !

!PDFStreamPrinter methodsFor: 'accessing' stamp: 'OlivierAuverlot 4/4/2013 09:08'!
streamContent: aString
	streamContent := aString! !

!PDFStreamPrinter methodsFor: 'visit' stamp: 'guillaumelarcheveque 2/15/2013 15:48'!
visitPDFDataArray: aPDFDataArray
	aPDFDataArray elements do: [ :aType | aType acceptVisitor: self ]! !

!PDFStreamPrinter methodsFor: 'visit' stamp: 'guillaumelarcheveque 2/15/2013 15:47'!
visitPDFDataAssociativeArray: aPDFDataAssociativeArray
	aPDFDataAssociativeArray associativeArray do: [ :aType | aType acceptVisitor: self ]! !

!PDFStreamPrinter methodsFor: 'visit' stamp: 'guillaumelarcheveque 2/15/2013 15:47'!
visitPDFDataComment: aPDFDataComment
	! !

!PDFStreamPrinter methodsFor: 'visit' stamp: 'GuillaumeLarcheveque 3/21/2013 15:23'!
visitPDFDataCouple: aPDFDataCouple
	aPDFDataCouple key acceptVisitor: self.
	aPDFDataCouple key symbol = 'Parent'
		ifFalse: [ aPDFDataCouple value acceptVisitor: self ]! !

!PDFStreamPrinter methodsFor: 'visit' stamp: 'guillaumelarcheveque 2/15/2013 15:46'!
visitPDFDataDateAndTime: aPDFDataDateAndTime
	! !

!PDFStreamPrinter methodsFor: 'visit' stamp: 'OlivierAuverlot 3/29/2013 15:20'!
visitPDFDataObject: aPDFDataObject
	self positions at: aPDFDataObject put: stream position.
	stream
		nextPutAll: aPDFDataObject id asString;
		space;
		nextPutAll: aPDFDataObject revision asString;
		space;
		nextPutAll: 'obj';
		lf.
	aPDFDataObject contents
		do: [ :aContent | 
			aContent isPrintable
				ifTrue: [ aContent printOn: stream ]
				ifFalse: [ aContent printWith: self ].
			stream lf ].
	stream
		nextPutAll: 'endobj';
		lf.
	aPDFDataObject contents do: [ :aContent | aContent acceptVisitor: self ]! !

!PDFStreamPrinter methodsFor: 'visit' stamp: 'guillaumelarcheveque 2/15/2013 15:29'!
visitPDFDataReference: aPDFDataReference
	aPDFDataReference referencedObject acceptVisitor: self! !

!PDFStreamPrinter methodsFor: 'visit' stamp: 'guillaumelarcheveque 2/15/2013 15:28'!
visitPDFDataStartXref: aPDFDataStartXref
	aPDFDataStartXref xref acceptVisitor: self! !

!PDFStreamPrinter methodsFor: 'visit' stamp: 'GuillaumeLarcheveque 3/1/2013 15:02'!
visitPDFDataStream: aPDFDataStream
! !

!PDFStreamPrinter methodsFor: 'visit' stamp: 'guillaumelarcheveque 2/15/2013 16:45'!
visitPDFDataStreamRefSize: aPDFDataStreamRefSize
	! !

!PDFStreamPrinter methodsFor: 'visit' stamp: 'guillaumelarcheveque 2/15/2013 15:16'!
visitPDFDataString: aPDFDataString
	! !

!PDFStreamPrinter methodsFor: 'visit' stamp: 'guillaumelarcheveque 2/15/2013 15:16'!
visitPDFDataSymbol: aPDFDataSymbol
	! !

!PDFStreamPrinter methodsFor: 'visit' stamp: 'OlivierAuverlot 3/29/2013 15:18'!
visitPDFDataTrailer: aPDFDataTrailer
	aPDFDataTrailer contents do: [ :aContent | aContent acceptVisitor: self ].
	stream
		nextPutAll: 'trailer';
		lf.
	aPDFDataTrailer contents
		do: [ :aContent | 
			aContent isPrintable
				ifTrue: [ aContent printOn: stream ]
				ifFalse: [ aContent printWith: self ].
			stream lf ]! !

!PDFStreamPrinter methodsFor: 'visit' stamp: 'guillaumelarcheveque 2/15/2013 15:16'!
visitPDFDataValue: aPDFDataValue
	! !

!PDFStreamPrinter methodsFor: 'visit' stamp: 'GuillaumeLarcheveque 3/21/2013 15:29'!
visitPDFDataXObjectStream: aPDFDataXObjectStream
	! !

!PDFStreamPrinter methodsFor: 'visit' stamp: 'OlivierAuverlot 3/29/2013 15:11'!
visitPDFDataXRef: aPDFDataXRef
	self positions at: aPDFDataXRef put: stream position.
	stream
		nextPutAll: 'xref';
		lf.
	stream
		nextPutAll: '0 ';
		nextPutAll: aPDFDataXRef referencies size asString;
		lf.
	aPDFDataXRef referencies do: [ :aReferency | aReferency acceptVisitor: self ]! !

!PDFStreamPrinter methodsFor: 'visit' stamp: 'AutoDeprecationRefactoring 1/30/2017 11:45'!
visitPDFDataXRefEntry: aPDFDataXRefEntry
	| positionString |
	aPDFDataXRefEntry referencedObject
		ifNil: [ stream
				nextPutAll: '0000000000 65535 f ';
				lf ]
		ifNotNil: [ :aPDFDataObject | 
			positionString := (self positions at: aPDFDataObject) asString.
			1 to: 10 - positionString size do: [ :i | stream nextPut: $0 ].
			stream
				nextPutAll: positionString;
				nextPutAll: ' 00000 n ';
				lf ]! !
